Package: yggdrasil
Title: R interface to yggdrasil framework.
Version: 0.1
Author: Meagan Lang
Authors@R: person("Meagan", "Lang", email = "langmm.astro@gmail.com",
                  role = c("aut", "cre"))
Maintainer: Meagan Lang <langmm.astro@gmail.com>
Description: Allows R models to connect to the yggdrasil framework
License: BSD 3-clause
Imports: bit64, reticulate, Rcpp, units, zeallot, R6
Depends: R (>= 3.1.0), zeallot
RoxygenNote: 7.1.1
NeedsCompilation: no
Packaged: 2022-03-21 08:47:23 UTC; VssAdministrator
Built: R 4.1.2; ; 2022-03-21 08:47:24 UTC; windows

Package: yggdrasil
Title: R interface to yggdrasil framework.
Version: 0.1
Authors@R: person("Meagan", "Lang", email = "langmm.astro@gmail.com",
                  role = c("aut", "cre"))
Description: Allows R models to connect to the yggdrasil framework
Depends: R (>= 3.1.0)
License: BSD 3-clause
LazyData: true
Imports:
    reticulate,
    zeallot,
    bit64,
    R6
Depends:
    zeallot

# yggdrasil-brute-simple

Simple program for finding curve25519 and ed25519 public keys whose sha512 hash has many leading ones.
Because ed25519 private keys consist of a seed that is hashed to find the secret part of the keypair,
this program is near optimal for finding ed25519 keypairs. Curve25519 key generation, on the other hand,
could be further optimized with elliptic curve magic.

Depends on libsodium.

library(yggdrasil)

# Input & output to an ASCII file line by line
in_file <- YggInterface('YggAsciiFileInput', 'inputR_file')
out_file <- YggInterface('YggAsciiFileOutput', 'outputR_file')
# Input & output from a table row by row
in_table <- YggInterface('YggAsciiTableInput', 'inputR_table')
out_table <- YggInterface('YggAsciiTableOutput', 'outputR_table',
                          '%5s\t%ld\t%3.1f\t%3.1lf%+3.1lfj\n')
# Input & output from a table as an array
in_array <- YggInterface('YggAsciiArrayInput', 'inputR_array')
out_array <- YggInterface('YggAsciiArrayOutput', 'outputR_array',
                          '%5s\t%ld\t%3.1f\t%3.1lf%+3.1lfj\n')

# Read lines from ASCII text file until end of file is reached.
# As each line is received, it is then sent to the output ASCII file.
print('ascii_io(R): Receiving/sending ASCII file.')
ret = TRUE
while (ret) {
  # Receive a single line
  c(ret, line) %<-% in_file$recv()
  if (ret) {
    # If the receive was succesful, send the line to output
    fprintf('File: %s', line)
    ret <- out_file$send(line)
    if (!ret) {
      stop("ascii_io(R): ERROR SENDING LINE")
    }
  } else {
    # If the receive was not succesful, send the end-of-file message to
    # close the output file.
    print("End of file input (R)")
    out_file$send_eof()
  }
}

# Read rows from ASCII table until end of file is reached.
# As each row is received, it is then sent to the output ASCII table
print('ascii_io(R): Receiving/sending ASCII table.')
ret <- TRUE
while (ret) {
  # Receive a single row
  c(ret, line) %<-% in_table$recv()
  if (ret) {
    # If the receive was succesful, send the values to output.
    # Formatting is taken care of on the output driver side.
    fprintf("Table: %s, %d, %3.1f, %s", line[[1]], line[[2]], line[[3]], line[[4]])
    ret <- out_table$send(line[[1]], line[[2]], line[[3]], line[[4]])
    if (!ret) {
      stop("ascii_io(R): ERROR SENDING ROW")
    }
  } else {
    # If the receive was not succesful, send the end-of-file message to
    # close the output file.
    print("End of table input (R)")
    out_table$send_eof()
  }
}

# Read entire array from ASCII table into numpy array
ret <- TRUE
while (ret) {
  c(ret, arr) %<-% in_array$recv_array()
  if (ret) {
    fprintf("Array: (%d rows)", length(arr))
    # Print each line in the array
    for (i in 1:length(arr)) {
      fprintf("%5s, %d, %3.1f, %s",
              arr[[i]][[1]], arr[[i]][[2]], arr[[i]][[3]], arr[[i]][[4]])
    }
    # Send the array to output. Formatting is handled on the output driver side.
    ret <- out_array$send_array(arr)
    if (!ret) {
      stop("ascii_io(R): ERROR SENDING ARRAY")
    }
  } else {
    print("ascii_io(R): End of array input (R)")
  }
}

# Import library for input/output
library(yggdrasil)

# Initialize input/output channels
in_channel <- YggInterface('YggPlyInput', 'inputB')
out_channel <- YggInterface('YggPlyOutput', 'outputB')

# Loop until there is no longer input or the queues are closed
while(TRUE) {

  # Receive input from input channel
  # If there is an error, the flag will be False
  c(flag, ply) %<-% in_channel$recv()
  if (!flag) {
    print('Model B: No more input.')
    break
  }

  # Print received message
  fprintf('Model B: (%d verts, %d faces)',
          length(ply[['vertices']]), length(ply[['faces']]))

  # Send output to output channel
  # If there is an error, the flag will be False
  flag = out_channel$send(ply)
  if (!flag) {
    stop('Model B: Error sending output.')
  }

}

function model_function(in_buf, out_buf) result(out)
  character(len=*), intent(in) :: in_buf
  character(len=:), pointer :: out_buf
  logical :: out
  character(len=255) :: copy_str
  integer :: copy
  call get_environment_variable("YGG_MODEL_COPY", copy_str)
  read(copy_str,*) copy
  write(*, '("server",I1,"(Fortran): ",A)') copy, in_buf
  out = .true.
  allocate(character(len=len(in_buf)) :: out_buf)
  out_buf = in_buf
end function model_function

program main
  use fygg

  integer(kind=c_size_t) :: msg_size_output = YGG_MSG_BUF
  integer(kind=c_size_t) :: msg_size_input = YGG_MSG_BUF
  character, dimension(YGG_MSG_BUF) :: output
  type(yggchar_r) :: input
  type(yggcomm) :: rpc
  logical :: ret

  print *, "maxMsgCli(F): Hello message size is ", msg_size_output

  ! Create a max message, send/recv and verify
  rpc = ygg_rpc_client("maxMsgSrv_maxMsgCli", "%s", "%s")

  ! Create a max message
  call rand_str(output, msg_size_output)
  print *, "maxMsgCli(F): sending ", output(1:10), "..."

  ! Call RPC server
  msg_size_input = size(input%x)
  ret = ygg_rpc_call_realloc(rpc, &
       [yggarg(output), yggarg(msg_size_output)], &
       [yggarg(input), yggarg(msg_size_input)])
  if (.not.ret) then
     print *, "maxMsgCli(F): RPC ERROR"
     stop 1
  end if
  print *, "maxMsgCli(F): received ", msg_size_input, " bytes: ", &
       input%x(1:10), "..."

  ! Check to see if response matches
  if (.not.all(output.eq.(input%x))) then
     print *, "maxMsgCli(F): ERROR: input/output do not match"
     stop 1
  else
     print *, "maxMsgCli(F): CONFIRM"
  end if

  ! All done, free and say goodbye
  print *, "maxMsgCli(F): Goodbye!"

end program main

subroutine rand_str(x, x_siz)
  use fygg
  character, dimension(*) :: x
  real :: x_rand
  integer(kind=c_size_t) :: x_siz, i, index
  character(len=62) :: charset
  charset = "0123456789&
       &abcdefghijklmnopqrstuvwxyz&
       &ABCDEFGHIJKLMNOPQRSTUVWXYZ"
  do i = 1, x_siz
     call random_number(x_rand)
     index = int(x_rand * (len(charset) - 1), c_size_t) + 1
     x(i) = charset(index:index)
  end do
  ! do i = (x_siz+1), size(x)
  !    x(i) = ' '
  ! end do
end subroutine rand_str

PROGRAM main
  ! Include methods for input/output channels
  USE fygg

  ! Declare resulting variables and create buffer
  ! for received message
  logical :: flag = .true.
  integer, parameter :: MYBUFSIZ = 1000
  integer :: bufsiz
  TYPE(yggcomm) :: in_channel, out_channel
  character(len = 1000) :: buf

  ! Initialize input/output channels
  in_channel = ygg_input("input")
  out_channel = ygg_output("output")

  ! Loop until there is no longer input or the queues are closed
  DO WHILE (flag)

    ! Receive input from input channel
    ! If there is an error or the queue is closed, the flag will be negative
     ! Otherwise, it is the size of the received message
     bufsiz = len(buf)
     flag = ygg_recv(in_channel, buf, bufsiz)
     IF (.not.flag) THEN
        PRINT *, "No more input."
        EXIT
     END IF

     ! Print received message
     PRINT *, buf

     ! Send output to output channel
     ! If there is an error, the flag will be negative
     flag = ygg_send(out_channel, buf, bufsiz)
     IF (.not.flag) THEN
        PRINT *, "Error sending output."
        EXIT
     END IF
     
  END DO

END PROGRAM main

library(yggdrasil)


run <- function() {
  print('Hello from R pipe_dst')

  # Ins/outs matching with the the model yaml
  inq <- YggInterface('YggInput', 'input_pipe')
  outf <- YggInterface('YggOutput', 'output_file')
  print("pipe_dst(R): Created I/O channels")

  # Continue receiving input from the queue
  count <- 0
  while (TRUE) {
    c(ret, buf) %<-% inq$recv()
    if (!ret) {
      print("pipe_dst(R): Input channel closed")
      break
    }
    ret <- outf$send(buf)
    if (!ret) {
      stop(sprintf("pipe_dst(R): SEND ERROR ON MSG %d", count))
    }
    count <- count + 1
  }

  fprintf('Goodbye from R destination. Received %d messages.', count)
}


run()

function light(height, time, intensity) result(out)
  real(kind=8), dimension(:), intent(in) :: height
  real(kind=8), intent(in) :: time
  real(kind=8), dimension(:), allocatable :: intensity
  logical :: out
  integer :: i
  real, parameter :: Pi = 3.1415927
  out = .true.
  if (allocated(intensity)) then
     deallocate(intensity)
  end if
  allocate(intensity(size(height)))
  do i = 1, size(height)
     intensity(i) = 80.0 * (1.0 + SIN(2.0 * Pi * time / 365)) / (ABS(200.0 - height(i))**2)
  end do
end function light

program main
  ! Include methods for input/output channels
  use fygg

  ! Declare resulting variables and create buffer for received message
  logical :: flag = .true.
  type(yggcomm) :: in_channel, out_channel
  type(ygggeneric) :: obj
  character(len=20), dimension(:), pointer :: keys
  type(ygggeneric), pointer :: amaxtb
  real(kind=8), dimension(:), pointer :: amaxtb_x, amaxtb_y
  real(kind=8), pointer :: co2
  integer :: i
  obj = init_generic()

  ! Initialize input/output channels
  in_channel = ygg_generic_input("input")
  out_channel = ygg_generic_output("output")

  ! Loop until there is no longer input or the queues are closed
  do while (flag)

     ! Receive input from input channel
     ! If there is an error, the flag will be false
     ! Otherwise, it is the number of variables filled
     flag = ygg_recv_var(in_channel, yggarg(obj))
     if (.not.flag) then
        write (*, '("Fortran Model: No more input.")')
        exit
     end if

     ! Print received message
     write (*, '("Fortran Model:")')
     call display_generic(obj)

     ! Print keys
     call generic_map_get_keys(obj, keys)
     write (*, '("Fortran Model: keys = ")')
     do i = 1, size(keys)
        write (*, '(A," ")', advance="no") trim(keys(i))
     end do
     write (*, '("")')

     ! Get double precision floating point element
     call generic_map_get(obj, "CO2", co2)
     write (*, '("Fortran Model: CO2 = ",F10.5)') co2

     ! Get array element
     call generic_map_get(obj, "AMAXTB", amaxtb)
     call generic_array_get(amaxtb, 1, amaxtb_x)
     call generic_array_get(amaxtb, 2, amaxtb_y)
     write (*, '("Fortran Model: AMAXTB = ")')
     do i = 1, size(amaxtb_x)
        write (*, '(A,F10.5,A,F10.5)') char(11), amaxtb_x(i), &
             char(11), amaxtb_y(i)
     end do

     ! Send output to output channel
     ! If there is an error, the flag will be false
     flag = ygg_send_var(out_channel, yggarg(obj))
     if (.not.flag) then
        write (*, '("Fortran Model: Error sending output.")')
        exit
     end if

  end do

end program main

library(yggdrasil)


main <- function(iterations, client_index) {

  fprintf('Hello from Python client: iterations = %d ', iterations)

  # Set up connections matching yaml
  # RPC client-side connection will be $(server_name)_$(client_name)
  rpc <- YggInterface('YggRpcClient',
                      sprintf("server_client%d", client_index), "%d", "%d")
  log <- YggInterface('YggOutput',
                      sprintf("output_log%d", client_index), 'fib(%-2d) = %-2d\n')

  # Iterate over Fibonacci sequence
  for (i in 1:iterations) {
        
    # Call the server and receive response
    fprintf('client%d(R): Calling fib(%d)', client_index, i)
    c(ret, result) %<-% rpc$call(i)
    if (!ret) {
      stop(sprintf('client%d(R): RPC CALL ERROR', client_index))
    }
    fib <- result[[1]]
    fprintf('client%d(R): Response fib(%d) = %d', client_index, i, fib)

    # Log result by sending it to the log connection
    ret <- log$send(i, fib)
    if (!ret) {
      stop(sprintf('client%d(R): SEND ERROR', client_index))
    }
  }

  fprintf('Goodbye from R client%d', client_index)
}


args = commandArgs(trailingOnly=TRUE)
main(strtoi(args[[1]]), strtoi(args[[2]]))

!---------------------------------------------------------------------------
!> @brief Compute the intensity of light.
!
!> @param[in] doy: Day of year.
!> @param[in] height: Distance from ground in cm.
!
!> @return intensity: Intensity of light in ergs cm^-2 s^-1.
!---------------------------------------------------------------------------
function light(doy, height) result(intensity)
  real(kind=8) :: doy
  real(kind=8) :: height
  real(kind=8) :: intensity
  real, parameter :: Pi = 3.1415927
  
  ! Define parameters that are static across a run
  real, parameter :: amplitude = 80.0
  real, parameter :: doy_offset = 0.0

  ! Calculate intensity
  intensity = amplitude * height * (1.0 + SIN(2.0 * Pi * (doy - doy_offset) / 365))
end function light

library(yggdrasil)

print('Hello from R')

# Ins/outs matching with the the model yaml
inf <- YggInterface('YggInput', 'inFile')
outf <- YggInterface('YggOutput', 'outFile')
inq <- YggInterface('YggInput', 'helloQueueIn')
outq <- YggInterface('YggOutput', 'helloQueueOut')
print("hello(R): Created I/O channels")

# Receive input from a local file
c(ret, buf) %<-% inf$recv()
if (!ret) {
  stop('hello(R): ERROR FILE RECV')
}
fprintf('hello(R): Received %d bytes from file: %s', length(buf), buf)

# Send output to the output queue
ret <- outq$send(buf)
if (!ret) {
  stop('hello(R): ERROR QUEUE SEND')
}
print('hello(R): Sent to outq')

# Receive input form the input queue
c(ret, buf) %<-% inq$recv()
if (!ret) {
  stop('hello(R): ERROR QUEUE RECV')
}
fprintf('hello(R): Received %d bytes from queue: %s', length(buf), buf)

# Send output to a local file
ret <- outf$send(buf)
if (!ret) {
  stop('hello(R): ERROR FILE SEND')
}
print('hello(R): Sent to outf')

print('Goodbye from R')

library(yggdrasil)


timestep_calc <- function(t, model) {
  state = list()
  if (model == 'A') {
    state[['x']] = sinpi(2.0 * t / units::set_units(10.0, 'day', mode="standard"))
    state[['y']] = cospi(2.0 * t / units::set_units(5.0, 'day', mode="standard"))
    state[['z1']] = -cospi(2.0 * t / units::set_units(20.0, 'day', mode="standard"))
    state[['z2']] = -cospi(2.0 * t / units::set_units(20.0, 'day', mode="standard"))
    state[['a']] = sinpi(2.0 * t / units::set_units(2.5, 'day', model="standard"))
  } else {
    state[['xvar']] = sinpi(2.0 * t / units::set_units(10.0, 'day', mode="standard")) / 2.0
    state[['yvar']] = cospi(2.0 * t / units::set_units(5.0, 'day', mode="standard"))
    state[['z']] = -2.0 * cospi(2.0 * t / units::set_units(20.0, 'day', mode="standard"))
    state[['b']] = cospi(2.0 * t / units::set_units(2.5, 'day', model="standard"))
  }
  return(state)
}

main <- function(t_step, t_units, model) {

  fprintf('Hello from R timesync: timestep = %f %s', t_step, t_units)
  t_step <- units::set_units(t_step, t_units, mode="standard")
  t_start <- units::set_units(0.0, t_units, mode="standard")
  t_end <- units::set_units(5.0, 'day', mode="standard")
  state <- timestep_calc(t_start, model)

  # Set up connections matching yaml
  # Timestep synchronization connection will be 'statesync'
  timesync <- YggInterface('YggTimesync', 'statesync')
  out <- YggInterface('YggOutput', 'output')

  # Initialize state and synchronize with other models
  t <- t_start
  c(ret, result) %<-% timesync$call(t, state)
  if (!ret) {
    stop('timesync(R): Initial sync failed.')
  }
  state <- result[[1]]
  fprintf('timesync(R): t = %5.1f %-1s',
          units::drop_units(t), units::deparse_unit(t))
  for (key in names(state)) {
    fprintf(', %s = %+ 5.2f', key, state[[key]])
  }
  fprintf('\n')

  # Send initial state to output
  msg = state
  msg[['time']] = t
  flag <- out$send(msg)
  if (!flag) {
    stop(sprintf('timesync(R): Failed to send initial output for t=%s', t))
  }

  # Iterate until end
  while (t < t_end) {
        
    # Perform calculations to update the state
    t <- t + t_step
    state <- timestep_calc(t, model)

    # Synchronize the state
    c(ret, result) %<-% timesync$call(t, state)
    if (!ret) {
      stop(sprintf('timesync(R): sync for t=%f failed.', t))
    }
    state <- result[[1]]
    fprintf('timesync(R): t = %5.1f %-1s',
            units::drop_units(t), units::deparse_unit(t))
    for (key in names(state)) {
      fprintf(', %s = %+ 5.2f', key, state[[key]])
    }
    fprintf('\n')

    # Send output
    msg = state
    msg[['time']] = t
    flag <- out$send(msg)
    if (!flag) {
      stop(sprintf('timesync(R): Failed to send output for t=%s.', t))
    }
  }

  print('Goodbye from R timesync')
  
}


args = commandArgs(trailingOnly=TRUE)
main(as.double(args[[1]]), args[[2]], args[[3]])

program main
  use fygg

  character(len=32) :: arg
  integer :: iterations, client_index
  type(yggcomm) :: rpc
  type(yggcomm) :: log
  logical :: ret
  integer :: fib, i
  integer :: exit_code = 0
  character(len=100) :: rpc_name
  character(len=100) :: log_name

  call get_command_argument(1, arg)
  read(arg, *) iterations
  call get_command_argument(2, arg)
  read(arg, *) client_index
  write(*, '("Hello from Fortran client",i1,": iterations ",i2)') &
       client_index, iterations

  ! Set up connections matching yaml
  ! RPC client-side connection will be $(server_name)_$(client_name)
  write(rpc_name, '("server_client",i1)') client_index
  write(log_name, '("output_log",i1)') client_index
  rpc = ygg_rpc_client(trim(rpc_name), "%d", "%d")
  log = ygg_output_fmt(trim(log_name), "fib(%-2d) = %-2d\n")

  ! Initialize variables
  ret = .true.
  fib = -1

  ! Iterate over Fibonacci sequence
  do i = 1, iterations

     ! Call the server and receive response
     write(*, '("client",i1,"(F): Calling fib(",i2,")")') &
          client_index, i
     ret = ygg_rpc_call(rpc, yggarg(i), yggarg(fib))
     if (.not.ret) then
        write(*, '("client",i1,"(F): RPC CALL ERROR")') client_index
        exit_code = -1;
        exit
     end if
     write(*, '("client",i1,"(F): Response fib(",i2,") = ",i2)') &
          client_index, i, fib

     ! Log result by sending it to the log connection
     ret = ygg_send_var(log, [yggarg(i), yggarg(fib)])
     if (.not.ret) then
        write(*, '("client",i1,"(F): SEND ERROR")') client_index
        exit_code = -1
        exit
     end if

  end do

  write(*, '("Goodbye from Fortran client",i1)') client_index
  if (exit_code.lt.0) then
     stop 1
  end if

end program main

function modelD_function(in_val1, in_val2, in_val1_copy, in_val2_copy, out_val) result(out)
  real(kind=8), intent(in) :: in_val1, in_val2
  real(kind=8), intent(out) :: in_val1_copy, in_val2_copy, out_val
  logical :: out
  out = .true.
  in_val1_copy = in_val1
  in_val2_copy = in_val2
  out_val = in_val1 + in_val2
  write(*, '("modelD_function(",F10.5,", ",F10.5,") = (",F10.5,")")') in_val1, in_val2, out_val
end function modelD_function

fprintf <- function(...) {
  print(sprintf(...))
}


finalize_comm <- function(pyobj) {
  # pyobj$eval_pyobj('atexit', ...)
  pyobj$atexit()
}


call_python_method <- function(pyobj, method_name, ...) {
  method = reticulate::py_get_attr(pyobj, method_name)
  if (length(list(...)) == 0) {
    return(reticulate::py_call(method))
  } else {
    return(reticulate::py_call(method, ...))
  }
}


YggInterfaceClass <- R6::R6Class("YggInterfaceClass", list(
    pyobj = NULL,
    initialize = function(pyobj) {
    	self$pyobj <- pyobj
	reg.finalizer(pyobj, finalize_comm, onexit=TRUE)
    },
    eval_pyobj = function(cmd, ...) {
      args <- list(...)
      nargs <- length(args)
      new_args <- list(self$pyobj, cmd)
      if (nargs > 0) {
        for (i in 1:nargs) {
          new_args[[2 + i]] = R2python(args[[i]])
        }
      }
      py_res <- do.call('call_python_method', new_args)
      r_res <- python2R(py_res)
      return(r_res)
    },
    recv = function(...) {
      return(self$eval_pyobj('recv', ...))
    },
    send = function(...) {
      return(self$eval_pyobj('send', ...))
    },
    recv_dict = function(...) {
      return(self$eval_pyobj('recv_dict', ...))
    },
    send_dict = function(...) {
      return(self$eval_pyobj('send_dict', ...))
    },
    recv_array = function(...) {
      return(self$eval_pyobj('recv_array', ...))
    },
    send_array = function(...) {
      return(self$eval_pyobj('send_array', ...))
    },
    send_eof = function(...) {
      return(self$eval_pyobj('send_eof', ...))
    },
    call = function(...) {
      return(self$eval_pyobj('call', ...))
    # },
    # finalize = function(...) {
    #   return(self$eval_pyobj('atexit', ...))
    }
  )
)

#' Create an object for sending/receiving messages to/from an yggdrasil channel.
#'
#' This function wraps functions from yggdrasil's [Python interface](interface_py.html), 
#' so refer to that documentation for additional details.
#'
#' @param type The name of the Python interface that should be called
#'   (e.g. [YggInput](interface_py.html#yggdrasil.languages.Python.YggInterface.YggInput),
#'   [YggOutput](interface_py.html#yggdrasil.languages.Python.YggInterface.YggOutput),
#'   [YggRpcClient](interface_py.html#yggdrasil.languages.Python.YggInterface.YggRpcClient),
#'   [YggRpcServer](interface_py.html#yggdrasil.languages.Python.YggInterface.YggRpcServer),
#'   [YggTimesync](interface_py.html#yggdrasil.languages.Python.YggInterface.YggTimesync))
#' @param ... Additional parameters will be passed to the Python interface
#'   function.
#'
#' @returns A Python comm that can be used to send/receive messages via
#'   send/recv methods.
#'
#' @export
#'
#' @examples
#'
#' \dontrun{
#'    in_channel = YggInterface('YggInput', 'input_channel_name')
#'    # Use zeallot '%<-%' syntax to expand multiple variables
#'    c(flag, input) %<-% in_channel$recv()
#' }
#'
#' \dontrun{
#'    out_channel = YggInterface('YggOutput', 'output_channel_name')
#'    flag <- out_channel$send(output1, output2, ...)
#' }
YggInterface <- function(type, ...) {
  # print(reticulate::py_config())
  if (!exists("ygg")) {
    ygg <- reticulate::import('yggdrasil.languages.Python.YggInterface', convert=FALSE)
    assign("ygg", ygg, envir = .GlobalEnv)
  }
  
  varargin <- list(...)
  nargin <- length(varargin)
  arg_names <- names(varargin)
  if (is.null(arg_names)) {
    args <- unname(varargin)
    kwargs <- NULL
  } else {
    first_named <- 0
    for (i in length(arg_names):1) {
      if (arg_names[i] == '') {
        first_named <- i + 1
	break
      }
    }
    if (first_named == 0) {
      args <- NULL
      kwargs <- varargin
    } else {
      args <- unname(varargin[1:(first_named - 1)])
      kwargs <- varargin[first_named:length(varargin)]
    }
  }
  pyobj <- ygg$YggInit(R2python(type, not_bytes=TRUE),
    R2python(args, not_bytes=TRUE), R2python(kwargs, not_bytes=TRUE))
  if (nargin > 0) {
    out <- YggInterfaceClass$new(pyobj)
  } else {
    out <- python2R(pyobj)
  }
  return(out);
}

program main
  ! Include methods for input/output channels
  use fygg

  ! Declare resulting variables and create buffer for received message
  logical :: flag = .true.
  type(yggcomm) :: in_channel, out_channel
  type(ygggeneric) :: obj
  obj = init_generic()

  ! initialize input/output channels
  in_channel = ygg_json_object_input("inputA")
  out_channel = ygg_json_object_output("outputA")

  ! Loop until there is no longer input or the queues are closed
  do while (flag)

     ! Receive input from input channel
     ! If there is an error, the flag will be negative
     ! Otherwise, it is the number of variables filled
     flag = ygg_recv_var(in_channel, yggarg(obj))
     if (.not.flag) then
        print *, "Model A: No more input."
        exit
     end if

     ! Print received message
     print *, "Model A:"
     call display_generic(obj)

     ! Send output to output channel
     ! If there is an error, the flag will be negative
     flag = ygg_send_var(out_channel, yggarg(obj))
     if (.not.flag) then
        print *, "Model A: Error sending output."
        exit
     end if

  end do

end program main

program main
  ! Include methods for input/output channels
  use fygg

  ! Declare resulting variables and create buffer for received message
  logical :: flag = .true.
  type(yggcomm) :: in_channel, out_channel
  integer(kind=c_size_t), parameter :: MYBUFSIZ = 1000
  character(len=MYBUFSIZ), target :: msg
  integer(kind=c_size_t), target :: msg_siz = 0
  integer, target :: count = 0
  real(kind=8), target :: siz = 0.0
  
  ! Initialize input/output channels
  in_channel = ygg_ascii_table_input("inputB")
  out_channel = ygg_ascii_table_output("outputB", "%6s\t%d\t%f\n")

  ! Loop until there is no longer input or the queues are closed
  do while (flag)
     msg_siz = MYBUFSIZ

     ! Receive input from input channel
     ! If there is an error, the flag will be negative
     ! Otherwise, it is the number of variables filled
     flag = ygg_recv_var(in_channel, [ &
          yggarg(msg), yggarg(msg_siz), yggarg(count), yggarg(siz)])
     if (.not.flag) then
        print *, "Model B: No more input."
        exit
     end if

     ! Print received message
     print *, "Model B: ", msg, count, siz

     ! Send output to output channel
     ! If there is an error, the flag will be negative
     flag = ygg_send_var(out_channel, [ &
          yggarg(msg), yggarg(msg_siz), yggarg(count), yggarg(siz)])
     if (.not.flag) then
        print *, "Model B: Error sending output."
        exit
     end if

  end do

end program main

.onAttach <- function(libname, pkgname) {
  if (is_attached("reticulate")) {
    reticulate::use_condaenv(Sys.getenv("CONDA_DEFAULT_ENV"))
  } else {
    setHook(packageEvent("reticulate", "attach"), function(...) {
      reticulate::use_condaenv(Sys.getenv("CONDA_DEFAULT_ENV"))
    })
  }
}

.onDetach <- function(libpath) {
  setHook(packageEvent("reticulate", "attach"), NULL, "replace")
}

is_attached <- function(pkg) paste0("package:", pkg) %in% search()

python2R <- function(pyobj) {
  # builtins <- reticulate::import_builtins()
  sys <- reticulate::import('sys')
  ver <- reticulate::py_get_attr(sys, 'version_info')
  pyv <- reticulate::py_to_r(reticulate::py_get_attr(ver, 'major'))
  np <- reticulate::import('numpy', convert=FALSE)
  try(units::install_unit('ac', '4046.86 m**2'), TRUE)
  try(units::install_unit('a', '100.0 m**2'), TRUE)
  try(units::install_unit('j', 'J'), TRUE)
  try(units::install_unit('ha', '10000.0 m**2'), TRUE)
  # try(units::install_conversion_constant('ac', 'm**2', 4046.86), TRUE)
  # try(units::install_conversion_constant('a', 'm**2', 100.0), TRUE)
  # try(units::install_conversion_constant('j', 'J', 1.0), TRUE)
  # try(units::install_conversion_constant('ha', 'm**2', 10000.0), TRUE)
  if (is(pyobj, "python.builtin.tuple")
      || is(pyobj, "python.builtin.list")) {
    pyobj_len <- reticulate::py_len(pyobj)
    out <- list()
    for (i in 1L:pyobj_len) {
      x <- python2R(reticulate::py_call(
        reticulate::py_get_attr(pyobj, '__getitem__'), i-1L))
      out[[i]] <- x
    }
  } else if (is(pyobj, "python.builtin.dict")) {
    out <- list()
    pyobj_len <- reticulate::py_len(pyobj)
    keys <- reticulate::iterate(
      call_python_method(pyobj, 'keys'))
    for (i in 1L:pyobj_len) {
      k <- keys[[i]]
      x <- python2R(call_python_method(pyobj, 'get', k))
      out[[reticulate::py_to_r(k)]] <- x
    }
  } else if (is(pyobj, "pint.quantity.Quantity")
             || is(pyobj, "unyt.array.unyt_quantity")
             || is(pyobj, "unyt.array.unyt_array")) {
    ygg_units <- reticulate::import('yggdrasil.units', convert=FALSE)
    robj_data <- python2R(ygg_units$get_data(pyobj))
    robj_units <- python2R(ygg_units$get_units(pyobj))
    out <- units::set_units(robj_data, robj_units, mode="standard")
  } else if (is(pyobj, "numpy.uint")) {
    out <- uint_to_R(pyobj)
  } else if (is(pyobj, "numpy.float32")) {
    out <- float32_to_R(pyobj)
  } else if (is(pyobj, "numpy.int32")) {
    out <- int32_to_R(pyobj)
  } else if (is(pyobj, "numpy.int64")) {
    out <- int64_to_R(pyobj)
  } else if (is(pyobj, "python.builtin.bytes")) {
    out <- bytes_to_R(pyobj)
  } else if (is(pyobj, "pandas.core.frame.DataFrame")) {
    ygg_tool <- reticulate::import('yggdrasil.tools', convert=FALSE)
    out <- reticulate::py_to_r(pyobj)
    ygg_types <- list()
    ncol_data = ncol(out)
    columns <- reticulate::py_get_attr(pyobj, 'columns')
    for (i in 1:ncol_data) {
      icol_name <- call_python_method(columns, '__getitem__',
        R2python(as.integer(i - 1)))
      icol <- call_python_method(pyobj, '__getitem__', icol_name)
      iele <- call_python_method(icol, '__getitem__', R2python(as.integer(0)))
      if (is(iele, "python.builtin.bytes")) {
        ygg_types[[as.character(i)]] <- "bytes"
	icol <- call_python_method(icol, 'apply', ygg_tool$bytes2str)
      } else if (is(iele, "numpy.float32")) {
        ygg_types[[as.character(i)]] <- "float32"
	icol <- call_python_method(icol, 'apply', np$float32)
      }
      out[, i] <- python2R(reticulate::py_get_attr(icol, 'values'))
    }
    attr(out, "ygg_types") <- ygg_types
  # TODO: There dosn't seem to be variable integer precision in R
  } else if (is(pyobj, "numpy.ndarray")) {
    type_len <- reticulate::py_len(pyobj$dtype)
    if (type_len > 1) {
      nrows <- reticulate::py_len(pyobj)
      out <- list()
      for (i in 1:nrows) {
        x <- reticulate::py_call(
	  reticulate::py_get_attr(pyobj, '__getitem__'), i-1L)
        out[[i]] <- python2R(x$tolist())
      }
    } else {
      dtype <- reticulate::py_to_r(pyobj$dtype$name)
      ygg_type <- ""
      if (substring(dtype, 1, nchar("uint")) == "uint") {
        out <- uint_to_R(pyobj)
	ygg_type <- "uint"
      } else if (dtype == "int32") {
        out <- int32_to_R(pyobj)
	# ygg_type <- "int32"
      } else if (dtype == "int64") {
        out <- int64_to_R(pyobj)
	# ygg_type <- "int64"
      } else if (dtype == "float32") {
        out <- float32_to_R(pyobj)
	ygg_type <- "float32"
      } else if (substring(dtype, 1, nchar("bytes")) == "bytes") {
        out <- bytes_to_R(pyobj)
	ygg_type <- "bytes"
      } else {
        out <- reticulate::py_to_r(pyobj)
      }
      if (length(dim(out)) == 1) {
        out <- as.vector(out)
	if (nchar(ygg_type) > 0) {
          attr(out, "ygg_type") <- ygg_type
	}
      }
    }
  } else if (is(pyobj, "python.builtin.NoneType")) {
    out <- NA
  } else {
    # print("Default handling for class:")
    # print(class(pyobj))
    out <- reticulate::py_to_r(pyobj)
  }
  # print(class(pyobj))
  # print(class(out))
  return(out)
}

program main
  ! Include methods for input/output channels
  use fygg

  ! Declare resulting variables and create buffer for received message
  logical :: flag = .true.
  type(yggcomm) :: in_channel, out_channel
  type(yggchar_r) :: msg  ! Structure wrapping reallocatable string
  integer(kind=c_size_t), target :: msg_siz = 0

  ! Initialize input/output channels
  in_channel = ygg_input("inputB")
  out_channel = ygg_output("outputB")

  ! Loop until there is no longer input or the queues are closed
  do while (flag)

     ! Receive input from input channel
     ! If there is an error, the flag will be negative
     ! Otherwise, it is the number of variables filled
     flag = ygg_recv_var_realloc(in_channel, &
          [yggarg(msg), yggarg(msg_siz)])
     if (.not.flag) then
        print *, "Model B: No more input."
        exit
     end if

     ! Print received message
     print *, "Model B: ", msg%x

     ! Send output to output channel
     ! If there is an error, the flag will be negative
     flag = ygg_send_var(out_channel, &
          [yggarg(msg), yggarg(msg_siz)])
     if (.not.flag) then
        print *, "Model B: Error sending output."
        exit
     end if

  end do

end program main

program main
  use fygg

  type(yggcomm) :: rpc
  character(len=32) :: arg
  real :: time_sleep
  integer :: input
  integer :: result0, prevResult, prevPrev, idx
  logical :: ret

  call get_command_argument(1, arg)
  read(arg, *) time_sleep
  write(*, '("Hello from Fortran rpcFibSrv: sleeptime = ",f10.4)') time_sleep

  ! Create server-side rpc conneciton using model name
  rpc = ygg_rpc_server("rpcFibSrv", "%d", "%d %d")

  ! Continue receiving requests until error occurs (the connection is
  ! closed by all clients that have connected).
  do while (.true.)
     write(*, '("rpcFibSrv(F): receiving...")')

     ret = ygg_recv_var(rpc, yggarg(input))
     if (.not.ret) then
        write(*, '("rpcFibSrv(F): end of input")')
        exit
     end if

     ! Compute fibonacci number
     result0 = 1
     prevResult = 1
     prevPrev = 0
     idx = 1
     do while (idx.lt.input)
        result0 = prevResult + prevPrev
        prevPrev = prevResult
        prevResult = result0
        idx = idx + 1
     end do
     write(*, '("rpcFibSrv(F): <- input ",i2," ::: ->(",i2," ",i2,")")') &
          input, input, result0

     ! Sleep and then send response back
     if (time_sleep.gt.0) call fsleep(int(time_sleep))
     ret = ygg_send_var(rpc, [yggarg(input), yggarg(result0)])
     if (.not.ret) then
        write(*, '("rpcFibSrv(F): ERROR sending")')
        exit
     end if

  end do

  write(*, '("Goodbye from Fortran rpcFibSrv")')

end program main

subroutine modelB_function1(in_val, in_val_copy, out_val)
  ! Only valid if in_val <= 2
  real, intent(in) :: in_val
  real, intent(out) :: in_val_copy
  real, intent(out) :: out_val
  in_val_copy = in_val
  out_val = in_val**2
  print *, "modelB_function1(", in_val, ") = ", out_val
end subroutine modelB_function1

program main
  use fygg

  character(len=32) :: arg
  integer :: iterations
  type(yggcomm) :: rpc
  logical :: ret
  integer :: fib, fibNo, i

  call get_command_argument(1, arg)
  read(arg, *) iterations
  write(*, '("Hello from Fortran rpcFibCliPar: iterations = ",i2)') &
       iterations

  ! Create RPC connection with server
  ! RPC client-side connection will be $(server_name)_$(client_name)
  rpc = ygg_rpc_client("rpcFibSrv_rpcFibCliPar", "%d", "%d %d")

  ! Send all of the requests to the server
  do i = 1, iterations
     write(*, '("rpcFibCliPar(F): fib(->",i2,") ::: ")') i
     ret = ygg_send_var(rpc, yggarg(i))
     if (.not.ret) then
        write(*, '("rpcFibCliPar(F): SEND FAILED")')
        stop 1
     end if
  end do

  ! Receive responses for all requests that were sent
  fib = -1
  fibNo = -1
  do i = 1, iterations
     ret = ygg_recv_var(rpc, [yggarg(fibNo), yggarg(fib)])
     if (.not.ret) then
        write(*, '("rpcFibCliPar(F): RECV FAILED")')
        stop 1
     end if
     write(*, '("rpcFibCliPar(F):  fib(",i2,"<-) = ",i2,"<-")') &
          fibNo, fib
  end do

  write(*, '("Goodbye from Fortran rpcFibCliPar")')

end program main

subroutine modelA_function(in_val, out_val)
  real, intent(in) :: in_val
  real, intent(out) :: out_val
  out_val = in_val
  print *, "modelA_function(", in_val, ") = ", out_val
end subroutine modelA_function

library(yggdrasil)


fibClient <- function(args) {
    
  iterations <- strtoi(args[[1]])
  fprintf('Hello from R rpcFibCli: iterations = %d ', iterations)

  # Set up connections matching yaml
  # RPC client-side connection will be $(server_name)_$(client_name)
  ymlfile <- YggInterface('YggInput', "yaml_in")
  rpc <- YggInterface('YggRpcClient', "rpcFibSrv_rpcFibCli", "%d", "%d %d")
  log <- YggInterface('YggOutput', "output_log")

  # Read entire contents of yaml
  c(ret, ycontent) %<-% ymlfile$recv()
  if (!ret) {
    stop('rpcFibCli(R): RECV ERROR')
  }
  fprintf('rpcFibCli: yaml has %d lines', length(strsplit(ycontent, '\n')))

  for (i in 1:iterations) {
        
    # Call the server and receive response
    fprintf('rpcFibCli(R): fib(->%-2d) ::: ', i)
    c(ret, fib) %<-% rpc$call(as.integer(i))
    if (!ret) {
      stop('rpcFibCli(R): RPC CALL ERROR')
    }

    # Log result by sending it to the log connection
    s <- sprintf('fib(%2d<-) = %-2d<-\n', fib[[1]], fib[[2]])
    print(s)
    ret <- log$send(s)
    if (!ret) {
      stop('rpcFibCli(R): SEND ERROR')
    }
  }

  print('Goodbye from R rpcFibCli')
}

    
args <- commandArgs(trailingOnly=TRUE)
fibClient(args)

model_function <- function(in_buf) {
  # The global_scope keyword is required to ensure that the comm persists
  # between function calls
  rpc <- YggInterface('YggRpcClient', 'server_client', global_scope=TRUE)
  print(sprintf("client(R): %s", in_buf))
  c(ret, result) %<-% rpc$call(in_buf)
  if (!ret) {
    stop('client(R): RPC CALL ERROR')
  }
  out_buf <- result[[1]]
  return(out_buf)
}

# Import library for input/output
library(yggdrasil)

# Initialize input/output channels
in_channel <- YggInterface('YggAsciiArrayInput', 'inputB')
out_channel <- YggInterface('YggAsciiArrayOutput', 'outputB', '%6s\t%d\t%f\n')

# Loop until there is no longer input or the queues are closed
while(TRUE) {

  # Receive input from input channel
  # If there is an error, the flag will be False
  c(flag, arr) %<-% in_channel$recv_array()
  if (!flag) {
    print('Model B: No more input.')
    break
  }

  # Print received message
  nr = length(arr);
  fprintf('Model B: (%d rows)', nr)
  for (i in 1:nr) {
    fprintf('   %s, %d, %f', arr[[i]][[1]], arr[[i]][[2]], arr[[i]][[3]])
  }

  # Send output to output channel
  # If there is an error, the flag will be False
  flag = out_channel$send_array(arr)
  if (!flag) {
    stop('Model B: Error sending output.')
  }

}

float32_to_R <- function(pyobj) {
  np <- reticulate::import('numpy', convert=FALSE)
  # out <- as.single(reticulate::py_to_r(pyobj))
  # out <- float::fl(reticulate::py_to_r(pyobj))
  out <- reticulate::py_to_r(call_python_method(np, 'float64', pyobj))
  return(out)
}

# Import library for input/output
library(yggdrasil)

# Initialize input/output channels
in_channel <- YggInterface('YggInput', 'input')
out_channel <- YggInterface('YggOutput', 'output')

# Loop until there is no longer input or the queues are closed
while(TRUE) {

  # Receive input from input channel
  # If there is an error, the flag will be False
  c(flag, obj) %<-% in_channel$recv()
  if (!flag) {
    print('R Model: No more input.')
    break
  }

  # Print received message
  print('R Model:')
  print(obj)

  # Print keys
  print('R Model: keys = ')
  print(names(obj))

  # Get floating point element
  co2 = obj[["CO2"]]
  print(sprintf('R Model: CO2 = %f', co2))

  # Get array element
  amaxtb = obj[["AMAXTB"]]
  print('R Model: AMAXTB = ')
  for (i in 1:length(amaxtb[[1]])) {
    print(sprintf('\t%f\t%f', amaxtb[[1]][[i]], amaxtb[[2]][[i]]))
  }

  # Send output to output channel
  # If there is an error, the flag will be False
  flag = out_channel$send(obj)
  if (!flag) {
    stop('R Model: Error sending output.')
  }

}

library(yggdrasil)


fibServer <- function(args) {

  sleeptime <- as.double(args[[1]])
  fprintf('Hello from R rpcFibSrv: sleeptime = %f', sleeptime)

  # Create server-side rpc conneciton using model name
  rpc <- YggInterface('YggRpcServer', "rpcFibSrv", "%d", "%d %d")

  # Continue receiving requests until error occurs (the connection is closed
  # by all clients that have connected).
  while (TRUE) {
    print('rpcFibSrv(R): receiving...')
    c(retval, rpc_in) %<-% rpc$recv()
    if (!retval) {
      print('rpcFibSrv(R): end of input')
      break
    }

    # Compute fibonacci number
    fprintf('rpcFibSrv(R): <- input %d', rpc_in[[1]])
    pprev <- 0
    prev <- 1
    result <- 1
    fib_no <- 1
    arg <- rpc_in[[1]]
    while (fib_no < arg) {
      result <- prev + pprev
      pprev <- prev
      prev <- result
      fib_no <- fib_no + 1
    }
    fprintf(' ::: ->(%2d %2d)', arg, result)

    # Sleep and then send response back
    Sys.sleep(sleeptime)
    flag <- rpc$send(arg, as.integer(result))
    if (!flag) {
      stop('rpcFibSrv(R): ERROR sending')
    }
  }
  print('Goodbye from R rpcFibSrv')

}

args = commandArgs(trailingOnly=TRUE)
fibServer(args)

function modelA_function(in_val, out_val1, out_val2) result(out)
  real(kind=8), intent(in) :: in_val
  real(kind=8), intent(out) :: out_val1, out_val2
  logical :: out
  out = .true.
  out_val1 = 2 * in_val
  out_val2 = 3 * in_val
  write(*, '("modelA_function(",F10.5,") = (",F10.5,", ",F10.5,")")') in_val, out_val1, out_val2
end function modelA_function

PROGRAM main
  ! Include methods for input/output channels
  USE fygg

  ! Declare resulting variables and create buffer for received message
  logical :: flag = .true.
  integer :: bufsiz
  character(len = 1000) :: buf
  TYPE(yggcomm) :: in_channel, out_channel

  ! Initialize input/output channels
  in_channel = ygg_input("inputB")
  out_channel = ygg_output("outputB")

  ! Loop until there is no longer input or the queues are closed
  DO WHILE (flag)
  
     ! Receive input from input channel
     ! If there is an error, the flag will be negative
     ! Otherwise, it is the size of the received message
     bufsiz = len(buf)
     flag = ygg_recv(in_channel, buf, bufsiz)
     IF (.not.flag) THEN
        PRINT *, "Model B: No more input."
        EXIT
     END IF

     ! Print received message
     PRINT *, "Model B: ", buf

     ! Send output to output channel
     ! If there is an error, the flag will be negative
     flag = ygg_send(out_channel, buf, bufsiz)
     IF (.not.flag) THEN
        PRINT *, "Model B: Error sending output."
        EXIT
     END IF

  END DO

END PROGRAM main

R2python <- function(robj, not_bytes=FALSE) {
  sys <- reticulate::import('sys')
  ver <- reticulate::py_get_attr(sys, 'version_info')
  pyv <- reticulate::py_to_r(reticulate::py_get_attr(ver, 'major'))
  np <- reticulate::import('numpy', convert=FALSE)
  ygg_tool <- reticulate::import('yggdrasil.tools', convert=FALSE)
  if (is.element("ygg_type", names(attributes(robj)))) {
    if (attr(robj, "ygg_type") == "bytes") {
      out <- ygg_tool$str2bytes(reticulate::r_to_py(robj),
        recurse=reticulate::r_to_py(TRUE))
    } else if (attr(robj, "ygg_type") == "float32") {
      out <- call_python_method(np, 'float32',
        reticulate::r_to_py(robj))
    } else if (attr(robj, "ygg_type") == "uint") {
      out <- call_python_method(np, 'uint',
        reticulate::r_to_py(robj))
    } else {
      print(attr(robj, "ygg_type"))
      stop("Unsupported ygg_type.")
    }
  } else if (is(robj, "list")) {
    robj <- lapply(robj, R2python, not_bytes=not_bytes)
    out <- reticulate::r_to_py(robj)
  } else if (is(robj, "units")) {
    x <- units(robj)
    ygg_units <- reticulate::import('yggdrasil.units', convert=FALSE)
    pyunits <- ygg_units$convert_R_unit_string(R2python(units::deparse_unit(robj), not_bytes=TRUE))
    pydata <- R2python(units::drop_units(robj))
    out <- ygg_units$add_units(pydata, pyunits)
  } else if (is(robj, "integer64")) {
    out <- call_python_method(np, 'int64',
      reticulate::r_to_py(as.integer(robj)))
  } else if (is(robj, "integer")) {
    out <- call_python_method(np, 'int32',
      reticulate::r_to_py(robj))
  } else if (is(robj, "float32")) {
    out <- call_python_method(np, 'float32',
      reticulate::r_to_py(float::dbl(robj)))
  } else if (is(robj, "double")) {
    # if (length(attributes(robj)) != 0) {
    out <- call_python_method(np, 'float64',
      reticulate::r_to_py(robj))
    # }
  } else if (is(robj, "ygg_float32")) {
    out <- call_python_method(np, 'float32',
      reticulate::r_to_py(robj))
  } else if (is(robj, "numeric")) {
    out <- call_python_method(np, 'float64',
      reticulate::r_to_py(robj))
  } else if (is(robj, "raw") || is(robj, "ygg_bytes")) {
    if (not_bytes) {
      out <- ygg_tool$bytes2str(reticulate::r_to_py(robj),
        recurse=reticulate::r_to_py(TRUE))
    } else {
      out <- ygg_tool$str2bytes(reticulate::r_to_py(robj),
        recurse=reticulate::r_to_py(TRUE))
    }
  } else if (is(robj, "character")) {
    out <- ygg_tool$bytes2str(reticulate::r_to_py(robj),
      recurse=R2python(TRUE))
  } else if (is(robj, "data.frame")) {
    out <- reticulate::r_to_py(robj)
    columns <- reticulate::py_get_attr(out, 'columns')
    if (is.element("ygg_types", names(attributes(robj)))) {
      for (i in names(attr(robj, "ygg_types"))) {
        name = call_python_method(columns, '__getitem__',
          R2python(as.integer(as.integer(i) - 1)))
        new_col = call_python_method(out, '__getitem__', name)
        if (attr(robj, "ygg_types")[[i]] == "bytes") {
          new_col = call_python_method(new_col, 'apply', ygg_tool$str2bytes)
	} else if (attr(robj, "ygg_types")[[i]] == "float32") {
          new_col = call_python_method(new_col, 'apply', np$float32)
	}
        call_python_method(out, '__setitem__', name, new_col)
      }
    }
  } else if (is.na(robj)) {
    out <- reticulate::r_to_py(NULL)
  } else {
    # print("Default handling for class:")
    # print(class(robj))
    out <- reticulate::r_to_py(robj)
  }
  # print(class(robj))
  # print(class(out))
  return(out)
}

library(yggdrasil)


run <- function(args) {
  msg_count <- strtoi(args[[1]])
  msg_size <- strtoi(args[[2]])
  fprintf('Hello from R pipe_src: msg_count = %d, msg_size = %d',
          msg_count, msg_size)

  # Ins/outs matching with the the model yaml
  outq <- YggInterface('YggOutput', 'output_pipe')
  print("pipe_src(R): Created I/O channels")

  # Send test message multiple times
  test_msg <- paste(replicate(msg_size, '0'), collapse="")
  count <- 0
  for (i in 1:msg_count) {
    ret <- outq$send(test_msg)
    if (!ret) {
      stop(sprintf('pipe_src(R): SEND ERROR ON MSG %d', i))
    }
    count <- count + 1
  }

  fprintf('Goodbye from R source. Sent %d messages.', count)
}
    

args <- commandArgs(trailingOnly=TRUE)
run(args)

program main
  use fygg

  character(len=32) :: arg
  integer :: msg_count, msg_size
  type(yggcomm) :: outq
  logical :: ret
  integer :: i, count
  integer :: exit_code = 0
  character(len=:), allocatable :: test_msg

  if (command_argument_count().ne.2) then
     write(*, '("Error in Fortran pipe_src: The message count and size &
          &must be provided as input arguments.")')
     stop 1
  end if

  call get_command_argument(1, arg)
  read(arg, *) msg_count
  call get_command_argument(2, arg)
  read(arg, *) msg_size
  write(*, '("Hello from Fortran pipe_src: msg_count = ",i5.1,", &
       &msg_size = ",i5.1)') msg_count, msg_size

  ! Ins/outs matching with the the model yaml
  outq = ygg_output("output_pipe")
  write(*, '("pipe_src(F): Created I/O channels")')

  ! Create test message
  allocate(character(len=(msg_size + 1)) :: test_msg)
  do i = 1, msg_size
     test_msg(i:i) = '0'
  end do
  test_msg((msg_size+1):(msg_size+1)) = c_null_char

  ! Send test message multiple times
  count = 0
  do i = 1, msg_count
     ret = ygg_send(outq, test_msg, msg_size)
     if (.not.ret) then
        write(*, '("pipe_src(F): SEND ERROR ON MSG ",i5.1)') i
        exit_code = -1
        exit
     end if
     count = count + 1
  end do
  
  write(*, '("Goodbye from Fortran source. Sent ",i5.1," messages.")') count
  if (allocated(test_msg)) deallocate(test_msg)
  if (exit_code.lt.0) then
     stop 1
  end if

end program main

program main
  use fygg

  character(len=32) :: arg
  integer :: iterations
  type(yggcomm) :: rpc
  type(yggcomm) :: log
  logical :: ret
  integer :: fib, i
  integer :: exit_code = 0

  call get_command_argument(1, arg)
  read(arg, *) iterations
  write(*, '("Hello from Fortran client: iterations ",i2)') iterations

  ! Set up connections matching yaml
  ! RPC client-side connection will be $(server_name)_$(client_name)
  rpc = ygg_rpc_client("server_client", "%d", "%d")
  log = ygg_output_fmt("output_log", "fib(%-2d) = %-2d\n")

  ! Initialize variables
  ret = .true.
  fib = -1

  ! Iterate over Fibonacci sequence
  do i = 1, iterations

     ! Call the server and receive response
     write(*, '("client(F): Calling fib(",i2,")")') i
     ret = ygg_rpc_call(rpc, yggarg(i), yggarg(fib))
     if (.not.ret) then
        write(*, '("client(F): RPC CALL ERROR")')
        exit_code = -1;
        exit
     end if
     write(*, '("client(F): Response fib(",i2,") = ",i2)') i, fib

     ! Log result by sending it to the log connection
     ret = ygg_send_var(log, [yggarg(i), yggarg(fib)])
     if (.not.ret) then
        write(*, '("client(F): SEND ERROR")')
        exit_code = -1
        exit
     end if

  end do

  write(*, '("Goodbye from Fortran client")')
  if (exit_code.lt.0) then
     stop 1
  end if

end program main

library(yggdrasil)


print("maxMsgSrv(R): Hello!")
rpc <- YggInterface('YggRpcServer', "maxMsgSrv", "%s", "%s")

while (TRUE) {
  c(ret, input) %<-% rpc$recv()
  if (!ret) {
    break
  }
  fprintf("maxMsgSrv(R): rpcRecv returned %s, input %.10s...", ret, input[[1]])
  flag <- rpc$send(input[[1]])
  if (!flag) {
    stop('maxMsgSrv(R): Error sending reply.')
  }
}

print("maxMsgSrv(R): Goodbye!")

bytes_to_R <- function(pyobj) {
  np <- reticulate::import('numpy', convert=FALSE)
  if (is(pyobj, "numpy.ndarray")) {
    pyobj <- reticulate::py_call(np$char$decode, pyobj)
  } else {
    pyobj <- pyobj$decode('utf-8')
  }
  out <- reticulate::py_to_r(pyobj)
  return(out)
}

library(yggdrasil)


main <- function(iterations) {

  fprintf('Hello from Python client: iterations = %d ', iterations)

  # Set up connections matching yaml
  # RPC client-side connection will be $(server_name)_$(client_name)
  rpc <- YggInterface('YggRpcClient', "server_client", "%d", "%d")
  log <- YggInterface('YggOutput', "output_log", 'fib(%-2d) = %-2d\n')

  # Iterate over Fibonacci sequence
  for (i in 1:iterations) {
        
    # Call the server and receive response
    fprintf('client(R): Calling fib(%d)', i)
    c(ret, result) %<-% rpc$call(i)
    if (!ret) {
      stop('client(R): RPC CALL ERROR')
    }
    fib <- result[[1]]
    fprintf('client(R): Response fib(%d) = %d', i, fib)

    # Log result by sending it to the log connection
    ret <- log$send(i, fib)
    if (!ret) {
      stop('client(R): SEND ERROR')
    }
  }

  print('Goodbye from R client')
}


args = commandArgs(trailingOnly=TRUE)
main(strtoi(args[[1]]))

function modelB_function(in_val, out_val) result(out)
  real(kind=8), intent(in) :: in_val
  real(kind=8), intent(out) :: out_val
  logical :: out
  out = .true.
  out_val = 3 * in_val
  write(*, '("modelB_function(",F10.5,") = (",F10.5,")")') in_val, out_val
end function modelB_function

function model_function(x) result(y)
  real(kind=4), dimension(:), intent(in) :: x
  real(kind=4), dimension(:), allocatable :: y
  integer :: i
  allocate(y(size(x, 1)))
  do i = 1, size(x, 1)
     y(i) = x(i) + 2.0
  end do
  write(*, '("Model B: [")', advance="no")
  do i = 1, size(x, 1)
     write(*, '(F10.5," ")', advance="no") x(i)
  end do
  write(*, '("] -> [")', advance="no")
  do i = 1, size(y, 1)
     write(*, '(F10.5," ")', advance="no") y(i)
  end do
  write(*, '("]")')
end function model_function

PROGRAM SaM
  USE fygg

  integer, parameter :: BSIZE = 1000
  integer :: bufsiz, a, b, sum
  character(len = 1000) :: adata, bdata, outbuf
  TYPE(yggcomm) :: in1, in2, out1
  logical :: ret = .true.

  ! Get input and output channels matching yaml
  in1 = ygg_input("input1_fortran")
  in2 = ygg_input("static_fortran")
  out1 = ygg_output("output_fortran")

  ! Get input from input1 channel
  bufsiz = BSIZE
  ret = ygg_recv(in1, adata, bufsiz)
  IF (.not.ret) THEN
     PRINT *, "SaM(Fortran): ERROR RECV from input1"
     STOP 1
  END IF
  READ(adata, '(I4)') a
  PRINT *, "SaM(Fortran): Received ", a, " from input1"

  ! Get input from static channel
  bufsiz = BSIZE
  ret = ygg_recv(in2, bdata, bufsiz)
  IF (.not.ret) THEN
     PRINT *, "SaM(Fortran): ERROR RECV from static"
     STOP 1
  END IF
  READ(bdata, '(I4)') b
  PRINT *, "SaM(Fortran): Received ", b, " from static"

  ! Compute sum and send message to output channel
  sum = a + b
  WRITE(outbuf, '(I4)') sum
  outbuf = ADJUSTL(outbuf)
  ret = ygg_send(out1, outbuf, LEN_TRIM(outbuf))
  IF (.not.ret) THEN
     PRINT *, "SaM(Fortran): ERROR SEND to output"
     STOP 1
  END IF
  PRINT *, "SaM(Fortran): Sent to output"
  
END PROGRAM SaM

# Import library for input/output
library(yggdrasil)

# Initialize input/output channels
in_channel <- YggInterface('YggInput', 'inputA')
out_channel <- YggInterface('YggOutput', 'outputA')

# Loop until there is no longer input or the queues are closed
while(TRUE) {

  # Receive input from input channel
  # If there is an error, the flag will be False
  c(flag, msg) %<-% in_channel$recv()
  if (!flag) {
    print('Model A: No more input.')
    break
  }

  # Print received message
  fprintf('Model A: %s', msg)

  # Send output to output channel
  # If there is an error, the flag will be False
  flag = out_channel$send(msg)
  if (!flag) {
    stop('Model A: Error sending output.')
  }

}

subroutine yggassign_yggchar2character(in, out)
  type(yggchar_r), intent(in) :: in
  character(len=:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(character(len=in_size) :: out)
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_yggchar2character
! subroutine yggassign_character2yggchar(in, out)
! end subroutine yggassign_character2yggchar

! UINT
! subroutine yggassign_unsigned_1d_to_array(in, out)
!   type(unsigned_1d), intent(in) :: in
!   unsigned, dimension(:), allocatable :: out
!   integer :: i, in_size
!   in_size = size(in%x)
!   if (allocated(out)) then
!      deallocate(out)
!   end if
!   allocate(out(in_size))
!   do i = 1, in_size
!      out(i:i) = in%x(i)
!   end do
! end subroutine yggassign_unsigned_1d_to_array
! subroutine yggassign_unsigned_1d_from_array(in, out)
!   unsigned, dimension(:), target, intent(in) :: in
!   type(unsigned_1d) :: out
!   out%x => in
! end subroutine yggassign_unsigned_1d_from_array
subroutine yggassign_unsigned2_1d_to_array(in, out)
  type(unsigned2_1d), intent(in) :: in
  integer(kind=2), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_unsigned2_1d_to_array
subroutine yggassign_unsigned2_1d_from_array(in, out)
  integer(kind=2), dimension(:), target, intent(in) :: in
  type(unsigned2_1d) :: out
  out%x => in
end subroutine yggassign_unsigned2_1d_from_array
subroutine yggassign_unsigned4_1d_to_array(in, out)
  type(unsigned4_1d), intent(in) :: in
  integer(kind=4), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_unsigned4_1d_to_array
subroutine yggassign_unsigned4_1d_from_array(in, out)
  integer(kind=4), dimension(:), target, intent(in) :: in
  type(unsigned4_1d) :: out
  out%x => in
end subroutine yggassign_unsigned4_1d_from_array
subroutine yggassign_unsigned8_1d_to_array(in, out)
  type(unsigned8_1d), intent(in) :: in
  integer(kind=8), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_unsigned8_1d_to_array
subroutine yggassign_unsigned8_1d_from_array(in, out)
  integer(kind=8), dimension(:), target, intent(in) :: in
  type(unsigned8_1d) :: out
  out%x => in
end subroutine yggassign_unsigned8_1d_from_array
! INT
subroutine yggassign_integer_1d_to_array(in, out)
  type(integer_1d), intent(in) :: in
  integer, dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_integer_1d_to_array
subroutine yggassign_integer_1d_from_array(in, out)
  integer, dimension(:), target, intent(in) :: in
  type(integer_1d) :: out
  out%x => in
end subroutine yggassign_integer_1d_from_array
subroutine yggassign_integer2_1d_to_array(in, out)
  type(integer2_1d), intent(in) :: in
  integer(kind=2), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_integer2_1d_to_array
subroutine yggassign_integer2_1d_from_array(in, out)
  integer(kind=2), dimension(:), target, intent(in) :: in
  type(integer2_1d) :: out
  out%x => in
end subroutine yggassign_integer2_1d_from_array
subroutine yggassign_integer4_1d_to_array(in, out)
  type(integer4_1d), intent(in) :: in
  integer(kind=4), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_integer4_1d_to_array
subroutine yggassign_integer4_1d_from_array(in, out)
  integer(kind=4), dimension(:), target, intent(in) :: in
  type(integer4_1d) :: out
  out%x => in
end subroutine yggassign_integer4_1d_from_array
subroutine yggassign_integer8_1d_to_array(in, out)
  type(integer8_1d), intent(in) :: in
  integer(kind=8), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_integer8_1d_to_array
subroutine yggassign_integer8_1d_from_array(in, out)
  integer(kind=8), dimension(:), target, intent(in) :: in
  type(integer8_1d) :: out
  out%x => in
end subroutine yggassign_integer8_1d_from_array
! REAL
subroutine yggassign_real_1d_to_array(in, out)
  type(real_1d), intent(in) :: in
  real, dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_real_1d_to_array
subroutine yggassign_real_1d_from_array(in, out)
  real, dimension(:), target, intent(in) :: in
  type(real_1d) :: out
  out%x => in
end subroutine yggassign_real_1d_from_array
subroutine yggassign_real4_1d_to_array(in, out)
  type(real4_1d), intent(in) :: in
  real(kind=4), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_real4_1d_to_array
subroutine yggassign_real4_1d_from_array(in, out)
  real(kind=4), dimension(:), target, intent(in) :: in
  type(real4_1d) :: out
  out%x => in
end subroutine yggassign_real4_1d_from_array
subroutine yggassign_real8_1d_to_array(in, out)
  type(real8_1d), intent(in) :: in
  real(kind=8), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_real8_1d_to_array
subroutine yggassign_real8_1d_from_array(in, out)
  real(kind=8), dimension(:), target, intent(in) :: in
  type(real8_1d) :: out
  out%x => in
end subroutine yggassign_real8_1d_from_array
subroutine yggassign_real16_1d_to_array(in, out)
  type(real16_1d), intent(in) :: in
  real(kind=16), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_real16_1d_to_array
subroutine yggassign_real16_1d_from_array(in, out)
  real(kind=16), dimension(:), target, intent(in) :: in
  type(real16_1d) :: out
  out%x => in
end subroutine yggassign_real16_1d_from_array
! COMPLEX
subroutine yggassign_complex_1d_to_array(in, out)
  type(complex_1d), intent(in) :: in
  complex, dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_complex_1d_to_array
subroutine yggassign_complex_1d_from_array(in, out)
  complex, dimension(:), target, intent(in) :: in
  type(complex_1d) :: out
  out%x => in
end subroutine yggassign_complex_1d_from_array
subroutine yggassign_complex4_1d_to_array(in, out)
  type(complex4_1d), intent(in) :: in
  complex(kind=4), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_complex4_1d_to_array
subroutine yggassign_complex4_1d_from_array(in, out)
  complex(kind=4), dimension(:), target, intent(in) :: in
  type(complex4_1d) :: out
  out%x => in
end subroutine yggassign_complex4_1d_from_array
subroutine yggassign_complex8_1d_to_array(in, out)
  type(complex8_1d), intent(in) :: in
  complex(kind=8), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_complex8_1d_to_array
subroutine yggassign_complex8_1d_from_array(in, out)
  complex(kind=8), dimension(:), target, intent(in) :: in
  type(complex8_1d) :: out
  out%x => in
end subroutine yggassign_complex8_1d_from_array
subroutine yggassign_complex16_1d_to_array(in, out)
  type(complex16_1d), intent(in) :: in
  complex(kind=16), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_complex16_1d_to_array
subroutine yggassign_complex16_1d_from_array(in, out)
  complex(kind=16), dimension(:), target, intent(in) :: in
  type(complex16_1d) :: out
  out%x => in
end subroutine yggassign_complex16_1d_from_array
! LOGICAL
subroutine yggassign_logical_1d_to_array(in, out)
  type(logical_1d), intent(in) :: in
  logical, dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_logical_1d_to_array
subroutine yggassign_logical_1d_from_array(in, out)
  logical, dimension(:), target, intent(in) :: in
  type(logical_1d) :: out
  out%x => in
end subroutine yggassign_logical_1d_from_array
subroutine yggassign_logical1_1d_to_array(in, out)
  type(logical1_1d), intent(in) :: in
  logical(kind=1), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_logical1_1d_to_array
subroutine yggassign_logical1_1d_from_array(in, out)
  logical(kind=1), dimension(:), target, intent(in) :: in
  type(logical1_1d) :: out
  out%x => in
end subroutine yggassign_logical1_1d_from_array
subroutine yggassign_logical2_1d_to_array(in, out)
  type(logical2_1d), intent(in) :: in
  logical(kind=2), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_logical2_1d_to_array
subroutine yggassign_logical2_1d_from_array(in, out)
  logical(kind=2), dimension(:), target, intent(in) :: in
  type(logical2_1d) :: out
  out%x => in
end subroutine yggassign_logical2_1d_from_array
subroutine yggassign_logical4_1d_to_array(in, out)
  type(logical4_1d), intent(in) :: in
  logical(kind=4), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_logical4_1d_to_array
subroutine yggassign_logical4_1d_from_array(in, out)
  logical(kind=4), dimension(:), target, intent(in) :: in
  type(logical4_1d) :: out
  out%x => in
end subroutine yggassign_logical4_1d_from_array
subroutine yggassign_logical8_1d_to_array(in, out)
  type(logical8_1d), intent(in) :: in
  logical(kind=8), dimension(:), allocatable :: out
  integer :: i, in_size
  in_size = size(in%x)
  if (allocated(out)) then
     deallocate(out)
  end if
  allocate(out(in_size))
  do i = 1, in_size
     out(i:i) = in%x(i)
  end do
end subroutine yggassign_logical8_1d_to_array
subroutine yggassign_logical8_1d_from_array(in, out)
  logical(kind=8), dimension(:), target, intent(in) :: in
  type(logical8_1d) :: out
  out%x => in
end subroutine yggassign_logical8_1d_from_array

! TODO: ND

subroutine modelB_function2(in_val, in_val_copy, out_val)
  ! Only valid if in_val > 2
  real, intent(in) :: in_val
  real, intent(out) :: in_val_copy
  real, intent(out) :: out_val
  in_val_copy = in_val
  out_val = 2 * (in_val**2)
  print *, "modelB_function2(", in_val, ") = ", out_val
end subroutine modelB_function2

module fygg

  ! TODO: Ensure that dynamically allocated C/C++ variables are freed.
  use iso_c_binding
  implicit none

  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  integer, parameter :: LINE_SIZE_MAX = 2048
  integer, parameter :: YGG_MSG_BUF = 2048
  integer, parameter :: ascii = selected_char_kind ("ascii")
#ifdef _WIN32
  integer, parameter :: ucs4  = 1
#else
  integer, parameter :: ucs4  = selected_char_kind ('ISO_10646')
#endif
  integer(kind=c_int), bind(c, name="YGG_MSG_MAX_F") :: YGG_MSG_MAX
  real(8),  parameter :: PI_8  = 4 * atan (1.0_8)
  real(16), parameter :: PI_16 = 4 * atan (1.0_16)
  ! END DOXYGEN_SHOULD_SKIP_THIS

  !> @brief Wrap a fortran variable so that yggdrasil can pass it to comm
  !>    send & receive methods.
  !> @param [in,out] x Variable to wrap.
  !> @returns y Wrapped variable.
  interface yggarg
     module procedure yggarg_scalar_unsigned1
     module procedure yggarg_scalar_unsigned2
     module procedure yggarg_scalar_unsigned4
     module procedure yggarg_scalar_unsigned8
     module procedure yggarg_scalar_integer2
     module procedure yggarg_scalar_integer4
     module procedure yggarg_scalar_integer8
     module procedure yggarg_scalar_real4
     module procedure yggarg_scalar_real8
#ifndef _WIN32
     module procedure yggarg_scalar_real16
#endif
     module procedure yggarg_scalar_complex4
     module procedure yggarg_scalar_complex8
#ifndef _WIN32
     module procedure yggarg_scalar_complex16
#endif
     module procedure yggarg_scalar_logical1
     module procedure yggarg_scalar_logical2
     module procedure yggarg_scalar_logical4
     module procedure yggarg_scalar_logical8
     module procedure yggarg_scalar_character
#ifndef _WIN32
     module procedure yggarg_scalar_unicode
#endif
     module procedure yggarg_scalar_yggchar_r
     module procedure yggarg_scalar_ply
     module procedure yggarg_scalar_obj
     module procedure yggarg_scalar_null
     module procedure yggarg_scalar_generic
     module procedure yggarg_scalar_yggarr
     module procedure yggarg_scalar_yggmap
     module procedure yggarg_scalar_yggschema
     module procedure yggarg_scalar_yggpython
     module procedure yggarg_scalar_yggpyinst
     module procedure yggarg_scalar_yggpyfunc
     module procedure yggarg_scalar_yggptr
     ! module procedure yggarg_scalar_yggptr_arr
     ! module procedure yggarg_scalar_yggptr_map
     module procedure yggarg_realloc_1darray_unsigned1
     module procedure yggarg_realloc_1darray_unsigned2
     module procedure yggarg_realloc_1darray_unsigned4
     module procedure yggarg_realloc_1darray_unsigned8
     module procedure yggarg_realloc_1darray_c_long
     module procedure yggarg_realloc_1darray_integer
     module procedure yggarg_realloc_1darray_integer2
     module procedure yggarg_realloc_1darray_integer4
     module procedure yggarg_realloc_1darray_integer8
     module procedure yggarg_realloc_1darray_real
     module procedure yggarg_realloc_1darray_real4
     module procedure yggarg_realloc_1darray_real8
     module procedure yggarg_realloc_1darray_real16
     module procedure yggarg_realloc_1darray_complex
     module procedure yggarg_realloc_1darray_complex4
     module procedure yggarg_realloc_1darray_complex8
     module procedure yggarg_realloc_1darray_complex16
     module procedure yggarg_realloc_1darray_logical
     module procedure yggarg_realloc_1darray_logical1
     module procedure yggarg_realloc_1darray_logical2
     module procedure yggarg_realloc_1darray_logical4
     module procedure yggarg_realloc_1darray_logical8
     module procedure yggarg_realloc_1darray_character
     module procedure yggarg_1darray_unsigned1
     module procedure yggarg_1darray_unsigned2
     module procedure yggarg_1darray_unsigned4
     module procedure yggarg_1darray_unsigned8
     module procedure yggarg_1darray_integer2
     module procedure yggarg_1darray_integer4
     module procedure yggarg_1darray_integer8
     module procedure yggarg_1darray_real4
     module procedure yggarg_1darray_real8
#ifndef _WIN32
     module procedure yggarg_1darray_real16
#endif
     module procedure yggarg_1darray_complex4
     module procedure yggarg_1darray_complex8
#ifndef _WIN32
     module procedure yggarg_1darray_complex16
#endif
     module procedure yggarg_1darray_logical1
     module procedure yggarg_1darray_logical2
     module procedure yggarg_1darray_logical4
     module procedure yggarg_1darray_logical8
     module procedure yggarg_1darray_character
#ifndef _WIN32
     module procedure yggarg_1darray_unicode
#endif
     module procedure yggarg_1darray_yggchar_r
     module procedure yggarg_realloc_ndarray_unsigned1
     module procedure yggarg_realloc_ndarray_unsigned2
     module procedure yggarg_realloc_ndarray_unsigned4
     module procedure yggarg_realloc_ndarray_unsigned8
     module procedure yggarg_realloc_ndarray_c_long
     module procedure yggarg_realloc_ndarray_integer
     module procedure yggarg_realloc_ndarray_integer2
     module procedure yggarg_realloc_ndarray_integer4
     module procedure yggarg_realloc_ndarray_integer8
     module procedure yggarg_realloc_ndarray_real
     module procedure yggarg_realloc_ndarray_real4
     module procedure yggarg_realloc_ndarray_real8
     module procedure yggarg_realloc_ndarray_real16
     module procedure yggarg_realloc_ndarray_complex
     module procedure yggarg_realloc_ndarray_complex4
     module procedure yggarg_realloc_ndarray_complex8
     module procedure yggarg_realloc_ndarray_complex16
     module procedure yggarg_realloc_ndarray_logical
     module procedure yggarg_realloc_ndarray_logical1
     module procedure yggarg_realloc_ndarray_logical2
     module procedure yggarg_realloc_ndarray_logical4
     module procedure yggarg_realloc_ndarray_logical8
     module procedure yggarg_realloc_ndarray_character
     module procedure yggarg_2darray_unsigned1
     module procedure yggarg_2darray_unsigned2
     module procedure yggarg_2darray_unsigned4
     module procedure yggarg_2darray_unsigned8
     module procedure yggarg_2darray_integer2
     module procedure yggarg_2darray_integer4
     module procedure yggarg_2darray_integer8
     module procedure yggarg_2darray_real4
     module procedure yggarg_2darray_real8
#ifndef _WIN32
     module procedure yggarg_2darray_real16
#endif
     module procedure yggarg_2darray_complex4
     module procedure yggarg_2darray_complex8
#ifndef _WIN32
     module procedure yggarg_2darray_complex16
#endif
     module procedure yggarg_2darray_logical1
     module procedure yggarg_2darray_logical2
     module procedure yggarg_2darray_logical4
     module procedure yggarg_2darray_logical8
     module procedure yggarg_2darray_character
     module procedure yggarg_2darray_yggchar_r
  end interface yggarg
  !> @brief Set an item in an array.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @param[in] index Index for value that should be set.
  !> @param[in] ... Additional variables contain information about the item.
  interface generic_array_set
     module procedure generic_array_set_generic
     module procedure generic_array_set_boolean
     ! module procedure generic_array_set_integer
     module procedure generic_array_set_null
     ! module procedure generic_array_set_number
     module procedure generic_array_set_array
     module procedure generic_array_set_map
     module procedure generic_array_set_ply
     module procedure generic_array_set_obj
     module procedure generic_array_set_python_class
     ! module procedure generic_array_set_python_function
     module procedure generic_array_set_schema
     ! module procedure generic_array_set_any
     module procedure generic_array_set_integer2
     module procedure generic_array_set_integer4
     module procedure generic_array_set_integer8
     module procedure generic_array_set_unsigned1
     module procedure generic_array_set_unsigned2
     module procedure generic_array_set_unsigned4
     module procedure generic_array_set_unsigned8
     module procedure generic_array_set_real4
     module procedure generic_array_set_real8
     module procedure generic_array_set_complex4
     module procedure generic_array_set_complex8
     module procedure generic_array_set_bytes
     module procedure generic_array_set_unicode
     module procedure generic_array_set_1darray_integer2
     module procedure generic_array_set_1darray_integer4
     module procedure generic_array_set_1darray_integer8
     module procedure generic_array_set_1darray_unsigned1
     module procedure generic_array_set_1darray_unsigned2
     module procedure generic_array_set_1darray_unsigned4
     module procedure generic_array_set_1darray_unsigned8
     module procedure generic_array_set_1darray_real4
     module procedure generic_array_set_1darray_real8
     module procedure generic_array_set_1darray_complex4
     module procedure generic_array_set_1darray_complex8
     module procedure generic_array_set_1darray_bytes
     module procedure generic_array_set_1darray_unicode
     module procedure generic_array_set_ndarray_integer2
     module procedure generic_array_set_ndarray_integer4
     module procedure generic_array_set_ndarray_integer8
     module procedure generic_array_set_ndarray_unsigned1
     module procedure generic_array_set_ndarray_unsigned2
     module procedure generic_array_set_ndarray_unsigned4
     module procedure generic_array_set_ndarray_unsigned8
     module procedure generic_array_set_ndarray_real4
     module procedure generic_array_set_ndarray_real8
     module procedure generic_array_set_ndarray_complex4
     module procedure generic_array_set_ndarray_complex8
     module procedure generic_array_set_ndarray_character
     module procedure generic_array_set_ndarray_bytes
     module procedure generic_array_set_ndarray_unicode
  end interface generic_array_set
  !> @brief Set an item in a map.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[in] key Key string for value that should be set.
  !> @param[in] ... Additional variables contain information about the item.
  interface generic_map_set
     module procedure generic_map_get_generic
     module procedure generic_map_set_boolean
     ! module procedure generic_map_set_integer
     module procedure generic_map_set_null
     ! module procedure generic_map_set_number
     module procedure generic_map_set_array
     module procedure generic_map_set_map
     module procedure generic_map_set_ply
     module procedure generic_map_set_obj
     module procedure generic_map_set_python_class
     ! module procedure generic_map_set_python_function
     module procedure generic_map_set_schema
     ! module procedure generic_map_set_any
     module procedure generic_map_set_integer2
     module procedure generic_map_set_integer4
     module procedure generic_map_set_integer8
     module procedure generic_map_set_unsigned1
     module procedure generic_map_set_unsigned2
     module procedure generic_map_set_unsigned4
     module procedure generic_map_set_unsigned8
     module procedure generic_map_set_real4
     module procedure generic_map_set_real8
     module procedure generic_map_set_complex4
     module procedure generic_map_set_complex8
     module procedure generic_map_set_bytes
     module procedure generic_map_set_unicode
     module procedure generic_map_set_1darray_integer2
     module procedure generic_map_set_1darray_integer4
     module procedure generic_map_set_1darray_integer8
     module procedure generic_map_set_1darray_unsigned1
     module procedure generic_map_set_1darray_unsigned2
     module procedure generic_map_set_1darray_unsigned4
     module procedure generic_map_set_1darray_unsigned8
     module procedure generic_map_set_1darray_real4
     module procedure generic_map_set_1darray_real8
     module procedure generic_map_set_1darray_complex4
     module procedure generic_map_set_1darray_complex8
     module procedure generic_map_set_1darray_bytes
     module procedure generic_map_set_1darray_unicode
     module procedure generic_map_set_ndarray_integer2
     module procedure generic_map_set_ndarray_integer4
     module procedure generic_map_set_ndarray_integer8
     module procedure generic_map_set_ndarray_unsigned1
     module procedure generic_map_set_ndarray_unsigned2
     module procedure generic_map_set_ndarray_unsigned4
     module procedure generic_map_set_ndarray_unsigned8
     module procedure generic_map_set_ndarray_real4
     module procedure generic_map_set_ndarray_real8
     module procedure generic_map_set_ndarray_complex4
     module procedure generic_map_set_ndarray_complex8
     module procedure generic_map_set_ndarray_character
     module procedure generic_map_set_ndarray_bytes
     module procedure generic_map_set_ndarray_unicode
  end interface generic_map_set
  !> @brief Get an item from an array.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @param[in,out] ... Additional arguments will determine the type of
  !>    data that's returned.
  !> @returns The item.
  interface generic_array_get
     module procedure generic_array_get_generic
     module procedure generic_array_get_boolean
     ! module procedure generic_array_get_integer
     module procedure generic_array_get_null
     ! module procedure generic_array_get_number
     module procedure generic_array_get_array
     module procedure generic_array_get_map
     module procedure generic_array_get_ply
     module procedure generic_array_get_obj
     module procedure generic_array_get_python_class
     ! module procedure generic_array_get_python_function
     module procedure generic_array_get_schema
     ! module procedure generic_array_get_any
     module procedure generic_array_get_integer2
     module procedure generic_array_get_integer4
     module procedure generic_array_get_integer8
     module procedure generic_array_get_unsigned1
     module procedure generic_array_get_unsigned2
     module procedure generic_array_get_unsigned4
     module procedure generic_array_get_unsigned8
     module procedure generic_array_get_real4
     module procedure generic_array_get_real8
     module procedure generic_array_get_complex4
     module procedure generic_array_get_complex8
     module procedure generic_array_get_bytes
     module procedure generic_array_get_unicode
     module procedure generic_array_get_1darray_integer2
     module procedure generic_array_get_1darray_integer4
     module procedure generic_array_get_1darray_integer8
     module procedure generic_array_get_1darray_unsigned1
     module procedure generic_array_get_1darray_unsigned2
     module procedure generic_array_get_1darray_unsigned4
     module procedure generic_array_get_1darray_unsigned8
     module procedure generic_array_get_1darray_real4
     module procedure generic_array_get_1darray_real8
     module procedure generic_array_get_1darray_complex4
     module procedure generic_array_get_1darray_complex8
     module procedure generic_array_get_1darray_bytes
     module procedure generic_array_get_1darray_unicode
     module procedure generic_array_get_ndarray_integer2
     module procedure generic_array_get_ndarray_integer4
     module procedure generic_array_get_ndarray_integer8
     module procedure generic_array_get_ndarray_unsigned1
     module procedure generic_array_get_ndarray_unsigned2
     module procedure generic_array_get_ndarray_unsigned4
     module procedure generic_array_get_ndarray_unsigned8
     module procedure generic_array_get_ndarray_real4
     module procedure generic_array_get_ndarray_real8
     module procedure generic_array_get_ndarray_complex4
     module procedure generic_array_get_ndarray_complex8
     module procedure generic_array_get_ndarray_character
     module procedure generic_array_get_ndarray_bytes
     module procedure generic_array_get_ndarray_unicode
  end interface generic_array_get
  !> @brief Get an item from a map.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[in,out] ... Additional arguments will determine the type of
  !>    data that's returned.
  !> @returns The item.
  interface generic_map_get
     module procedure generic_map_get_generic
     module procedure generic_map_get_boolean
     ! module procedure generic_map_get_integer
     module procedure generic_map_get_null
     ! module procedure generic_map_get_number
     module procedure generic_map_get_array
     module procedure generic_map_get_map
     module procedure generic_map_get_ply
     module procedure generic_map_get_obj
     module procedure generic_map_get_python_class
     ! module procedure generic_map_get_python_function
     module procedure generic_map_get_schema
     ! module procedure generic_map_get_any
     module procedure generic_map_get_integer2
     module procedure generic_map_get_integer4
     module procedure generic_map_get_integer8
     module procedure generic_map_get_unsigned1
     module procedure generic_map_get_unsigned2
     module procedure generic_map_get_unsigned4
     module procedure generic_map_get_unsigned8
     module procedure generic_map_get_real4
     module procedure generic_map_get_real8
     module procedure generic_map_get_complex4
     module procedure generic_map_get_complex8
     module procedure generic_map_get_bytes
     module procedure generic_map_get_unicode
     module procedure generic_map_get_1darray_integer2
     module procedure generic_map_get_1darray_integer4
     module procedure generic_map_get_1darray_integer8
     module procedure generic_map_get_1darray_unsigned1
     module procedure generic_map_get_1darray_unsigned2
     module procedure generic_map_get_1darray_unsigned4
     module procedure generic_map_get_1darray_unsigned8
     module procedure generic_map_get_1darray_real4
     module procedure generic_map_get_1darray_real8
     module procedure generic_map_get_1darray_complex4
     module procedure generic_map_get_1darray_complex8
     module procedure generic_map_get_1darray_bytes
     module procedure generic_map_get_1darray_unicode
     module procedure generic_map_get_ndarray_integer2
     module procedure generic_map_get_ndarray_integer4
     module procedure generic_map_get_ndarray_integer8
     module procedure generic_map_get_ndarray_unsigned1
     module procedure generic_map_get_ndarray_unsigned2
     module procedure generic_map_get_ndarray_unsigned4
     module procedure generic_map_get_ndarray_unsigned8
     module procedure generic_map_get_ndarray_real4
     module procedure generic_map_get_ndarray_real8
     module procedure generic_map_get_ndarray_complex4
     module procedure generic_map_get_ndarray_complex8
     module procedure generic_map_get_ndarray_character
     module procedure generic_map_get_ndarray_bytes
     module procedure generic_map_get_ndarray_unicode
  end interface generic_map_get
  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  interface yggassign
     module procedure yggassign_yggchar2character
     ! module procedure yggassign_character2yggchar
     module procedure yggassign_integer_1d_to_array
     module procedure yggassign_integer_1d_from_array
     module procedure yggassign_integer2_1d_to_array
     module procedure yggassign_integer2_1d_from_array
     module procedure yggassign_integer4_1d_to_array
     module procedure yggassign_integer4_1d_from_array
     module procedure yggassign_integer8_1d_to_array
     module procedure yggassign_integer8_1d_from_array
     ! module procedure yggassign_unsigned_1d_to_array
     ! module procedure yggassign_unsigned_1d_from_array
     module procedure yggassign_unsigned2_1d_to_array
     module procedure yggassign_unsigned2_1d_from_array
     module procedure yggassign_unsigned4_1d_to_array
     module procedure yggassign_unsigned4_1d_from_array
     module procedure yggassign_unsigned8_1d_to_array
     module procedure yggassign_unsigned8_1d_from_array
     module procedure yggassign_real_1d_to_array
     module procedure yggassign_real_1d_from_array
     module procedure yggassign_real4_1d_to_array
     module procedure yggassign_real4_1d_from_array
     module procedure yggassign_real8_1d_to_array
     module procedure yggassign_real8_1d_from_array
     module procedure yggassign_real16_1d_to_array
     module procedure yggassign_real16_1d_from_array
     module procedure yggassign_complex_1d_to_array
     module procedure yggassign_complex_1d_from_array
     module procedure yggassign_complex4_1d_to_array
     module procedure yggassign_complex4_1d_from_array
     module procedure yggassign_complex8_1d_to_array
     module procedure yggassign_complex8_1d_from_array
     module procedure yggassign_complex16_1d_to_array
     module procedure yggassign_complex16_1d_from_array
     module procedure yggassign_logical_1d_to_array
     module procedure yggassign_logical_1d_from_array
     module procedure yggassign_logical1_1d_to_array
     module procedure yggassign_logical1_1d_from_array
     module procedure yggassign_logical2_1d_to_array
     module procedure yggassign_logical2_1d_from_array
     module procedure yggassign_logical4_1d_to_array
     module procedure yggassign_logical4_1d_from_array
     module procedure yggassign_logical8_1d_to_array
     module procedure yggassign_logical8_1d_from_array
     ! TODO: ND array
  end interface yggassign
  ! END DOXYGEN_SHOULD_SKIP_THIS
  !> @brief Convert an object to type(yggarr)
  !> @param[in] input Object to convert.
  !> @returns Converted object.
  interface yggarr
     module procedure ygggeneric2yggarr
  end interface yggarr
  !> @brief Convert an object to type(yggmap)
  !> @param[in] input Object to convert.
  !> @returns Converted object.
  interface yggmap
     module procedure ygggeneric2yggmap
  end interface yggmap
  !> @brief Convert an object to type(yggschema)
  !> @param[in] input Object to convert.
  !> @returns Converted object.
  interface yggschema
     module procedure ygggeneric2yggschema
  end interface yggschema
  !> @brief Convert an object to type(yggpyinst)
  !> @param[in] input Object to convert.
  !> @returns Converted object.
  interface yggpyinst
     module procedure ygggeneric2yggpyinst
  end interface yggpyinst
  !> @brief Convert an object to type(ygggeneric)
  !> @param[in] input Object to convert.
  !> @returns Converted object.
  interface ygggeneric
     module procedure yggarr2ygggeneric
     module procedure yggmap2ygggeneric
     module procedure yggschema2ygggeneric
     module procedure yggpyinst2ygggeneric
  end interface ygggeneric
  !> @brief Convert an object to type(yggpyfunc)
  !> @param[in] input Object to convert.
  !> @returns Converted object.
  interface yggpyfunc
     module procedure yggpython2yggpyfunc
  end interface yggpyfunc
  !> @brief Convert an object to type(yggpython)
  !> @param[in] input Object to convert.
  !> @returns Converted object.
  interface yggpython
     module procedure yggpython2yggpython
     module procedure yggpyfunc2yggpython
  end interface yggpython
  !> @brief Send one or more variables.
  !> @param[in] ygg_q Output/RPC/Timesync comm.
  !> @param[in] args One or more variables to send.
  !> @returns flag Success (.true.) or failure (.false.) of the send.
  interface ygg_send_var
     module procedure ygg_send_var_sing
     module procedure ygg_send_var_mult
  end interface ygg_send_var
  !> @brief Receive data into one or more variables that cannot be resized.
  !> @param[in] ygg_q Output/RPC/Timesync comm.
  !> @param[in,out] args One or more variables to receive into.
  !> @returns flag Success (.true.) or failure (.false.) of the send.
  interface ygg_recv_var
     module procedure ygg_recv_var_sing
     module procedure ygg_recv_var_mult
  end interface ygg_recv_var
  !> @brief Receive data into one or more variables that can be resized.
  !> @param[in] ygg_q Output/RPC/Timesync comm.
  !> @param[in,out] args One or more variables to receive into.
  !> @returns flag Success (.true.) or failure (.false.) of the send.
  interface ygg_recv_var_realloc
     module procedure ygg_recv_var_realloc_sing
     module procedure ygg_recv_var_realloc_mult
  end interface ygg_recv_var_realloc
  !> @brief Send a request and receive a response into one or more variables
  !>   that cannot be resized.
  !> @param[in] ygg_q RPC/Timesync comm.
  !> @param[in] oargs One or more variables to send in the request.
  !> @param[in,out] iargs One or more variables to receive the response 
  !>   into that cannot be resized.
  !> @returns flag Success (.true.) or failure (.false.) of the call.
  interface ygg_rpc_call
     module procedure ygg_rpc_call_1v1
     module procedure ygg_rpc_call_1vm
     module procedure ygg_rpc_call_mv1
     module procedure ygg_rpc_call_mult
  end interface ygg_rpc_call
  !> @brief Send a request and receive a response into one or more variables
  !>   that can be resized.
  !> @param[in] ygg_q RPC/Timesync comm.
  !> @param[in] oargs One or more variables to send in the request.
  !> @param[in,out] iargs One or more variables to receive the response 
  !>   into that can be resized.
  !> @returns flag Success (.true.) or failure (.false.) of the call.
  interface ygg_rpc_call_realloc
     module procedure ygg_rpc_call_realloc_1v1
     module procedure ygg_rpc_call_realloc_1vm
     module procedure ygg_rpc_call_realloc_mv1
     module procedure ygg_rpc_call_realloc_mult
  end interface ygg_rpc_call_realloc
  !> @brief Initialize a ygguint instance.
  !> @param[in] x Integer that unsigned integer object should be initialized
  !>   with. The kind of input integer will determine the precision of the
  !>   unsigned int object.
  !> @returns A ygguint instance.
  interface ygguint
     module procedure init_ygguint1
     module procedure init_ygguint2
     module procedure init_ygguint4
     module procedure init_ygguint8
  end interface ygguint
  !> @brief Wrapper for a C comm object.
  type :: yggcomm
     type(c_ptr) :: comm !< C comm object
  end type yggcomm
  !> @brief Wrapper for a C data type
  type :: yggdtype
     type(c_ptr) :: ptr !< C data type
  end type yggdtype
  !> @brief Wrapper for a reallocatable character array.
  type :: yggchar_r
     character, dimension(:), pointer :: x => null() !< Wrapped array
  end type yggchar_r
  !> @brief Wrapper for a reallocatable 1D array of c_long.
  type :: c_long_1d
     integer(kind=c_long), dimension(:), pointer :: x => null() !< Wrapped array
  end type c_long_1d
  !> @brief Wrapper for a reallocatable 1D array of 1 byte unsigned integers.
  type :: unsigned1_1d
     integer(kind=1), dimension(:), pointer :: x => null() !< Wrapped array
  end type unsigned1_1d
  !> @brief Wrapper for a reallocatable 1D array of 2 byte unsigned integers.
  type :: unsigned2_1d
     integer(kind=2), dimension(:), pointer :: x => null() !< Wrapped array
  end type unsigned2_1d
  !> @brief Wrapper for a reallocatable 1D array of 4 byte unsigned integers.
  type :: unsigned4_1d
     integer(kind=4), dimension(:), pointer :: x => null() !< Wrapped array
  end type unsigned4_1d
  !> @brief Wrapper for a reallocatable 1D array of 8 byte unsigned integers.
  type :: unsigned8_1d
     integer(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
  end type unsigned8_1d
  !> @brief Wrapper for a reallocatable 1D array of 1 byte integers.
  type :: integer_1d
     integer, dimension(:), pointer :: x => null() !< Wrapped array
  end type integer_1d
  !> @brief Wrapper for a reallocatable 1D array of 2 byte integers.
  type :: integer2_1d
     integer(kind=2), dimension(:), pointer :: x => null() !< Wrapped array
  end type integer2_1d
  !> @brief Wrapper for a reallocatable 1D array of 4 byte integers.
  type :: integer4_1d
     integer(kind=4), dimension(:), pointer :: x => null() !< Wrapped array
  end type integer4_1d
  !> @brief Wrapper for a reallocatable 1D array of 8 byte integers.
  type :: integer8_1d
     integer(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
  end type integer8_1d
  !> @brief Wrapper for a reallocatable 1D array of real.
  type :: real_1d
     real, dimension(:), pointer :: x => null() !< Wrapped array
  end type real_1d
  !> @brief Wrapper for a reallocatable 1D array of 4 byte real.
  type :: real4_1d
     real(kind=4), dimension(:), pointer :: x => null() !< Wrapped array
  end type real4_1d
  !> @brief Wrapper for a reallocatable 1D array of 8 byte real.
  type :: real8_1d
     real(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
  end type real8_1d
#ifdef _WIN32
  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  !> @brief Wrapper for a reallocatable 1D array of 16 byte real.
  type :: real16_1d
     real(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
  end type real16_1d
  ! END DOXYGEN_SHOULD_SKIP_THIS
#else
  !> @brief Wrapper for a reallocatable 1D array of 16 byte real.
  type :: real16_1d
     real(kind=16), dimension(:), pointer :: x => null() !< Wrapped array
  end type real16_1d
#endif
  !> @brief Wrapper for a reallocatable 1D array of complex.
  type :: complex_1d
     complex, dimension(:), pointer :: x => null() !< Wrapped array
  end type complex_1d
  !> @brief Wrapper for a reallocatable 1D array of 4 byte complex.
  type :: complex4_1d
     complex(kind=4), dimension(:), pointer :: x => null() !< Wrapped array
  end type complex4_1d
  !> @brief Wrapper for a reallocatable 1D array of 8 byte complex.
  type :: complex8_1d
     complex(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
  end type complex8_1d
#ifdef _WIN32
  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  !> @brief Wrapper for a reallocatable 1D array of 16 byte complex.
  type :: complex16_1d
     complex(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
  end type complex16_1d
  ! END DOXYGEN_SHOULD_SKIP_THIS
#else
  !> @brief Wrapper for a reallocatable 1D array of 16 byte complex.
  type :: complex16_1d
     complex(kind=16), dimension(:), pointer :: x => null() !< Wrapped array
  end type complex16_1d
#endif
  !> @brief Wrapper for a reallocatable 1D array of logical.
  type :: logical_1d
     logical, dimension(:), pointer :: x => null() !< Wrapped array
  end type logical_1d
  !> @brief Wrapper for a reallocatable 1D array of 1 byte logical.
  type :: logical1_1d
     logical(kind=1), dimension(:), pointer :: x => null() !< Wrapped array
  end type logical1_1d
  !> @brief Wrapper for a reallocatable 1D array of 2 byte logical.
  type :: logical2_1d
     logical(kind=2), dimension(:), pointer :: x => null() !< Wrapped array
  end type logical2_1d
  !> @brief Wrapper for a reallocatable 1D array of 4 byte logical.
  type :: logical4_1d
     logical(kind=4), dimension(:), pointer :: x => null() !< Wrapped array
  end type logical4_1d
  !> @brief Wrapper for a reallocatable 1D array of 8 byte logical.
  type :: logical8_1d
     logical(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
  end type logical8_1d
  !> @brief Wrapper for a reallocatable 1D array of character arrays.
  type :: character_1d
     type(yggchar_r), dimension(:), pointer :: x => null() !< Wrapped array
  end type character_1d
  !> @brief Wrapper for a reallocatable ND array of 1 byte unsigned integer.
  type :: unsigned1_nd
     integer(kind=1), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type unsigned1_nd
  !> @brief Wrapper for a reallocatable ND array of 2 byte unsigned integer.
  type :: unsigned2_nd
     integer(kind=2), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type unsigned2_nd
  !> @brief Wrapper for a reallocatable ND array of 4 byte unsigned integer.
  type :: unsigned4_nd
     integer(kind=4), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type unsigned4_nd
  !> @brief Wrapper for a reallocatable ND array of 8 byte unsigned integer.
  type :: unsigned8_nd
     integer(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type unsigned8_nd
  !> @brief Wrapper for a reallocatable ND array of c_long.
  type :: c_long_nd
     integer(kind=c_long), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type c_long_nd
  !> @brief Wrapper for a reallocatable ND array of integer.
  type :: integer_nd
     integer, dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type integer_nd
  !> @brief Wrapper for a reallocatable ND array of 2 byte integer.
  type :: integer2_nd
     integer(kind=2), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type integer2_nd
  !> @brief Wrapper for a reallocatable ND array of 4 byte integer.
  type :: integer4_nd
     integer(kind=4), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type integer4_nd
  !> @brief Wrapper for a reallocatable ND array of 8 byte integer.
  type :: integer8_nd
     integer(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type integer8_nd
  !> @brief Wrapper for a reallocatable ND array of real.
  type :: real_nd
     real, dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type real_nd
  !> @brief Wrapper for a reallocatable ND array of 4 byte real.
  type :: real4_nd
     real(kind=4), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type real4_nd
  !> @brief Wrapper for a reallocatable ND array of 8 byte real.
  type :: real8_nd
     real(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type real8_nd
#ifdef _WIN32
  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  !> @brief Wrapper for a reallocatable ND array of 16 byte real.
  type :: real16_nd
     real(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type real16_nd
  ! END DOXYGEN_SHOULD_SKIP_THIS
#else
  !> @brief Wrapper for a reallocatable ND array of 16 byte real.
  type :: real16_nd
     real(kind=16), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type real16_nd
#endif
  !> @brief Wrapper for a reallocatable ND array of complex.
  type :: complex_nd
     complex, dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type complex_nd
  !> @brief Wrapper for a reallocatable ND array of 4 byte complex.
  type :: complex4_nd
     complex(kind=4), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type complex4_nd
  !> @brief Wrapper for a reallocatable ND array of 8 byte complex.
  type :: complex8_nd
     complex(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type complex8_nd
#ifdef _WIN32
  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  !> @brief Wrapper for a reallocatable ND array of 16 byte complex.
  type :: complex16_nd
     complex(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type complex16_nd
  ! END DOXYGEN_SHOULD_SKIP_THIS
#else
  !> @brief Wrapper for a reallocatable ND array of 16 byte complex.
  type :: complex16_nd
     complex(kind=16), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type complex16_nd
#endif
  !> @brief Wrapper for a reallocatable ND array of logical.
  type :: logical_nd
     logical, dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type logical_nd
  !> @brief Wrapper for a reallocatable ND array of 1 byte logical.
  type :: logical1_nd
     logical(kind=1), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type logical1_nd
  !> @brief Wrapper for a reallocatable ND array of 2 byte logical.
  type :: logical2_nd
     logical(kind=2), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type logical2_nd
  !> @brief Wrapper for a reallocatable ND array of 4 byte logical.
  type :: logical4_nd
     logical(kind=4), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type logical4_nd
  !> @brief Wrapper for a reallocatable ND array of 8 byte logical.
  type :: logical8_nd
     logical(kind=8), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type logical8_nd
  !> @brief Wrapper for a reallocatable ND array of bytes.
  type :: bytes_nd
     character(len=:), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type bytes_nd
  !> @brief Wrapper for a reallocatable ND array of unicode.
  type :: unicode_nd
     character(kind=ucs4, len=:), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type unicode_nd
  !> @brief Wrapper for a reallocatable ND array of character arrays.
  type :: character_nd
     type(yggchar_r), dimension(:), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type character_nd
  !> @brief Wrapper for a reallocatable 2D array of 1 byte unsigned integer.
  type :: unsigned1_2d
     integer(kind=1), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type unsigned1_2d
  !> @brief Wrapper for a reallocatable 2D array of 2 byte unsigned integer.
  type :: unsigned2_2d
     integer(kind=2), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type unsigned2_2d
  !> @brief Wrapper for a reallocatable 2D array of 4 byte unsigned integer.
  type :: unsigned4_2d
     integer(kind=4), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type unsigned4_2d
  !> @brief Wrapper for a reallocatable 2D array of 8 byte unsigned integer.
  type :: unsigned8_2d
     integer(kind=8), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type unsigned8_2d
  !> @brief Wrapper for a reallocatable 2D array of c_long.
  type :: c_long_2d
     integer(kind=c_long), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type c_long_2d
  !> @brief Wrapper for a reallocatable 2D array of integer.
  type :: integer_2d
     integer, dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type integer_2d
  !> @brief Wrapper for a reallocatable 2D array of 2 byte integer.
  type :: integer2_2d
     integer(kind=2), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type integer2_2d
  !> @brief Wrapper for a reallocatable 2D array of 4 byte integer.
  type :: integer4_2d
     integer(kind=4), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type integer4_2d
  !> @brief Wrapper for a reallocatable 2D array of 8 byte integer.
  type :: integer8_2d
     integer(kind=8), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type integer8_2d
  !> @brief Wrapper for a reallocatable 2D array of real.
  type :: real_2d
     real, dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type real_2d
  !> @brief Wrapper for a reallocatable 2D array of 4 byte real.
  type :: real4_2d
     real(kind=4), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type real4_2d
  !> @brief Wrapper for a reallocatable 2D array of 8 byte real.
  type :: real8_2d
     real(kind=8), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type real8_2d
#ifdef _WIN32
  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  !> @brief Wrapper for a reallocatable 2D array of 16 byte real.
  type :: real16_2d
     real(kind=8), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type real16_2d
  ! END DOXYGEN_SHOULD_SKIP_THIS
#else
  !> @brief Wrapper for a reallocatable 2D array of 16 byte real.
  type :: real16_2d
     real(kind=16), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type real16_2d
#endif
  !> @brief Wrapper for a reallocatable 2D array of complex.
  type :: complex_2d
     complex, dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type complex_2d
  !> @brief Wrapper for a reallocatable 2D array of 4 byte complex.
  type :: complex4_2d
     complex(kind=4), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type complex4_2d
  !> @brief Wrapper for a reallocatable 2D array of 8 byte complex.
  type :: complex8_2d
     complex(kind=8), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type complex8_2d
#ifdef _WIN32
  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  !> @brief Wrapper for a reallocatable 2D array of 16 byte complex.
  type :: complex16_2d
     complex(kind=8), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type complex16_2d
  ! END DOXYGEN_SHOULD_SKIP_THIS
#else
  !> @brief Wrapper for a reallocatable 2D array of 16 byte complex.
  type :: complex16_2d
     complex(kind=16), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type complex16_2d
#endif
  !> @brief Wrapper for a reallocatable 2D array of logical.
  type :: logical_2d
     logical, dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type logical_2d
  !> @brief Wrapper for a reallocatable 2D array of 1 byte logical.
  type :: logical1_2d
     logical(kind=1), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type logical1_2d
  !> @brief Wrapper for a reallocatable 2D array of 2 byte logical.
  type :: logical2_2d
     logical(kind=2), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type logical2_2d
  !> @brief Wrapper for a reallocatable 2D array of 4 byte logical.
  type :: logical4_2d
     logical(kind=4), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type logical4_2d
  !> @brief Wrapper for a reallocatable 2D array of 8 byte logical.
  type :: logical8_2d
     logical(kind=8), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type logical8_2d
  !> @brief Wrapper for a reallocatable 2D array of character arrays.
  type :: character_2d
     type(yggchar_r), dimension(:, :), pointer :: x => null() !< Wrapped array
     integer(kind=c_size_t), dimension(:), pointer :: shape => null() !< Shape of the array
  end type character_2d
  !> @brief A wrapper for any scalar or array accessed via a C pointer.
  !>   Only some of the members will be used for each specific type.
  type :: yggptr
     character(len=15) :: type = "none" !< Type of data wrapped
     logical :: ndarray = .false. !< .true. if the data is an ND array
     logical :: array = .false. !< .true. if the data is an array
     logical :: alloc = .false. !< .true. if the memory was allocated
     integer(kind=8) :: len = 0 !< Length of an 1D array
     integer(kind=8) :: prec = 0 !< Precison of scalar/array elements
     integer(kind=8) :: ndim = 0 !< Number of dimensions in an ND array
     integer(kind=8) :: nbytes = 0 !< Number of bytes in the wrapped data
     integer(kind=8), dimension(:), pointer :: shape => null() !< Shape of an ND array
     type(c_ptr) :: ptr = c_null_ptr !< C pointer to data
     class(*), pointer :: item => null() !< Fortran pointer to scalar data
     class(*), dimension(:), pointer :: item_array => null() !< Fortran pointer to 1D array
     class(*), dimension(:, :), pointer :: item_array_2d => null() !< Fortran pointer to 2D array
     class(*), dimension(:, :, :), pointer :: item_array_3d => null() !< Fortran pointer to 3D array
     character, dimension(:), pointer :: data_character_unit => null() !< Fortran pointer to array of characters
     character(kind=ucs4), dimension(:), &
          pointer :: data_unicode_unit => null() !< Fortran array to array of unicode characters
     integer(kind=c_size_t), pointer :: len_c => null() !< C variable for storing array length
     integer(kind=c_size_t), pointer :: prec_c => null() !< C variable for storing precision
     integer(kind=c_size_t), pointer :: ndim_c => null() !< C variable for storing number of array dimensions
     integer(kind=c_size_t), dimension(:), pointer :: shape_c => null() !< C variable for storing the array shape
     type(c_ptr) :: len_ptr = c_null_ptr !< C pointer to len_c variable
     type(c_ptr) :: prec_ptr = c_null_ptr !< C pointer to prec_c variable
     type(c_ptr) :: ndim_ptr = c_null_ptr !< C pointer to ndim_c variable
     type(c_ptr) :: shape_ptr = c_null_ptr !< C pointer to shape_c variable
  end type yggptr
  !> @brief Wrapper to a reallocatable array of pointers.
  type :: yggptr_arr
     type(yggptr), dimension(:), pointer :: vals => null() !< Wrapped array
  end type yggptr_arr
  !> @brief Wrapper to a reallocatable map of pointers.
  type :: yggptr_map
     character(len=20), dimension(:), pointer :: keys => null() !< Keys in the wrapped object
     type(yggptr), dimension(:), pointer :: vals => null() !< Values in the wrapped object
  end type yggptr_map
  !> @brief Wrapper for a C generic object.
  type, bind(c) :: ygggeneric
     character(kind=c_char) :: prefix !< Character used to identify generic objects
     type(c_ptr) :: obj !< Pointer to C generic object
  end type ygggeneric
  !> @brief Wrapper for C NULL object.
  type :: yggnull
     type(c_ptr) :: ptr = c_null_ptr !< C NULL object
   ! contains
   !   procedure :: write_null
   !   generic :: write(formatted) => write_null
  end type yggnull
  !> @brief Wrapper for an array of generic objects (stored in a generic object).
  type, bind(c) :: yggarr
     character(kind=c_char) :: prefix !< Character used to identify generic objects
     type(c_ptr) :: obj !< Pointer to wrapped array.
  end type yggarr
  !> @brief Wrapper for a mapping of generic objects (stored in a generic object).
  type, bind(c) :: yggmap
     character(kind=c_char) :: prefix !< Character used to identify generic objects
     type(c_ptr) :: obj !< Pointer to wrapped mapping.
  end type yggmap
  !> @brief Wrapper for a schema (stored in a generic object).
  type, bind(c) :: yggschema
     character(kind=c_char) :: prefix !< Character used to identify generic objects
     type(c_ptr) :: obj !< Pointer to wrapped schema.
  end type yggschema
  !> @brief  Wrapper for a Python instance (stored in a generic object).
  type, bind(c) :: yggpyinst
     character(kind=c_char) :: prefix !< Character used to identify generic objects
     type(c_ptr) :: obj !< Pointer to wrapped Python instance.
  end type yggpyinst
  !> @brief Wrapper for a Python function.
  type, bind(c) :: yggpyfunc
     character(kind=c_char), dimension(1000) :: name = c_null_char !< Name of the Python function.
     type(c_ptr) :: args = c_null_ptr !< Arguments used to construct the Python object (unused).
     type(c_ptr) :: kwargs = c_null_ptr !< Keyword arguments used to construct the Python object (unused).
     type(c_ptr) :: obj = c_null_ptr !< Python object.
  end type yggpyfunc
  !> @brief Wrapper for a Python object.
  type, bind(c) :: yggpython
     character(kind=c_char), dimension(1000) :: name = c_null_char !< Name of the Python class.
     type(c_ptr) :: args = c_null_ptr !< Arguments used to construct the Python object.
     type(c_ptr) :: kwargs = c_null_ptr !< Keyword arguments used to construct the Python object.
     type(c_ptr) :: obj = c_null_ptr !< Python object.
  end type yggpython
  !> @brief Ply structure.
  type, bind(c) :: yggply
     character(kind=c_char), dimension(100) :: material !< Name of material.
     integer(kind=c_int) :: nvert !< Number of vertices.
     integer(kind=c_int) :: nface !< Number of faces.
     integer(kind=c_int) :: nedge !< Number of edges.
     type(c_ptr) :: c_vertices !< X, Y, Z positions of vertices.
     type(c_ptr) :: c_faces !< Indices of the vertices composing each face.
     type(c_ptr) :: c_edges !< Indices of the vertices composing each edge.
     type(c_ptr) :: c_vertex_colors !< RGB colors of each vertex.
     type(c_ptr) :: c_edge_colors !< RGB colors of each edge.
     type(c_ptr) :: c_nvert_in_face !< Number of vertices in each face.
  end type yggply
  !> @brief Obj structure.
  type, bind(c) :: yggobj
     character(kind=c_char), dimension(100) :: material !< Material that should be used for faces.
     integer(kind=c_int) :: nvert !< Material that should be used for faces.
     integer(kind=c_int) :: ntexc !< Number of vertices.
     integer(kind=c_int) :: nnorm !< Number of texture coordinates.
     integer(kind=c_int) :: nparam !< Number of normals.
     integer(kind=c_int) :: npoint !< Number of points.
     integer(kind=c_int) :: nline !< Number of lines.
     integer(kind=c_int) :: nface !< Number of faces.
     integer(kind=c_int) :: ncurve !< Number of curves.
     integer(kind=c_int) :: ncurve2 !< Number of curv2.
     integer(kind=c_int) :: nsurf !< Number of surfaces.
     type(c_ptr) :: c_vertices !< X, Y, Z positions of vertices.
     type(c_ptr) :: c_vertex_colors !< RGB colors of each vertex.
     type(c_ptr) :: c_texcoords !< Texture coordinates.
     type(c_ptr) :: c_normals !< X, Y, Z direction of normals.
     type(c_ptr) :: c_params !< U, V, W directions of params.
     type(c_ptr) :: c_points !< Sets of one or more vertex indices.
     type(c_ptr) :: c_nvert_in_point !< Number of vertex indices in each point set.
     type(c_ptr) :: c_lines !< Indices of the vertices composing each line.
     type(c_ptr) :: c_nvert_in_line !< Number of vertex indices in each line.
     type(c_ptr) :: c_line_texcoords !< Indices of texcoords for each line vertex.
     type(c_ptr) :: c_faces !< Indices of the vertices composing each face.
     type(c_ptr) :: c_nvert_in_face !< Number of vertex indices in each face.
     type(c_ptr) :: c_face_texcoords !< Indices of texcoords for each face vertex.
     type(c_ptr) :: c_face_normals !< Indices of normals for each face vertex.
     type(c_ptr) :: c_curves !< Indices of control point vertices for each curve.
     type(c_ptr) :: c_curve_params !< Starting and ending parameters for each curve.
     type(c_ptr) :: c_nvert_in_curve !< Number of vertex indices in each curve.
     type(c_ptr) :: c_curves2 !< Indices of control parameters for each curve.
     type(c_ptr) :: c_nparam_in_curve2 !< Number of parameter indices in each curve.
     type(c_ptr) :: c_surfaces !< Indices of control point vertices for each surface.
     type(c_ptr) :: c_nvert_in_surface !< Number of vertices in each surface.
     type(c_ptr) :: c_surface_params_u !< Starting and ending parameters for each curve in the u direction.
     type(c_ptr) :: c_surface_params_v !< Starting and ending parameters for each curve in the v direction.
     type(c_ptr) :: c_surface_texcoords !< Indices of texcoords for each surface vertex.
     type(c_ptr) :: c_surface_normals !< Indices of normals for each surface vertex.
  end type yggobj
  !> @brief Wrapper for a 1 byte unsigned integer.
  type ygguint1
     integer(kind=1) :: x !< Wrapped scalar
  end type ygguint1
  !> @brief Wrapper for a 2 byte unsigned integer.
  type ygguint2
     integer(kind=2) :: x !< Wrapped scalar
  end type ygguint2
  !> @brief Wrapper for a 4 byte unsigned integer.
  type ygguint4
     integer(kind=4) :: x !< Wrapped scalar
  end type ygguint4
  !> @brief Wrapper for a 8 byte unsigned integer.
  type ygguint8
     integer(kind=8) :: x !< Wrapped scalar
  end type ygguint8

  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  interface assignment(=)
     module procedure ygguint1_assign
     module procedure ygguint2_assign
     module procedure ygguint4_assign
     module procedure ygguint8_assign
  end interface assignment(=)

  public :: yggarg, yggchar_r, yggcomm, ygggeneric, &
       yggptr, yggnull, yggarr, yggmap, &
       yggschema, yggpython, yggply, yggobj, yggpyinst, yggpyfunc, &
       LINE_SIZE_MAX
  ! END DOXYGEN_SHOULD_SKIP_THIS

  include "YggInterface_cdef.f90"

#define WITH_GLOBAL_SCOPE(COMM) call set_global_comm(); COMM; call unset_global_comm()

contains

  ! include "YggInterface_copy.f90"
  include "YggInterface_realloc.f90"
  include "YggInterface_c2f.f90"
  include "YggInterface_arg.f90"
  include "YggInterface_conv.f90"
  include "YggInterface_assign.f90"
  include "YggInterface_array.f90"
  include "YggInterface_map.f90"

  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  subroutine ygguint1_assign(self, other)
    type(ygguint1), intent(inout) :: self
    integer, intent(in) :: other
    self%x = int(other, kind=1)
  end subroutine ygguint1_assign
  subroutine ygguint2_assign(self, other)
    type(ygguint2), intent(inout) :: self
    integer, intent(in) :: other
    self%x = int(other, kind=2)
  end subroutine ygguint2_assign
  subroutine ygguint4_assign(self, other)
    type(ygguint4), intent(inout) :: self
    integer, intent(in) :: other
    self%x = int(other, kind=4)
  end subroutine ygguint4_assign
  subroutine ygguint8_assign(self, other)
    type(ygguint8), intent(inout) :: self
    integer, intent(in) :: other
    self%x = int(other, kind=8)
  end subroutine ygguint8_assign
  ! END DOXYGEN_SHOULD_SKIP_THIS


#ifndef _WIN32
  function yggarg_scalar_real16(x) result (y)
    type(yggptr) :: y
    real(kind=16), target :: x
    real(kind=16), pointer :: xp
    y = yggarg_scalar_init(x)
    xp => x
    y%type = "real"
    y%ptr = c_loc(xp)
    y%nbytes = 16
  end function yggarg_scalar_real16
  function yggarg_scalar_complex16(x) result (y)
    type(yggptr) :: y
    complex(kind=16), target :: x
    complex(kind=16), pointer :: xp
    y = yggarg_scalar_init(x)
    xp => x
    y%type = "complex"
    y%ptr = c_loc(xp)
    y%nbytes = 16 * 2
  end function yggarg_scalar_complex16
  function yggarg_1darray_real16(x, x_shape) result (y)
    real(kind=16), dimension(:), target :: x
    real(kind=16), dimension(:), pointer :: xp
    integer, dimension(:), optional :: x_shape
    type(yggptr) :: y
    xp => x
    if (present(x_shape)) then
       y = yggarg_ndarray_init(x, x_shape)
    else
       y = yggarg_ndarray_init(x)
    end if
    y%type = "real"
    y%ptr = c_loc(xp(1))
  end function yggarg_1darray_real16
  function yggarg_1darray_complex16(x, x_shape) result (y)
    complex(kind=16), dimension(:), target :: x
    complex(kind=16), dimension(:), pointer :: xp
    integer, dimension(:), optional :: x_shape
    type(yggptr) :: y
    xp => x
    if (present(x_shape)) then
       y = yggarg_ndarray_init(x, x_shape)
    else
       y = yggarg_ndarray_init(x)
    end if
    y%type = "complex"
    y%ptr = c_loc(xp(1))
  end function yggarg_1darray_complex16
  ! function yggarg_1darray_real16(x) result (y)
  !   real(kind=16), dimension(:), target :: x
  !   real(kind=16), dimension(:), pointer :: xp
  !   type(yggptr) :: y
  !   xp => x
  !   y = yggarg_ndarray_init(x)
  !   y%type = "real"
  !   y%ptr = c_loc(xp(1))
  ! end function yggarg_1darray_real16
  ! function yggarg_1darray_complex16(x) result (y)
  !   complex(kind=16), dimension(:), target :: x
  !   complex(kind=16), dimension(:), pointer :: xp
  !   type(yggptr) :: y
  !   xp => x
  !   y = yggarg_ndarray_init(x)
  !   y%type = "complex"
  !   y%ptr = c_loc(xp(1))
  ! end function yggarg_1darray_complex16
  function yggarg_2darray_real16(x) result (y)
    real(kind=16), dimension(:, :), target :: x
    real(kind=16), dimension(:), pointer :: xp
    type(yggptr) :: y
    allocate(xp(size(x)))
    xp = reshape(x, [size(x)])
    y = yggarg(xp, shape(x))
    call yggarg_2darray_init(y, x)
  end function yggarg_2darray_real16
  function yggarg_2darray_complex16(x) result (y)
    complex(kind=16), dimension(:, :), target :: x
    complex(kind=16), dimension(:), pointer :: xp
    type(yggptr) :: y
    allocate(xp(size(x)))
    xp = reshape(x, [size(x)])
    y = yggarg(xp, shape(x))
    call yggarg_2darray_init(y, x)
  end function yggarg_2darray_complex16
#endif
  
  ! Utilities
  function init_ygguint1(x) result(y)
    integer(kind=1) :: x
    type(ygguint1) :: y
    y%x = x
    if (y%x.lt.0) stop "Unsigned int cannot be less than 0."
  end function init_ygguint1
  function init_ygguint2(x) result(y)
    integer(kind=2) :: x
    type(ygguint2) :: y
    y%x = x
    if (y%x.lt.0) stop "Unsigned int cannot be less than 0."
  end function init_ygguint2
  function init_ygguint4(x) result(y)
    integer(kind=4) :: x
    type(ygguint4) :: y
    y%x = x
    if (y%x.lt.0) stop "Unsigned int cannot be less than 0."
  end function init_ygguint4
  function init_ygguint8(x) result(y)
    integer(kind=8) :: x
    type(ygguint8) :: y
    y%x = x
    if (y%x.lt.0) stop "Unsigned int cannot be less than 0."
  end function init_ygguint8
  !> @brief Display a null object (for completeness).
  !> @param[in] x Instance to display.
  subroutine display_null(x)
    class(yggnull), intent(in) :: x
    write (*, '("NULL")')
  end subroutine display_null
  ! subroutine write_null(dtv, unit, iotype, v_list, iostat, iomsg)
  !   ! Argument names here from the std, but you can name them differently.
  !   class(yggnull), intent(in) :: dtv   ! Object to write.
  !   integer, intent(in) :: unit         ! Internal unit to write to.
  !   character(*), intent(in) :: iotype  ! LISTDIRECTED or DTxxx
  !   integer, intent(in) :: v_list(:)    ! parameters from fmt spec.
  !   integer, intent(out) :: iostat      ! non zero on error, etc.
  !   character(*), intent(inout) :: iomsg  ! define if iostat non zero.
  !   write (unit, '("NULL")', IOSTAT=iostat, IOMSG=iomsg)
  ! end subroutine write_null
  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  subroutine fix_format_str(x)
    implicit none
    character(len=*) :: x
    integer :: i, length
    length = len(x)
    i = index(x, "\t")
    do while (i.ne.0)
       x(i:i) = char(9)
       x((i+1):length) = x((i+2):length)
       length = len(x)
       i = index(x, "\t")
    end do
    i = index(x, "\n")
    do while (i.ne.0)
       x(i:i) = NEW_LINE('c')
       x((i+1):length) = x((i+2):length)
       length = len(x)
       i = index(x, "\n")
    end do
  end subroutine fix_format_str
  ! END DOXYGEN_SHOULD_SKIP_THIS

  ! YggInterface

  ! Utilities
  function ygg_init() result(out)
    implicit none
    logical :: out
    integer(kind=c_int) :: c_out
    c_out = ygg_init_c()
    if (c_out.eq.0) then
       out = .true.
    else
       out = .false.
    end if
  end function ygg_init
  !> @brief Write a log message at the INFO level.
  !> @param[in] fmt Log message.
  subroutine ygglog_info(fmt)
    implicit none
    character(len=*), intent(in) :: fmt
    character(len=len_trim(fmt)+1) :: c_fmt
    c_fmt = trim(fmt)//c_null_char
    call ygglog_info_c(c_fmt)
  end subroutine ygglog_info
  !> @brief Write a log message at the DEBUG level.
  !> @param[in] fmt Log message.
  subroutine ygglog_debug(fmt)
    implicit none
    character(len=*), intent(in) :: fmt
    character(len=len_trim(fmt)+1) :: c_fmt
    c_fmt = trim(fmt)//c_null_char
    call ygglog_debug_c(c_fmt)
  end subroutine ygglog_debug
  !> @brief Write a log message at the ERROR level. This will also cause
  !>   the calling model to return an error code on exit.
  !> @param[in] fmt Log message.
  subroutine ygglog_error(fmt)
    implicit none
    character(len=*), intent(in) :: fmt
    character(len=len_trim(fmt)+1) :: c_fmt
    c_fmt = trim(fmt)//c_null_char
    call ygglog_error_c(c_fmt)
  end subroutine ygglog_error

  ! Methods for initializing channels
  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  function is_comm_format_array_type(x, args) result(out)
    implicit none
    type(yggcomm), intent(in) :: x
    type(yggptr) :: args(:)
    logical :: out
    integer(c_int) :: c_out
    integer :: i
    c_out = is_comm_format_array_type_c(x%comm)
    if (c_out.eq.0) then
       out = .false.
    else if (c_out.eq.1) then
       out = .true.
    else if (size(args).eq.1) then
       out = .false.
    else
       out = .true.
       do i = 2, size(args)
          if (.not.args(i)%array) then
             out = .false.
             exit
          end if
       end do
       if ((out).and.(.not.((args(1)%array).or.(is_size_t(args(1)))))) then
          out = .false.
       end if
       ! stop "is_comm_format_array_type: Error checking type."
    end if
  end function is_comm_format_array_type
  ! END DOXYGEN_SHOULD_SKIP_THIS
  
  !> @brief Constructor for an output comm.
  !>   Create a yggcomm structure for an output channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an
  !>   environment variable.
  !> @param[in] name Name of the channel.
  !> @returns Output comm structure.
  function ygg_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_output_c(c_name)
  end function ygg_output
  
  !> @brief Constructor for an input comm.
  !>   Create a yggcomm structure for an input channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable.
  !> @param[in] name Name of the channel.
  !> @returns Input comm structure.
  function ygg_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_input_c(c_name)
  end function ygg_input

  !> @brief Constructor for an output comm that will send a specific data 
  !>   type. Create a yggcomm structure for an output channel based on a 
  !>   provided name that is used to locate a particular comm address stored 
  !>   in an environment variable and a structure defining the datatype of
  !>   outgoing messages.
  !> @param[in] name Name of the channel.
  !> @param[in] datatype Data structure containing type information.
  !> @returns Output comm structure.
  function ygg_output_type(name, datatype) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    type(yggdtype) :: datatype
    character(len=len_trim(name)+1) :: c_name
    type(c_ptr) :: c_datatype
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_datatype = datatype%ptr
    channel%comm = ygg_output_type_c(c_name, c_datatype)
  end function ygg_output_type
  
  !> @brief Constructor for an input comm that will receive a specific data 
  !>   type. Create a yggcomm structure for an input channel based on a 
  !>   provided name that is used to locate a particular comm address stored 
  !>   in an environment variable and a structure defining the datatype of
  !>   incoming messages.
  !> @param[in] name Name of the channel.
  !> @param[in] datatype Data structure containing type information.
  !> @returns Input comm structure.
  function ygg_input_type(name, datatype) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    type(yggdtype) :: datatype
    character(len=len_trim(name)+1) :: c_name
    type(c_ptr) :: c_datatype
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_datatype = datatype%ptr
    channel%comm = ygg_input_type_c(c_name, c_datatype)
  end function ygg_input_type
  
  !> @brief Constructor for an output comm with a type specified via a 
  !>   C-style format string. Create a yggcomm structure for an output 
  !>   channel based on a provided name that is used to locate a particular 
  !>   comm address stored in an environment variable and a format string.
  !> @param[in] name Name of the channel.
  !> @param[in] fmt C-style format string that should be used to determine the
  !>   type of data that will be sent.
  !> @returns Output comm structure.
  function ygg_output_fmt(name, fmt) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: fmt
    character(len=len_trim(name)+1) :: c_name
    character(len=len_trim(fmt)+1) :: c_fmt
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_fmt = trim(fmt)//c_null_char
    call fix_format_str(c_fmt)
    channel%comm = ygg_output_fmt_c(c_name, c_fmt)
  end function ygg_output_fmt
  
  !> @brief Constructor for an input comm with a type specified via a C-style 
  !>   format string. Create a yggcomm structure for an input channel based 
  !>   on a provided name that is used to locate a particular comm address 
  !>   stored in an environment variable and a format string.
  !> @param[in] name Name of the channel.
  !> @param[in] fmt C-style format string that should be used to determine the
  !>   type of data that will be received.
  !> @returns Input comm structure.
  function ygg_input_fmt(name, fmt) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: fmt
    character(len=len_trim(name)+1) :: c_name
    character(len=len_trim(fmt)+1) :: c_fmt
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_fmt = trim(fmt)//c_null_char
    call fix_format_str(c_fmt)
    channel%comm = ygg_input_fmt_c(c_name, c_fmt)
  end function ygg_input_fmt
  
  !> @brief Constructor for an ASCII file output comm.
  !>   Create a yggcomm structure for an output channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable. This type of comm sends string output
  !>   line-by-line.
  !> @param[in] name Name of the channel.
  !> @returns Output comm structure.
  function ygg_ascii_file_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ascii_file_output_c(c_name)
  end function ygg_ascii_file_output
  
  !> @brief Constructor for an ASCII file input comm.
  !>   Create a yggcomm structure for an input channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable. This type of comm receives string input
  !>   line-by-line.
  !> @param[in] name Name of the channel.
  !> @returns Input comm structure.
  function ygg_ascii_file_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ascii_file_input_c(c_name)
  end function ygg_ascii_file_input
  
  !> @brief Constructor for an ASCII table output comm.
  !>   Create a yggcomm structure for an output channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable and a format string. This type of comm outputs 
  !>   table rows one at a time and formats them using the provided
  !>   format_str.
  !> @param[in] name Name of the channel.
  !> @param[in] format_str C-style format string that should be used to format
  !>   table rows.
  !> @returns Output comm structure.
  function ygg_ascii_table_output(name, format_str) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: format_str
    character(len=len_trim(name)+1) :: c_name
    character(len=len_trim(format_str)+1) :: c_format_str
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_format_str = trim(format_str)//c_null_char
    call fix_format_str(c_format_str)
    channel%comm = ygg_ascii_table_output_c(c_name, c_format_str)
  end function ygg_ascii_table_output
  
  !> @brief Constructor for an ASCII table input comm.
  !>   Create a yggcomm structure for an input channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable and a format string. This type of comm receives 
  !>   table rows one at a time.
  !> @param[in] name Name of the channel.
  !> @returns Input comm structure.
  function ygg_ascii_table_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ascii_table_input_c(c_name)
  end function ygg_ascii_table_input
  
  !> @brief Constructor for an ASCII table array output comm.
  !>   Create a yggcomm structure for an output channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable and a format string. This type of comm outputs 
  !>   table columns as arrays and formats rows using the provided format_str.
  !> @param[in] name Name of the channel.
  !> @param[in] format_str C-style format string that should be used to format
  !>   table rows.
  !> @returns Output comm structure.
  function ygg_ascii_array_output(name, format_str) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: format_str
    character(len=len_trim(name)+1) :: c_name
    character(len=len_trim(format_str)+1) :: c_format_str
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_format_str = trim(format_str)//c_null_char
    call fix_format_str(c_format_str)
    channel%comm = ygg_ascii_array_output_c(c_name, c_format_str)
  end function ygg_ascii_array_output
  
  !> @brief Constructor for an ASCII table array input comm.
  !>   Create a yggcomm structure for an input channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable and a format string. This type of comm receives 
  !>   table columns as arrays.
  !> @param[in] name Name of the channel.
  !> @returns Input comm structure.
  function ygg_ascii_array_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ascii_array_input_c(c_name)
  end function ygg_ascii_array_input
  
  !> @brief Constructor for an output comm that sends Ply data.
  !>   Create a yggcomm structure for an output channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable. This type of comm only sends Ply data
  !>   contained in yggply structures.
  !> @param[in] name Name of the channel.
  !> @returns Output comm structure.
  function ygg_ply_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ply_output_c(c_name)
  end function ygg_ply_output
  
  !> @brief Constructor for an input comm that receives Ply data.
  !>   Create a yggcomm structure for an input channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an
  !>   environment variable. This type of comm only receives Ply data into
  !>   yggply structures.
  !> @param[in] name Name of the channel.
  !> @returns Input comm structure.
  function ygg_ply_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ply_input_c(c_name)
  end function ygg_ply_input
  
  !> @brief Constructor for an output comm that sends Obj data.
  !>   Create a yggcomm structure for an output channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable. This type of comm only sends Obj data contained
  !>   in yggobj structures.
  !> @param[in] name Name of the channel.
  !> @returns Output comm structure.
  function ygg_obj_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_obj_output_c(c_name)
  end function ygg_obj_output
  
  !> @brief Constructor for an input comm that receives Obj data.
  !>   Create a yggcomm structure for an input channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable. This type of comm only receives Obj data into
  !>   yggobj structures.
  !> @param[in] name Name of the channel.
  !> @returns Input comm structure.
  function ygg_obj_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_obj_input_c(c_name)
  end function ygg_obj_input

  !> @brief Constructor for an output comm that sends generic data.
  !>   Create a yggcomm structure for an output channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable. This type of comm can send any type of data as 
  !>   long as it is wrapped in an ygggeneric structure.
  !> @param[in] name Name of the channel.
  !> @returns Output comm structure.
  function ygg_generic_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_generic_output_c(c_name)
  end function ygg_generic_output
  
  !> @brief Constructor for an input comm that receives generic data.
  !>   Create a yggcomm structure for an input channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable. This type of comm can receive any type of data 
  !>   into an ygggeneric structure.
  !> @param[in] name Name of the channel.
  !> @returns Input comm structure.
  function ygg_generic_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_generic_input_c(c_name)
  end function ygg_generic_input

  !> @brief Constructor for an output comm that sends generic data.
  !>   Create a yggcomm structure for an output channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable. This type of comm can send any type of data as 
  !>   long as it is wrapped in an ygggeneric structure.
  !> @param[in] name Name of the channel.
  !> @returns Output comm structure.
  function ygg_any_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_any_output_c(c_name)
  end function ygg_any_output
  
  !> @brief Constructor for an input comm that receives generic data.
  !>   Create a yggcomm structure for an input channel based on a provided 
  !>   name that is used to locate a particular comm address stored in an 
  !>   environment variable. This type of comm can receive any type of data 
  !>   into an ygggeneric structure.
  !> @param[in] name Name of the channel.
  !> @returns Input comm structure.
  function ygg_any_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_any_input_c(c_name)
  end function ygg_any_input

  !> @brief Constructor for an output comm that sends JSON arrays of generic
  !>   data. Create a yggcomm structure for an output channel based on a 
  !>   provided name that is used to locate a particular comm address stored 
  !>   in an environment variable. This type of comm can send any type of 
  !>   data as long as it is wrapped in an ygggeneric structure.
  !> @param[in] name Name of the channel.
  !> @returns Output comm structure.
  function ygg_json_array_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_json_array_output_c(c_name)
  end function ygg_json_array_output
  
  !> @brief Constructor for an input comm that receives JSON arrays of 
  !>   generic data. Create a yggcomm structure for an input channel based on 
  !>   a provided name that is used to locate a particular comm address stored
  !>   in an environment variable. This type of comm can receive any type of
  !>   data into an ygggeneric structure.
  !> @param[in] name Name of the channel.
  !> @returns Input comm structure.
  function ygg_json_array_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_json_array_input_c(c_name)
  end function ygg_json_array_input

  !> @brief Constructor for an output comm that sends JSON objects of generic 
  !>   data. Create a yggcomm structure for an output channel based on a 
  !>   provided name that is used to locate a particular comm address stored 
  !>   in an environment variable. This type of comm can send any type of 
  !>   data as long as it is wrapped in an ygggeneric structure.
  !> @param[in] name Name of the channel.
  !> @returns Output comm structure.
  function ygg_json_object_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_json_object_output_c(c_name)
  end function ygg_json_object_output
  
  !> @brief Constructor for an input comm that receives JSON objects of 
  !>   generic data. Create a yggcomm structure for an input channel based on 
  !>   a provided name that is used to locate a particular comm address 
  !>   stored in an environment variable. This type of comm can receive any
  !>   type of data into an ygggeneric structure.
  !> @param[in] name Name of the channel.
  !> @returns Input comm structure.
  function ygg_json_object_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_json_object_input_c(c_name)
  end function ygg_json_object_input

  !> @brief Constructor for a client-side RPC comm.
  !>   Create a yggcomm structure for the client side of an RPC channel based
  !>   on a provided name that is used to locate a particular comm address
  !>   stored in an environment variable. Types can be specified by format
  !>   strings.
  !> @param[in] name Name of the channel.
  !> @param[in] out_fmt_in C-style format string defining how client requests
  !>   (outgoing messages) should be formatted.
  !> @param[in] in_fmt_in C-style format string defining how client responses
  !>   (incoming messages) should be parsed.
  !> @returns Client comm structure.
  function ygg_rpc_client(name, out_fmt_in, in_fmt_in) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in), optional :: out_fmt_in
    character(len=*), intent(in), optional :: in_fmt_in
    character(len=:), allocatable :: out_fmt
    character(len=:), allocatable :: in_fmt
    character(len=len_trim(name)+1) :: c_name
    character(len=:), allocatable :: c_out_fmt
    character(len=:), allocatable :: c_in_fmt
    type(yggcomm) :: channel
    if (present(out_fmt_in)) then
       out_fmt = out_fmt_in
    else
       out_fmt = "%s"
    end if
    if (present(in_fmt_in)) then
       in_fmt = in_fmt_in
    else
       in_fmt = "%s"
    end if
    allocate(character(len=len_trim(in_fmt)+1) :: c_in_fmt)
    allocate(character(len=len_trim(out_fmt)+1) :: c_out_fmt)
    c_name = trim(name)//c_null_char
    c_out_fmt = trim(out_fmt)//c_null_char
    c_in_fmt = trim(in_fmt)//c_null_char
    call fix_format_str(c_out_fmt)
    call fix_format_str(c_in_fmt)
    channel%comm = ygg_rpc_client_c(c_name, c_out_fmt, c_in_fmt)
  end function ygg_rpc_client

  !> @brief Constructor for a server-side RPC comm.
  !>   Create a yggcomm structure for the server side of an RPC channel based
  !>   on a provided name that is used to locate a particular comm address
  !>   stored in an environment variable. Types can be specified by format
  !>   strings.
  !> @param[in] name Name of the channel.
  !> @param[in] in_fmt_in C-style format string defining how requests
  !>   (incoming messages) should be parsed.
  !> @param[in] out_fmt_in C-style format string defining how responses
  !>   (outgoing messages) should be formatted.
  !> @returns Server comm structure.
  function ygg_rpc_server(name, in_fmt_in, out_fmt_in) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in), optional :: in_fmt_in
    character(len=*), intent(in), optional :: out_fmt_in
    character(len=:), allocatable :: in_fmt
    character(len=:), allocatable :: out_fmt
    character(len=len_trim(name)+1) :: c_name
    character(len=:), allocatable :: c_in_fmt
    character(len=:), allocatable :: c_out_fmt
    type(yggcomm) :: channel
    if (present(in_fmt_in)) then
       in_fmt = in_fmt_in
    else
       in_fmt = "%s"
    end if
    if (present(out_fmt_in)) then
       out_fmt = out_fmt_in
    else
       out_fmt = "%s"
    end if
    allocate(character(len=len_trim(in_fmt)+1) :: c_in_fmt)
    allocate(character(len=len_trim(out_fmt)+1) :: c_out_fmt)
    c_name = trim(name)//c_null_char
    c_in_fmt = trim(in_fmt)//c_null_char
    c_out_fmt = trim(out_fmt)//c_null_char
    call fix_format_str(c_in_fmt)
    call fix_format_str(c_out_fmt)
    channel%comm = ygg_rpc_server_c(c_name, c_in_fmt, c_out_fmt)
  end function ygg_rpc_server

  !> @brief Constructor for a client-side RPC comm with explicit datatypes.
  !>   Create a yggcomm structure for the client side of an RPC channel based
  !>   on a provided name that is used to locate a particular comm address
  !>   stored in an environment variable. Types can be specified by datatype
  !>   structures.
  !> @param[in] name Name of the channel.
  !> @param[in] out_type_in Datatype structure containing information on
  !>   the type of data that requests (outgoing messages) will contain.
  !> @param[in] in_type_in Datatype structure containing information on
  !>   the type of data that responses (incoming messages) will contain.
  !> @returns Client comm structure.
  function ygg_rpc_client_type(name, out_type_in, in_type_in) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    type(yggdtype), optional :: out_type_in
    type(yggdtype), optional :: in_type_in
    type(c_ptr) :: c_out_type
    type(c_ptr) :: c_in_type
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    if (present(out_type_in)) then
       c_out_type = out_type_in%ptr
    else
       c_out_type = c_null_ptr
    end if
    if (present(in_type_in)) then
       c_in_type = in_type_in%ptr
    else
       c_in_type = c_null_ptr
    end if
    c_name = trim(name)//c_null_char
    channel%comm = ygg_rpc_client_type_c(c_name, c_out_type, c_in_type)
  end function ygg_rpc_client_type

  !> @brief Constructor for a server-side RPC comm with explicit datatypes.
  !>   Create a yggcomm structure for the server side of an RPC channel based
  !>   on a provided name that is used to locate a particular comm address
  !>   stored in an environment variable. Types can be specified by datatype
  !>   structures.
  !> @param[in] name Name of the channel.
  !> @param[in] in_type_in Datatype structure containing information on
  !>   the type of data that requests (incoming messages) will contain.
  !> @param[in] out_type_in Datatype structure containing information on
  !>   the type of data that responses (outgoing messages) will contain.
  !> @returns Server comm structure.
  function ygg_rpc_server_type(name, in_type_in, out_type_in) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    type(yggdtype), optional :: in_type_in
    type(yggdtype), optional :: out_type_in
    type(c_ptr) :: c_in_type
    type(c_ptr) :: c_out_type
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    if (present(in_type_in)) then
       c_in_type = in_type_in%ptr
    else
       c_in_type = c_null_ptr
    end if
    if (present(out_type_in)) then
       c_out_type = out_type_in%ptr
    else
       c_out_type = c_null_ptr
    end if
    c_name = trim(name)//c_null_char
    channel%comm = ygg_rpc_server_type_c(c_name, c_in_type, c_out_type)
  end function ygg_rpc_server_type

  !> @brief Constructor for a timesync comm.
  !>   Create a yggcomm structure for a timesync channel based 
  !>   on a provided name that is used to locate a particular comm address
  !>   stored in an environment variable.
  !> @param[in] name Name of the channel.
  !> @param[in] units Units that outgoing time steps will be in.
  !> @returns Timesync comm structure.
  function ygg_timesync(name, units) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: units
    character(len=len_trim(name)+1) :: c_name
    character(len=len_trim(units)+1) :: c_units
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_units = trim(units)//c_null_char
    channel%comm = ygg_timesync_c(c_name, c_units)
  end function ygg_timesync

  ! Method for constructing data types
  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  function is_dtype_format_array(type_struct) result(out)
    implicit none
    type(yggdtype) :: type_struct
    logical :: out
    integer(kind=c_int) :: c_out
    c_out = is_dtype_format_array_c(type_struct%ptr)
    if (c_out.eq.0) then
       out = .false.
    else if (c_out.eq.1) then
       out = .true.
    else
       stop "is_dtype_format_array: Error checking data type"
    end if
  end function is_dtype_format_array
  ! END DOXYGEN_SHOULD_SKIP_THIS

  !> @brief Create an empty data type.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_empty(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_empty_c(logical(use_generic, kind=1))
  end function create_dtype_empty

  !> @brief Create a data type based on a Python dictionary.
  !> @param[in] pyobj A Python dictionary containing data type information.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_python(pyobj, use_generic) result(out)
    implicit none
    type(c_ptr) :: pyobj
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_python_c(pyobj, logical(use_generic, kind=1))
  end function create_dtype_python

  !> @brief Create a direct data type for handling byte messages.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_direct(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_direct_c(logical(use_generic, kind=1))
  end function create_dtype_direct

  !> @brief Create a data type for one of the simple JSON data types
  !>   (e.g. number, integer, string).
  !> @param[in] typename Name of the JSON data type that the type object
  !>   should be initialized for.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_default(typename, use_generic) result(out)
    implicit none
    character(len=*), intent(in) :: typename
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    character(len=len_trim(typename)+1) :: c_typename
    c_typename = trim(typename)//c_null_char
    out%ptr = create_dtype_default_c(c_typename, logical(use_generic, kind=1))
  end function create_dtype_default

  !> @brief Create a data type for handling scalars with fixed precision.
  !> @param[in] subtype Name of the scalar data type.
  !>   (e.g. int, uint, float, complex, bytes, unicode)
  !> @param[in] precision Precision (in bits) of the scalar type.
  !> @param[in] units Units that should be associated with this data type.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_scalar(subtype, precision, units, &
       use_generic) result(out)
    implicit none
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    character(len=*), intent(in) :: units
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    character(len=len_trim(subtype)+1) :: c_subtype
    integer(kind=c_size_t) :: c_precision
    character(len=len_trim(units)+1) :: c_units
    c_subtype = trim(subtype)//c_null_char
    c_precision = precision
    c_units = trim(units)//c_null_char
    out%ptr = create_dtype_scalar_c(c_subtype, c_precision, c_units, &
         logical(use_generic, kind=1))
  end function create_dtype_scalar

  !> @brief Create a data type for handling 1D arrays with fixed precision.
  !> @param[in] subtype Name of the 1D array element data type
  !>   (e.g. int, uint, float, complex, bytes, unicode).
  !> @param[in] precision Precision (in bits) of the array element type.
  !> @param[in] length Number of elements in arrays of this type.
  !> @param[in] units Units that should be associated with this data type.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_1darray(subtype, precision, length, &
       units, use_generic) result(out)
    implicit none
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    integer, intent(in) :: length
    character(len=*), intent(in) :: units
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    character(len=len_trim(subtype)+1) :: c_subtype
    integer(kind=c_size_t) :: c_precision
    integer(kind=c_size_t) :: c_length
    character(len=len_trim(units)+1) :: c_units
    c_subtype = trim(subtype)//c_null_char
    c_precision = precision
    c_length = length
    c_units = trim(units)//c_null_char
    out%ptr = create_dtype_1darray_c(c_subtype, c_precision, c_length, &
         c_units, logical(use_generic, kind=1))
  end function create_dtype_1darray

  !> @brief Create a data type for handling 1D arrays with fixed precision.
  !> @param[in] subtype Name of the 1D array element data type
  !>   (e.g. int, uint, float, complex, bytes, unicode).
  !> @param[in] precision Precision (in bits) of the array element type.
  !> @param[in] ndim Number of dimensions in arrays of this type.
  !> @param[in] shape Size of arrays of this type in each dimension.
  !> @param[in] units Units that should be associated with this data type.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_ndarray(subtype, precision, ndim, &
       shape, units, use_generic) result(out)
    implicit none
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    integer, intent(in) :: ndim
    integer(kind=c_size_t), dimension(:), target, intent(in) :: shape
    character(len=*), intent(in) :: units
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    integer(kind=c_size_t), dimension(:), pointer :: pshape
    character(len=len_trim(subtype)+1) :: c_subtype
    integer(kind=c_size_t) :: c_precision
    integer(kind=c_size_t) :: c_ndim
    type(c_ptr) :: c_shape
    character(len=len_trim(units)+1) :: c_units
    pshape => shape
    c_subtype = trim(subtype)//c_null_char
    c_precision = precision
    c_ndim = ndim
    c_shape = c_loc(shape(1))
    c_units = trim(units)//c_null_char
    out%ptr = create_dtype_ndarray_c(c_subtype, c_precision, c_ndim, &
         c_shape, c_units, logical(use_generic, kind=1))
  end function create_dtype_ndarray

  !> @brief Create a data type for handling JSON arrays.
  !> @param[in] nitems The number of items that will be in the arrays.
  !> @param[in] items Data types for each element in the arrays.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_json_array(nitems, items, use_generic) &
       result(out)
    implicit none
    integer, intent(in) :: nitems
    type(yggdtype), dimension(:), intent(in) :: items
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    integer(kind=c_size_t) :: c_nitems
    type(c_ptr), target :: c_items(size(items))
    integer :: i
    c_nitems = nitems
    do i = 1, size(items)
       c_items(i) = items(i)%ptr
    end do
    out%ptr = create_dtype_json_array_c(c_nitems, c_loc(c_items(1)), &
         logical(use_generic, kind=1))
  end function create_dtype_json_array

  !> @brief Create a data type for handling JSON object.
  !> @param[in] nitems The number of items that will be in the objects.
  !> @param[in] keys The keys that will be in the objects.
  !> @param[in] values Data types for the values associated with the keys.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_json_object(nitems, keys, values, use_generic) &
       result(out)
    implicit none
    integer, intent(in) :: nitems
    character(len=*), dimension(:), intent(in), target :: keys
    type(yggdtype), dimension(:), intent(in) :: values
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    integer(kind=c_size_t) :: c_nitems
    type(c_ptr), target :: c_keys(size(keys))
    type(c_ptr), target :: c_values(size(values))
    character(kind=c_char, len=len(keys(1))), pointer :: ikey
    integer :: i, ikey_len
    c_nitems = nitems
    do i = 1, size(keys)
       ikey => keys(i)
       ikey_len = len_trim(ikey)
       if (ikey_len.lt.len(ikey)) then
          ikey((ikey_len+1):(ikey_len+1)) = c_null_char
       end if
       c_keys(i) = c_loc(ikey(1:1))
    end do
    do i = 1, size(values)
       c_values(i) = values(i)%ptr
    end do
    out%ptr = create_dtype_json_object_c(c_nitems, c_loc(c_keys(1)), &
         c_loc(c_values(1)), logical(use_generic, kind=1))
  end function create_dtype_json_object

  !> @brief Create a data type for handling Ply meshes.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_ply(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_ply_c(logical(use_generic, kind=1))
  end function create_dtype_ply

  !> @brief Create a data type for handling Obj meshes.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_obj(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_obj_c(logical(use_generic, kind=1))
  end function create_dtype_obj

  !> @brief Create a data type based on a C-style format string.
  !> @param[in] format_str A C-style format string.
  !> @param[in] as_array If True, the data type will expect arrays (one
  !>   for each field in the format string). If False, the data type
  !>   will expect scalars.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_format(format_str, as_array, use_generic) &
       result(out)
    implicit none
    character(len=*), intent(in) :: format_str
    integer, intent(in) :: as_array
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    character(len=len_trim(format_str)+1) :: c_format_str
    c_format_str = trim(format_str)//c_null_char
    call fix_format_str(c_format_str)
    out%ptr = create_dtype_format_c(c_format_str, as_array, logical(use_generic, kind=1))
  end function create_dtype_format

  !> @brief Create a data type for handling Python objects.
  !> @param[in] typename Type of Python object. (e.g. instance or class)
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_pyobj(typename, use_generic) result(out)
    implicit none
    character(len=*), intent(in) :: typename
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    character(len=len_trim(typename)+1) :: c_typename
    c_typename = trim(typename)//c_null_char
    out%ptr = create_dtype_pyobj_c(c_typename, logical(use_generic, kind=1))
  end function create_dtype_pyobj

  !> @brief Create a data type for handling schemas.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_schema(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_schema_c(logical(use_generic, kind=1))
  end function create_dtype_schema

  !> @brief Create a data type for any data type.
  !> @param[in] use_generic True if the data type should expect generic
  !>   datatypes.
  !> @returns A data type object.
  function create_dtype_any(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_any_c(logical(use_generic, kind=1))
  end function create_dtype_any

  ! Methods for sending/receiving
  !> @brief Send raw bytes data from a character array.
  !> @param[in] ygg_q Output/RPC/Timesync comm.
  !> @param[in] data Array of bytes to send.
  !> @param[in] data_len Number of bytes from data to send.
  !> @returns flag Success (.true.) or failure (.false.) of the send.
  function ygg_send(ygg_q, data, data_len) result (flag)
    implicit none
    type(yggcomm), intent(in) :: ygg_q
    type(c_ptr) :: c_ygg_q
    character(len=*), intent(in) :: data
    character(len=len(data)+1) :: c_data
    integer, intent(in) :: data_len
    integer(kind=c_int) :: c_data_len
    logical :: flag
    integer(kind=c_int) :: c_flag
    c_ygg_q = ygg_q%comm
    c_data = data//c_null_char
    c_data_len = data_len
    c_flag = ygg_send_c(c_ygg_q, c_data, c_data_len)
    if (c_flag.ge.0) then
       flag = .true.
    else
       flag = .false.
    end if
  end function ygg_send
  
  !> @brief Receive raw bytes data into a character array that cannot be
  !>   resized.
  !> @param[in] ygg_q Input/RPC/Timesync comm.
  !> @param[in] data Array to receive bytes into.
  !> @param[in] data_len Variable where the size of the received message
  !>   should be stored.
  !> @returns flag Success (.true.) or failure (.false.) of the receive.
  function ygg_recv(ygg_q, data, data_len) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(c_ptr) :: c_ygg_q
    character(len=*) :: data
    character(len=len(data)+1) :: c_data
    integer :: data_len
    integer(kind=c_int) :: c_data_len
    logical :: flag
    integer(kind=c_int) :: c_flag
    c_ygg_q = ygg_q%comm
    c_data = data//c_null_char
    c_data_len = data_len
    c_flag = ygg_recv_c(c_ygg_q, c_data, c_data_len)
    if (c_flag.ge.0) then
       flag = .true.
       data = c_data(:c_flag)
       data_len = c_flag
    else
       flag = .false.
    end if
  end function ygg_recv

  !> @brief Send raw bytes data from a character array.
  !> @param[in] ygg_q Output/RPC/Timesync comm.
  !> @param[in] data Array of bytes to send.
  !> @param[in] data_len Number of bytes from data to send.
  !> @returns flag Success (.true.) or failure (.false.) of the send.
  function ygg_send_nolimit(ygg_q, data, data_len) result (flag)
    implicit none
    type(yggcomm), intent(in) :: ygg_q
    type(yggchar_r) :: data
    integer, intent(in) :: data_len
    logical :: flag
    integer(kind=c_size_t) :: len_used
    len_used = data_len
    flag = ygg_send_var(ygg_q, [yggarg(data), yggarg(len_used)])
  end function ygg_send_nolimit
  
  !> @brief Receive raw bytes data into a character array that can be resized.
  !> @param[in] ygg_q Input/RPC/Timesync comm.
  !> @param[in] data Array to receive bytes into.
  !> @param[in] data_len Variable where the size of the received message
  !>   should be stored.
  !> @returns flag Success (.true.) or failure (.false.) of the receive.
  function ygg_recv_nolimit(ygg_q, data, data_len) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggchar_r) :: data
    integer :: data_len
    logical :: flag
    integer(kind=c_size_t) :: len_used
    len_used = data_len
    flag = ygg_recv_var_realloc(ygg_q, [yggarg(data), yggarg(len_used)])
    if (flag) then
       data_len = int(len_used)
    end if
  end function ygg_recv_nolimit

  function ygg_send_var_sing(ygg_q, args) result (flag)
    implicit none
    type(yggcomm), intent(in) :: ygg_q
    type(yggptr) :: args
    logical :: flag
    flag = ygg_send_var_mult(ygg_q, [args])
  end function ygg_send_var_sing
  function ygg_send_var_mult(ygg_q, args) result (flag)
    implicit none
    type(yggcomm), intent(in) :: ygg_q
    type(c_ptr) :: c_ygg_q
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    integer :: c_nargs
    logical :: flag, is_format
    integer(kind=c_int) :: c_flag
    is_format = is_comm_format_array_type(ygg_q, args)
    c_ygg_q = ygg_q%comm
    c_nargs = pre_send(args, c_args, is_format)
    c_flag = ygg_send_var_c(c_ygg_q, c_nargs, c_loc(c_args(1)))
    if (c_flag.ge.0) then
       flag = .true.
    else
       flag = .false.
    end if
    call post_send(args, c_args, flag)
  end function ygg_send_var_mult

  ! BEGIN DOXYGEN_SHOULD_SKIP_THIS
  function is_next_size_t(args, i, req_array) result(flag)
    implicit none
    type(yggptr) :: args(:)
    integer :: i
    logical, intent(in), optional :: req_array
    logical :: flag
    if (i.ge.size(args)) then
       flag = .false.
    else
       if (present(req_array)) then
          flag = is_size_t(args(i+1), req_array)
       else
          flag = is_size_t(args(i+1))
       end if
    end if
  end function is_next_size_t

  function is_size_t(arg, req_array_in) result(flag)
    type(yggptr), intent(in) :: arg
    logical, optional :: req_array_in
    logical :: req_array
    logical :: flag
    if (present(req_array_in)) then
       req_array = req_array_in
    else
       req_array = .false.
    end if
    if (((arg%type.eq."integer").or.(arg%type.eq."size_t")).and. &
         (arg%nbytes.eq.8)) then
       flag = .true.
       if (req_array.and.(.not.arg%array)) then
          flag = .false.
       else if ((.not.req_array).and.arg%array) then
          flag = .false.
       end if
    else
       flag = .false.
    end if
  end function is_size_t

  function pre_send(args, c_args, is_format) result(c_nargs)
    implicit none
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    logical :: is_format
    integer(kind=c_int) :: c_nargs
    integer(kind=c_size_t) :: k
    integer :: i, j
    integer :: nargs
    call ygglog_debug("pre_send: begin")
    nargs = size(args)  ! Number of arguments passed
    c_nargs = nargs  ! Number of arguments that C should be aware of
    if (is_format) then
       if (.not.is_size_t(args(1))) then
          nargs = nargs + 1
          c_nargs = c_nargs + 1
       end if
    end if
    do i = 1, size(args)
       allocate(args(i)%len_c)
       allocate(args(i)%prec_c)
       allocate(args(i)%ndim_c)
       allocate(args(i)%shape_c(args(i)%ndim))
       args(i)%len_c = 1
       args(i)%prec_c = 1
       args(i)%ndim_c = 1
       do k = 1, args(i)%ndim
          args(i)%shape_c(k) = args(i)%shape(k)
       end do
       if (args(i)%array) then
          if (args(i)%ndim.gt.1) then
             if (is_next_size_t(args, i).and.is_next_size_t(args, i+1, req_array=.true.)) then
                ! Do nothing, vars already exist
             else if (is_next_size_t(args, i, req_array=.true.)) then
                if (args(i)%alloc) then
                   nargs = nargs + 1  ! For ndim
                   c_nargs = c_nargs + 1
                end if
             else if (args(i)%alloc) then
                nargs = nargs + 2  ! For ndim and shape
                c_nargs = c_nargs + 2
             end if
          else
             if ((.not.is_format).and.(.not.is_next_size_t(args, i))) then
                if (args(i)%alloc) then
                   nargs = nargs + 1  ! For the array size
                   c_nargs = c_nargs + 1
                end if
             end if
          end if
       else if ((args(i)%type.eq."character").or. &
            (args(i)%type.eq."unicode")) then
          if (.not.is_next_size_t(args, i)) then
             nargs = nargs + 1  ! For the string size
             c_nargs = c_nargs + 1
          end if
       end if
    end do
    call ygglog_debug("pre_send: counted variables")
    allocate(c_args(nargs))
    j = 1
    if (is_format) then
       if (.not.is_size_t(args(1))) then
          args(1)%len_c = args(1)%len
          args(1)%len_ptr = c_loc(args(1)%len_c)
          c_args(j) = args(1)%len_ptr
          j = j + 1
       end if
    end if
    do i = 1, size(args)
       c_args(j) = args(i)%ptr
       j = j + 1
       if (args(i)%array) then
          if (args(i)%ndim.gt.1) then
             if (is_next_size_t(args, i).and.is_next_size_t(args, i+1, req_array=.true.)) then
                args(i)%ndim_ptr = args(i+1)%ptr
                args(i)%shape_ptr = args(i+2)%ptr
             else if (is_next_size_t(args, i, req_array=.true.)) then
                args(i)%shape_ptr = args(i+1)%ptr
                if (args(i)%alloc) then
                   args(i)%ndim_c = args(i)%ndim
                   args(i)%ndim_ptr = c_loc(args(i)%ndim_c)
                   c_args(j) = args(i)%ndim_ptr
                   j = j + 1
                end if
             else if (args(i)%alloc) then
                args(i)%ndim_c = args(i)%ndim
                args(i)%ndim_ptr = c_loc(args(i)%ndim_c)
                c_args(j) = args(i)%ndim_ptr
                j = j + 1
                args(i)%shape_ptr = c_loc(args(i)%shape_c(1))
                c_args(j) = args(i)%shape_ptr
                j = j + 1
             end if
          else
             if (is_format) then
                args(i)%len_ptr = c_args(1)
             else if (is_next_size_t(args, i)) then
                args(i)%len_ptr = args(i+1)%ptr
             else if (args(i)%alloc) then
                args(i)%len_c = args(i)%len
                args(i)%len_ptr = c_loc(args(i)%len_c)
                c_args(j) = args(i)%len_ptr
                j = j + 1
             end if
          end if
       else if ((args(i)%type.eq."character").or. &
            (args(i)%type.eq."unicode")) then
          if (is_next_size_t(args, i)) then
             args(i)%prec_ptr = args(i+1)%ptr
          else
             args(i)%prec_c = args(i)%prec
             args(i)%prec_ptr = c_loc(args(i)%prec_c)
             c_args(j) = args(i)%prec_ptr
             j = j + 1
          end if
       end if
    end do
    call ygglog_debug("pre_send: end")
  end function pre_send

  function pre_recv(args, c_args, is_format) result(c_nargs)
    implicit none
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    logical :: is_format
    integer(kind=c_int) :: c_nargs
    integer(kind=c_size_t) :: k
    integer :: i, j
    integer :: nargs
    call ygglog_debug("pre_recv: begin")
    nargs = size(args)  ! Number of arguments passed
    c_nargs = nargs  ! Number of arguments that C should be aware of
    if ((is_format).and.(nargs.gt.0)) then
       if (.not.is_size_t(args(1))) then
          nargs = nargs + 1
          c_nargs = c_nargs + 1
       end if
    end if
    do i = 1, size(args)
       allocate(args(i)%len_c)
       allocate(args(i)%prec_c)
       allocate(args(i)%ndim_c)
       args(i)%len_c = 1
       args(i)%prec_c = 1
       args(i)%ndim_c = 1
       if (associated(args(i)%shape)) then
          allocate(args(i)%shape_c(args(i)%ndim))
          do k = 1, args(i)%ndim
             args(i)%shape_c(k) = args(i)%shape(k)
          end do
       end if
       if (args(i)%array) then
          if ((args(i)%ndim.gt.1).or.args(i)%ndarray) then
             if (is_next_size_t(args, i).and.is_next_size_t(args, i+1, req_array=.true.)) then
                ! Do nothing, vars already exist
             else if (is_next_size_t(args, i, req_array=.true.)) then
                nargs = nargs + 1  ! For ndim
                if (args(i)%alloc) then
                   c_nargs = c_nargs + 1
                end if
             else
                nargs = nargs + 2  ! For ndim and shape
                if (args(i)%alloc) then
                   c_nargs = c_nargs + 2
                end if
             end if
          else
             if ((.not.is_format).and.(.not.is_next_size_t(args, i))) then
                nargs = nargs + 1  ! For the array size
                if (args(i)%alloc) then
                   c_nargs = c_nargs + 1
                end if
             end if
          end if
          if ((args(i)%type.eq."character").or. &
               (args(i)%type.eq."unicode")) then
             nargs = nargs + 1  ! For the string length
          end if
       else if ((args(i)%type.eq."character").or. &
            (args(i)%type.eq."unicode")) then
          if (.not.is_next_size_t(args, i)) then
             nargs = nargs + 1  ! For the string size
             c_nargs = c_nargs + 1
          end if
       end if
    end do
    allocate(c_args(nargs))
    call ygglog_debug("pre_recv: counted and allocated for arguments")
    j = 1
    if (is_format) then
       if (.not.is_size_t(args(1))) then
          args(1)%len_c = args(1)%len
          args(1)%len_ptr = c_loc(args(1)%len_c)
          c_args(j) = args(1)%len_ptr
          j = j + 1
       end if
    end if
    do i = 1, size(args)
       c_args(j) = args(i)%ptr
       j = j + 1
       if (args(i)%array) then
          ! TODO: handle case where shape is explicit and ensure
          ! that length of shape variable is not appended
          if ((args(i)%ndim.gt.1).or.args(i)%ndarray) then
             if (is_next_size_t(args, i).and.is_next_size_t(args, i+1, req_array=.true.)) then
                args(i)%ndim_ptr = args(i+1)%ptr
                args(i)%shape_ptr = args(i+2)%ptr
             else if (is_next_size_t(args, i, req_array=.true.)) then
                args(i)%shape_ptr = args(i+1)%ptr
                args(i)%ndim_c = args(i)%ndim
                args(i)%ndim_ptr = c_loc(args(i)%ndim_c)
                c_args(j) = args(i)%ndim_ptr
                j = j + 1
             else
                args(i)%ndim_c = args(i)%ndim
                args(i)%ndim_ptr = c_loc(args(i)%ndim_c)
                c_args(j) = args(i)%ndim_ptr
                j = j + 1
                if (associated(args(i)%shape_c)) then
                   args(i)%shape_ptr = c_loc(args(i)%shape_c(1))
                else
                   args(i)%shape_ptr = c_null_ptr
                end if
                c_args(j) = args(i)%shape_ptr
                j = j + 1
             end if
          else
             if (is_format) then
                args(i)%len_ptr = c_args(1)
             else if (is_next_size_t(args, i)) then
                args(i)%len_ptr = args(i+1)%ptr
             else
                args(i)%len_c = args(i)%len
                args(i)%len_ptr = c_loc(args(i)%len_c)
                c_args(j) = args(i)%len_ptr
                j = j + 1
             end if
          end if
          if ((args(i)%type.eq."character").or. &
               (args(i)%type.eq."unicode")) then
             args(i)%prec_c = args(i)%prec
             args(i)%prec_ptr = c_loc(args(i)%prec_c)
             c_args(j) = args(i)%prec_ptr
             j = j + 1
          end if
       else if ((args(i)%type.eq."character").or. &
            (args(i)%type.eq."unicode")) then
          if (is_next_size_t(args, i)) then
             args(i)%prec_ptr = args(i+1)%ptr
          else
             args(i)%prec_c = args(i)%prec
             args(i)%prec_ptr = c_loc(args(i)%prec_c)
             c_args(j) = args(i)%prec_ptr
             j = j + 1
          end if
       end if
    end do
    call ygglog_debug("pre_recv: end")
  end function pre_recv

  subroutine post_recv(args, c_args, flag, realloc, is_format)
    implicit none
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    logical :: flag
    integer :: i, j
    logical :: realloc, is_format
    call ygglog_debug("post_recv: begin")
    if (flag) then
       j = 1
       if (is_format) then
          if (.not.is_size_t(args(1))) then
             j = j + 1
          end if
       end if
       do i = 1, size(args)
          args(i)%ptr = c_args(j)
          if ((args(i)%ndim.gt.1).or.args(i)%ndarray) then
             args(i)%shape_ptr = c_args(j+2)
          end if
          flag = yggptr_c2f(args(i), realloc)
          if (.not.flag) then
             call ygglog_error("Error recovering fortran pointer for variable.")
             exit
          end if
          j = j + 1
          if (args(i)%array) then
             if ((args(i)%ndim.gt.1).or.args(i)%ndarray) then
                if (is_next_size_t(args, i).and.is_next_size_t(args, i+1, req_array=.true.)) then
                   ! Do nothing, process variables as normal
                else if (is_next_size_t(args, i, req_array=.true.)) then
                   j = j + 1
                else
                   j = j + 2
                end if
             else
                if ((.not.is_format).and.(.not.is_next_size_t(args, i))) then
                   j = j + 1
                end if
             end if
             if ((args(i)%type.eq."character").or. &
                  (args(i)%type.eq."unicode")) then
                j = j + 1
             end if
          else if ((args(i)%type.eq."character").or. &
               (args(i)%type.eq."unicode")) then
             if (.not.is_next_size_t(args, i)) then
                j = j + 1
             end if
          end if
       end do
    end if
    if (flag) then
       do i = 1, size(args)
          deallocate(args(i)%len_c)
          deallocate(args(i)%prec_c)
          deallocate(args(i)%ndim_c)
          if (associated(args(i)%shape_c)) then
             deallocate(args(i)%shape_c)
          end if
       end do
    end if
    if (allocated(c_args)) then
       deallocate(c_args)
    end if
    call ygglog_debug("post_recv: end")
  end subroutine post_recv

  subroutine post_send(args, c_args, flag)
    implicit none
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    logical :: flag
    integer :: i
    call ygglog_debug("post_send: begin")
    if (flag) then
       do i = 1, size(args)
          deallocate(args(i)%len_c)
          deallocate(args(i)%prec_c)
          deallocate(args(i)%ndim_c)
          deallocate(args(i)%shape_c)
       end do
    end if
    if (allocated(c_args)) then
       deallocate(c_args)
    end if
    call ygglog_debug("post_send: end")
  end subroutine post_send
  ! END DOXYGEN_SHOULD_SKIP_THIS

  function ygg_rpc_call_1v1(ygg_q, oargs, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oargs
    type(yggptr) :: iargs
    logical :: flag
    flag = ygg_rpc_call_mult(ygg_q, [oargs], [iargs])
  end function ygg_rpc_call_1v1
  function ygg_rpc_call_1vm(ygg_q, oargs, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oargs
    type(yggptr) :: iargs(:)
    logical :: flag
    flag = ygg_rpc_call_mult(ygg_q, [oargs], iargs)
  end function ygg_rpc_call_1vm
  function ygg_rpc_call_mv1(ygg_q, oargs, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oargs(:)
    type(yggptr) :: iargs
    logical :: flag
    flag = ygg_rpc_call_mult(ygg_q, oargs, [iargs])
  end function ygg_rpc_call_mv1
  function ygg_rpc_call_mult(ygg_q, oargs, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(c_ptr) :: c_ygg_q
    type(yggptr) :: oargs(:)
    type(yggptr) :: iargs(:)
    type(c_ptr), allocatable, target :: c_args(:)
    type(c_ptr), allocatable, target :: c_iargs(:)
    type(c_ptr), allocatable, target :: c_oargs(:)
    integer :: c_nargs
    logical :: flag
    integer :: i
    integer(kind=c_int) :: c_flag
    logical :: iis_format, ois_format
    ois_format = is_comm_format_array_type(ygg_q, oargs)
    iis_format = is_comm_format_array_type(ygg_q, iargs)
    c_ygg_q = ygg_q%comm
    c_nargs = 0
    c_nargs = c_nargs + pre_send(oargs, c_oargs, ois_format)
    c_nargs = c_nargs + pre_recv(iargs, c_iargs, iis_format)
    allocate(c_args(size(c_oargs) + size(c_iargs)))
    do i = 1, size(c_oargs)
       c_args(i) = c_oargs(i)
    end do
    do i = 1, size(c_iargs)
       c_args(i + size(c_oargs)) = c_iargs(i)
    end do
    c_flag = ygg_rpc_call_c(c_ygg_q, c_nargs, c_loc(c_args(1)))
    if (c_flag.ge.0) then
       flag = .true.
    else
       flag = .false.
    end if
    do i = 1, size(c_iargs)
       c_iargs(i) = c_args(i + size(c_oargs))
    end do
    call post_send(oargs, c_oargs, flag)
    call post_recv(iargs, c_iargs, flag, .false., iis_format)
    if (allocated(c_args)) then
       deallocate(c_args)
    end if
  end function ygg_rpc_call_mult
  
  function ygg_rpc_call_realloc_1v1(ygg_q, oargs, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oargs
    type(yggptr) :: iargs
    logical :: flag
    flag = ygg_rpc_call_realloc_mult(ygg_q, [oargs], [iargs])
  end function ygg_rpc_call_realloc_1v1
  function ygg_rpc_call_realloc_1vm(ygg_q, oargs, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oargs
    type(yggptr) :: iargs(:)
    logical :: flag
    flag = ygg_rpc_call_realloc_mult(ygg_q, [oargs], iargs)
  end function ygg_rpc_call_realloc_1vm
  function ygg_rpc_call_realloc_mv1(ygg_q, oargs, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oargs(:)
    type(yggptr) :: iargs
    logical :: flag
    flag = ygg_rpc_call_realloc_mult(ygg_q, oargs, [iargs])
  end function ygg_rpc_call_realloc_mv1
  function ygg_rpc_call_realloc_mult(ygg_q, oargs, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(c_ptr) :: c_ygg_q
    type(yggptr) :: oargs(:)
    type(yggptr) :: iargs(:)
    type(c_ptr), allocatable, target :: c_args(:)
    type(c_ptr), allocatable, target :: c_oargs(:)
    type(c_ptr), allocatable, target :: c_iargs(:)
    integer :: c_nargs
    logical :: flag, iis_format, ois_format
    integer(kind=c_int) :: c_flag
    integer :: i
    c_ygg_q = ygg_q%comm
    ois_format = is_comm_format_array_type(ygg_q, oargs)
    iis_format = is_comm_format_array_type(ygg_q, iargs)
    flag = .true.
    do i = 1, size(iargs)
       if ((iargs(i)%array.or.(iargs(i)%type.eq."character").or. &
            (iargs(i)%type.eq."unicode")).and. &
            (.not.(iargs(i)%alloc))) then
          call ygglog_error("Provided array/string is not allocatable.")
          flag = .false.
       end if
    end do
    if (flag) then
       c_nargs = 0
       c_nargs = c_nargs + pre_send(oargs, c_oargs, ois_format)
       c_nargs = c_nargs + pre_recv(iargs, c_iargs, iis_format)
       allocate(c_args(size(c_oargs) + size(c_iargs)))
       do i = 1, size(c_oargs)
          c_args(i) = c_oargs(i)
       end do
       do i = 1, size(c_iargs)
          c_args(i + size(c_oargs)) = c_iargs(i)
       end do
       c_flag = ygg_rpc_call_realloc_c(c_ygg_q, c_nargs, c_loc(c_args(1)))
       if (c_flag.ge.0) then
          flag = .true.
       else
          flag = .false.
       end if
       do i = 1, size(c_iargs)
          c_iargs(i) = c_args(i + size(c_oargs))
       end do
    end if
    call post_send(oargs, c_oargs, flag)
    call post_recv(iargs, c_iargs, flag, .true., iis_format)
    if (allocated(c_args)) then
       deallocate(c_args)
    end if
  end function ygg_rpc_call_realloc_mult
  
  function ygg_recv_var_sing(ygg_q, args) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: args
    logical :: flag
    flag = ygg_recv_var_mult(ygg_q, [args])
  end function ygg_recv_var_sing
  function ygg_recv_var_mult(ygg_q, args) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(c_ptr) :: c_ygg_q
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    integer :: c_nargs
    logical :: flag, is_format
    integer(kind=c_int) :: c_flag
    is_format = is_comm_format_array_type(ygg_q, args)
    c_ygg_q = ygg_q%comm
    c_nargs = pre_recv(args, c_args, is_format)
    c_flag = ygg_recv_var_c(c_ygg_q, c_nargs, c_loc(c_args(1)))
    if (c_flag.ge.0) then
       flag = .true.
    else
       flag = .false.
    end if
    call post_recv(args, c_args, flag, .false., is_format)
  end function ygg_recv_var_mult

  function ygg_recv_var_realloc_sing(ygg_q, args) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: args
    logical :: flag
    flag = ygg_recv_var_realloc_mult(ygg_q, [args])
  end function ygg_recv_var_realloc_sing
  function ygg_recv_var_realloc_mult(ygg_q, args) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(c_ptr) :: c_ygg_q
    type(yggptr), target :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    integer :: c_nargs
    logical :: flag, is_format
    integer :: i
    integer(kind=c_int) :: c_flag
    call ygglog_debug("ygg_recv_var_realloc: begin")
    is_format = is_comm_format_array_type(ygg_q, args)
    c_ygg_q = ygg_q%comm
    flag = .true.
    do i = 1, size(args)
       if ((args(i)%array.or.(args(i)%type.eq."character").or. &
            (args(i)%type.eq."unicode")).and. &
            (.not.(args(i)%alloc))) then
          call ygglog_error("Provided array/string is not allocatable.")
          flag = .false.
       end if
    end do
    call ygglog_debug("ygg_recv_var_realloc: checked variables")
    if (flag) then
       c_nargs = pre_recv(args, c_args, is_format)
       c_flag = ygg_recv_var_realloc_c(c_ygg_q, c_nargs, c_loc(c_args(1)))
       if (c_flag.ge.0) then
          flag = .true.
       else
          flag = .false.
       end if
    end if
    call post_recv(args, c_args, flag, .true., is_format)
    call ygglog_debug("ygg_recv_var_realloc: end")
  end function ygg_recv_var_realloc_mult

  ! Ply interface
  !> @brief Initialize a ply mesh instance.
  !> @returns A ply mesh.
  function init_ply() result (out)
    implicit none
    type(yggply) :: out
    out = init_ply_c()
  end function init_ply
  !> @brief Free a ply mesh instance.
  !> @param[in] p The ply mesh to free.
  subroutine free_ply(p)
    implicit none
    type(yggply), target :: p
    type(yggply), pointer :: pp
    type(c_ptr) :: c_p
    pp => p
    c_p = c_loc(pp)
    call free_ply_c(c_p)
    nullify(pp)
  end subroutine free_ply
  !> @brief Copy a ply mesh instance.
  !> @param[in] p The ply mesh to copy.
  !> @returns A copy of the mesh.
  function copy_ply(p) result(out)
    implicit none
    type(yggply), intent(in) :: p
    type(yggply) :: out
    out = copy_ply_c(p)
  end function copy_ply
  !> @brief Display the contents of a ply mesh with a certain indentation.
  !> @param[in] p The ply mesh to display.
  !> @param[in] indent The indentation to use for each line.
  subroutine display_ply_indent(p, indent)
    implicit none
    type(yggply), intent(in) :: p
    character(len=*), intent(in) :: indent
    character(len=len(indent)+1) :: c_indent
    c_indent = indent//c_null_char
    call display_ply_indent_c(p, c_indent)
  end subroutine display_ply_indent
  !> @brief Display the contents of a ply mesh.
  !> @param[in] p The ply mesh to display.
  subroutine display_ply(p)
    implicit none
    type(yggply), intent(in) :: p
    call display_ply_c(p)
  end subroutine display_ply
  
  ! Obj interface
  !> @brief Initialize an obj mesh instance.
  !> @returns An obj mesh.
  function init_obj() result (out)
    implicit none
    type(yggobj) :: out
    out = init_obj_c()
  end function init_obj
  !> @brief Free an obj mesh instance.
  !> @param[in] p The obj mesh to free.
  subroutine free_obj(p)
    implicit none
    type(yggobj), target :: p
    type(yggobj), pointer :: pp
    type(c_ptr) :: c_p
    pp => p
    c_p = c_loc(pp)
    call free_obj_c(c_p)
    nullify(pp)
  end subroutine free_obj
  !> @brief Copy an obj mesh instance.
  !> @param[in] p The obj mesh to copy.
  !> @returns A copy of the mesh.
  function copy_obj(p) result(out)
    implicit none
    type(yggobj), intent(in) :: p
    type(yggobj) :: out
    out = copy_obj_c(p)
  end function copy_obj
  !> @brief Display the contents of a obj mesh with a certain indentation.
  !> @param[in] p The obj mesh to display.
  !> @param[in] indent The indentation to use for each line.
  subroutine display_obj_indent(p, indent)
    implicit none
    type(yggobj), intent(in) :: p
    character(len=*), intent(in) :: indent
    character(len=len(indent)+1) :: c_indent
    c_indent = indent//c_null_char
    call display_obj_indent_c(p, c_indent)
  end subroutine display_obj_indent
  !> @brief Display the contents of a obj mesh.
  !> @param[in] p The obj mesh to display.
  subroutine display_obj(p)
    implicit none
    type(yggobj), intent(in) :: p
    call display_obj_c(p)
  end subroutine display_obj

  ! Generic interface
  !> @brief Initialize a generic object.
  !> @returns A new generic object.
  function init_generic() result(out)
    implicit none
    type(ygggeneric) :: out
    out = init_generic_c()
  end function init_generic
  !> @brief Initialize an array of generic objects.
  !> @returns A new generic object array.
  function init_generic_array() result(out)
    implicit none
    type(ygggeneric) :: out
    out = init_generic_array_c()
  end function init_generic_array
  !> @brief Initialize a mapping of generic objects.
  !> @returns A new generic object map.
  function init_generic_map() result(out)
    implicit none
    type(ygggeneric) :: out
    out = init_generic_map_c()
  end function init_generic_map
  !> @brief Create a generic object from a type and some data.
  !> @param[in] type_class The data type associated with the data pointer.
  !> @param[in] data A pointer to data of an arbitrary type defined by type_class.
  !> @returns A new generic object containing the provided data.
  function create_generic(type_class, data) result(out)
    implicit none
    type(yggdtype) :: type_class
    type(yggptr) :: data
    integer(kind=c_size_t) :: nbytes
    type(c_ptr) :: c_type_class
    type(c_ptr) :: c_data
    type(ygggeneric) :: out
    c_type_class = type_class%ptr
    c_data = data%ptr
    nbytes = data%nbytes
    out = create_generic_c(c_type_class, c_data, nbytes)
  end function create_generic
  !> @brief Free a generic object.
  !> @param[in] x A generic object to free.
  subroutine free_generic(x)
    implicit none
    type(ygggeneric), target :: x
    integer(kind=c_int) :: out
    out = free_generic_c(c_loc(x))
    if (out.ne.0) then
       stop "Error freeing generic object."
    end if
  end subroutine free_generic
  !> @brief Check if a generic object has been initialized.
  !> @param[in] x A generic object.
  !> @returns .true. if the object has been initialized, .false. otherwise.
  function is_generic_init(x) result(out)
    implicit none
    type(ygggeneric), value, intent(in) :: x
    logical :: out
    integer(kind=c_int) :: c_out
    out = .false.
    c_out = is_generic_init_c(x)
    if (c_out.ne.0) then
       out = .true.
    end if
  end function is_generic_init
  !> @brief Copy a generic object.
  !> @param[in] src A generic object to copy.
  !> @returns A copy of src.
  function copy_generic(src) result(out)
    implicit none
    type(ygggeneric), intent(in) :: src
    type(ygggeneric) :: out
    out = copy_generic_c(src)
  end function copy_generic
  !> @brief Display a generic object.
  !> @param[in] x A generic object to display.
  subroutine display_generic(x)
    implicit none
    type(ygggeneric), intent(in) :: x
    call display_generic_c(x)
  end subroutine display_generic
  !> @brief Add an element to the end of an array of generic elements.
  !> @param[in] arr Array to add element to.
  !> @param[in] x Element to add.
  !> @returns A flag that is 1 if there is an error and 0 otherwise.
  function add_generic_array(arr, x) result(out)
    implicit none
    type(ygggeneric) :: arr
    type(ygggeneric), intent(in) :: x
    integer(kind=c_int) :: out
    out = add_generic_array_c(arr, x)
  end function add_generic_array
  !> @brief Set an element in the array at a given index to a new value.
  !> @param[in] arr Array to add element to.
  !> @param[in] i  Index where element should be added.
  !> @param[in] x Element to add.
  !> @returns A flag that is 1 if there is an error and 0 otherwise.
  function set_generic_array(arr, i, x) result(out)
    implicit none
    type(ygggeneric) :: arr
    integer(kind=c_size_t), intent(in) :: i
    type(ygggeneric), intent(in) :: x
    integer(kind=c_int) :: out
    out = set_generic_array_c(arr, i-1, x)
  end function set_generic_array
  !> @brief Get an element from an array.
  !> @param[in] arr Array to get element from.
  !> @param[in] i Index of element to get.
  !> @param[out] x Pointer to address where element should be stored.
  !> @returns A flag that is 1 if there is an error and 0 otherwise.
  function get_generic_array(arr, i, x) result(out)
    implicit none
    type(ygggeneric), intent(in) :: arr
    integer(kind=c_size_t), intent(in) :: i
    type(ygggeneric), pointer :: x
    integer(kind=c_int) :: out
    type(c_ptr) :: c_x
    allocate(x);
    c_x = c_loc(x) ! Maybe use first element in type
    out = get_generic_array_c(arr, i-1, c_x)
  end function get_generic_array
  !> @brief Set an element in the object at for a given key to a new value.
  !> @param[in] arr Object to add element to.
  !> @param[in] k Key where element should be added.
  !> @param[in] x Element to add.
  !> @returns A flag that is 1 if there is an error and 0 otherwise.
  function set_generic_object(arr, k, x) result(out)
    implicit none
    type(ygggeneric) :: arr
    character(len=*), intent(in) :: k
    type(ygggeneric), intent(in) :: x
    integer(kind=c_int) :: out
    character(len=len_trim(k)+1) :: c_k
    c_k = trim(k)//c_null_char
    out = set_generic_object_c(arr, c_k, x)
  end function set_generic_object
  !> @brief Get an element from an object.
  !> @param[in] arr Object to get element from.
  !> @param[in] k Key of element to return.
  !> @param[out] x Pointer to address where element should be stored.
  !> @returns A flag that is 1 if there is an error and 0 otherwise.
  function get_generic_object(arr, k, x) result(out)
    implicit none
    type(ygggeneric), intent(in) :: arr
    character(len=*), intent(in) :: k
    type(ygggeneric), pointer, intent(out) :: x
    integer(kind=c_int) :: out
    character(len=len_trim(k)+1) :: c_k
    type(c_ptr) :: c_x
    allocate(x);
    c_k = trim(k)//c_null_char
    c_x = c_loc(x) ! Maybe use first element in type
    out = get_generic_object_c(arr, c_k, c_x)
  end function get_generic_object

  ! Python interface
  !> @brief Initialize a Python object.
  !> @returns A Python object.
  function init_python() result(out)
    implicit none
    type(yggpython) :: out
    out = init_python_c()
  end function init_python
  !> @brief Free a Python object.
  !> @param[in] x The Python object to free.
  subroutine free_python(x)
    implicit none
    type(yggpython), target :: x
    type(yggpython), pointer :: xp
    type(c_ptr) :: c_x
    xp => x
    c_x = c_loc(xp)
    call free_python_c(c_x)
    nullify(xp)
  end subroutine free_python
  !> @brief Copy a Python object.
  !> @param[in] x The Python object to copy.
  !> @returns A copy of the Python object.
  function copy_python(x) result(out)
    implicit none
    type(yggpython) :: x
    type(yggpython) :: out
    out = copy_python_c(x)
  end function copy_python
  !> @brief Display a Python object.
  !> @param[in] x The Python object to display.
  subroutine display_python(x)
    implicit none
    type(yggpython) :: x
    call display_python_c(x)
  end subroutine display_python

  ! Interface for getting/setting generic array elements
  ! Get
  !> @brief Get the number of elements in an array object.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @returns Number of elements in array.
  function generic_array_get_size(x) result(out)
    implicit none
    type(ygggeneric) :: x
    integer(kind=c_size_t) :: out
    out = generic_array_get_size_c(x)
  end function generic_array_get_size
  !> @brief Get an item from an array for types that don't require
  !>   additional parameters.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @param[in] index Index for value that should be returned.
  !> @param[in] typename Type of value expected.
  !> @returns Pointer to data for array item.
  function generic_array_get_item(x, index, typename) result(out)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    character(len=*), intent(in) :: typename
    type(c_ptr) :: out
    character(len=len_trim(typename)+1) :: c_typename
    c_typename = trim(typename)//c_null_char
    out = generic_array_get_item_c(x, int(index-1, c_size_t), c_typename)
  end function generic_array_get_item
  !> @brief Get the size of an item from an array in bytes.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @param[in] index Index for value that the size should be returned for.
  !> @returns Size of the item in bytes.
  function generic_array_get_item_nbytes(x, index) result(out)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    integer(kind=c_int) :: out
    out = generic_array_get_item_nbytes_c(x, int(index-1, c_size_t))
    if (out.lt.0) then
       stop "Error getting number of bytes in array item."
    end if
  end function generic_array_get_item_nbytes
  !> @brief Get a scalar item from an array.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @param[in] index Index for value that should be returned.
  !> @param[in] subtype Type of scalar value expected.
  !> @param[in] precision Precision (in bits) of scalar value expected.
  !> @returns Pointer to data for the array item.
  function generic_array_get_scalar(x, index, subtype, precision) result(out)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    type(c_ptr) :: out
    character(len=len_trim(subtype)+1) :: c_subtype
    c_subtype = trim(subtype)//c_null_char
    out = generic_array_get_scalar_c(x, int(index-1, c_size_t), &
         c_subtype, int(precision, c_size_t))
  end function generic_array_get_scalar
  !> @brief Get a 1D array item from an array.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @param[in] index Index for value that should be returned.
  !> @param[in] subtype Type of 1D array expected.
  !> @param[in] precision Precision (in bits) of array expected.
  !> @param[out] data Pointer to memory that should be reallocated to store
  !>   the 1D array.
  !> @returns The number of elements in the array.
  function generic_array_get_1darray(x, index, subtype, precision, data) &
       result(out)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    type(c_ptr), value :: data
    integer(kind=c_size_t) :: out
    character(len=len_trim(subtype)+1) :: c_subtype
    c_subtype = trim(subtype)//c_null_char
    out = generic_array_get_1darray_c(x, int(index-1, c_size_t), &
         c_subtype, int(precision, c_size_t), data)
  end function generic_array_get_1darray
  !> @brief Get an ND array item from an array.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @param[in] index Index for value that should be returned.
  !> @param[in] subtype Type of ND array expected.
  !> @param[in] precision Precision (in bits) of array expected.
  !> @param[out] data Pointer to memory that should be reallocated to store
  !>   the ND array.
  !> @returns The shape of the ND array (size in each dimension).
  function generic_array_get_ndarray(x, index, subtype, precision, &
       data) result(shape)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    type(c_ptr), value :: data
    integer(kind=c_size_t), dimension(:), pointer :: shape
    integer(kind=c_size_t) :: ndim
    character(len=len_trim(subtype)+1) :: c_subtype
    type(c_ptr), target :: c_shape
    c_subtype = trim(subtype)//c_null_char
    ndim = generic_array_get_ndarray_c(x, int(index-1, c_size_t), &
         subtype, int(precision, c_size_t), data, c_loc(c_shape))
    call c_f_pointer(c_shape, shape, [ndim])
  end function generic_array_get_ndarray
  ! Set
  !> @brief Set an item in an array for types that don't require additional
  !>   information.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @param[in] index Index for value that should be set.
  !> @param[in] typename Type of value being set.
  !> @param[in] val Pointer to data that item should be set to.
  subroutine generic_array_set_item(x, index, typename, val)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    character(len=*), intent(in) :: typename
    type(c_ptr) :: val
    integer(kind=c_int) :: c_out
    character(len=len_trim(typename)+1) :: c_typename
    c_typename = trim(typename)//c_null_char
    c_out = generic_array_set_item_c(x, int(index-1, c_size_t), &
         c_typename, val)
    if (c_out.lt.0) then
       stop "Error setting element in array."
    end if
  end subroutine generic_array_set_item
  !> @brief Set a scalar value in an array.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @param[in] index Index for value that should be set.
  !> @param[in] val Pointer to scalar data.
  !> @param[in] subtype Subtype of scalar in value.
  !> @param[in] precision Precision of scalar in value.
  !> @param[in] units_in Units of value.
  subroutine generic_array_set_scalar(x, index, val, subtype, &
       precision, units_in)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    type(c_ptr) :: val
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       units = ""
    end if
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_array_set_scalar_c(x, int(index-1, c_size_t), &
         val, c_subtype, int(precision, c_size_t), c_units)
    if (c_out.lt.0) then
       stop "Error setting scalar element in array."
    end if
  end subroutine generic_array_set_scalar
  !> @brief Set a 1d array value in an array.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @param[in] index Index for value that should be set.
  !> @param[in] val Pointer to array data.
  !> @param[in] subtype Subtype of array expected.
  !> @param[in] precision Precision of array that is expected.
  !> @param[in] length Number of elements in value.
  !> @param[in] units_in Units of value.
  subroutine generic_array_set_1darray(x, index, val, subtype, &
       precision, length, units_in)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    type(c_ptr) :: val
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    integer, intent(in) :: length
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       units = ""
    end if
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_array_set_1darray_c(x, int(index-1, c_size_t), &
         val, c_subtype, int(precision, c_size_t), &
         int(length, c_size_t), c_units)
    if (c_out.lt.0) then
       stop "Error setting 1darray element in array."
    end if
  end subroutine generic_array_set_1darray
  !> @brief Set a nd array value from an array.
  !> @param[in] x Generic object that is presumed to contain an array.
  !> @param[in] index Index for value that should be set.
  !> @param[in] data Pointer to array data.
  !> @param[in] subtype Subtype of array in value.
  !> @param[in] precision Precision of array that is in value.
  !> @param[in] shape Pointer to array containing the size of the array in
  !>   each dimension.
  !> @param[in] units_in const char* Units that should be added to the array.
  subroutine generic_array_set_ndarray(x, index, data, subtype, &
       precision, shape, units_in)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    type(c_ptr) :: data
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    integer(kind=c_size_t), dimension(:), intent(in), target :: shape
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       units = ""
    end if
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_array_set_ndarray_c(x, int(index-1, c_size_t), &
         data, c_subtype, int(precision, c_size_t), &
         int(size(shape), c_size_t), c_loc(shape), c_units)
    if (c_out.lt.0) then
       stop "Error setting ndarray element in array."
    end if
  end subroutine generic_array_set_ndarray

  ! Interface for getting/setting generic map elements
  ! Get
  !> @brief Get the number of elements in an map object.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @returns Number of elements in map.
  function generic_map_get_size(x) result(out)
    implicit none
    type(ygggeneric) :: x
    integer(kind=c_size_t) :: out
    out = generic_map_get_size_c(x)
  end function generic_map_get_size
  !> @brief Get the keys in a map object.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[out] keys Pointer to memory where array of keys should be stored.
  !> @returns Number of keys in map.
  subroutine generic_map_get_keys(x, keys)
    implicit none
    type(ygggeneric) :: x
    character(len=*), dimension(:), pointer, intent(out) :: keys
    integer(kind=c_size_t), target :: n_keys
    integer(kind=c_size_t), target :: key_size
    integer(kind=c_size_t) :: i, j
    type(c_ptr) :: c_keys
    character, dimension(:), pointer :: f_keys
    c_keys = generic_map_get_keys_c(x, c_loc(n_keys), c_loc(key_size))
    if (.not.c_associated(c_keys)) then
      stop "Error getting keys from map."
    endif
    call c_f_pointer(c_keys, f_keys, [n_keys * key_size])
    allocate(keys(n_keys))
    if (key_size.gt.len(keys(1))) then
      stop "Key size is greater than size of provided keys."
    endif
    ! Allocation of character length and array dimension in gfortran
    ! has a bug which is fixed in gfortran 9.1 and the version on
    ! conda-forge as m2w64-gcc-fortran is only 5.3 as of 2020/6/18
    ! so for now the keys pointer needs to have a defined character
    ! length.
    ! allocate(character(len=key_size) :: keys(n_keys))
    do i = 1, n_keys
       do j = 1, key_size
          keys(i)(j:j) = f_keys(((i-1)*key_size)+j)
       end do
       do j = key_size+1, len(keys(1))
          keys(i)(j:j) = ' '
       end do
    end do
    deallocate(f_keys)
  end subroutine generic_map_get_keys
  !> @brief Get an item from a map for types that don't require additional
  !>   parameters.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[in] key Key string for value that should be returned.
  !> @param[in] typename Type of value expected.
  !> @returns Pointer to data for map item.
  function generic_map_get_item(x, key, typename) result(out)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    character(len=*) :: typename
    type(c_ptr) :: out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(typename)+1) :: c_typename
    c_key = trim(key)//c_null_char
    c_typename = trim(typename)//c_null_char
    out = generic_map_get_item_c(x, c_key, c_typename)
  end function generic_map_get_item
  !> @brief Get the size of an item from a map in bytes.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[in] key Key for value that the size should be returned for.
  !> @returns Size of the item in bytes.
  function generic_map_get_item_nbytes(x, key) result(out)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    integer(kind=c_int) :: out
    character(len=len_trim(key)+1) :: c_key
    c_key = trim(key)//c_null_char
    out = generic_map_get_item_nbytes_c(x, c_key)
    if (out.lt.0) then
       stop "Error getting number of bytes in map item."
    end if
  end function generic_map_get_item_nbytes
  !> @brief Get a scalar value from a map.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[in] key Key string for value that should be returned.
  !> @param[in] subtype Subtype of scalar expected.
  !> @param[in] precision Precision of scalar that is expected.
  !> @returns Pointer to scalar data.
  function generic_map_get_scalar(x, key, subtype, precision) result(out)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    character(len=*) :: subtype
    integer, intent(in) :: precision
    type(c_ptr) :: out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    out = generic_map_get_scalar_c(x, c_key, c_subtype, &
         int(precision, c_size_t))
  end function generic_map_get_scalar
  !> @brief Get a 1d array value from a map.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[in] key Key string for value that should be returned.
  !> @param[in] subtype Subtype of array expected.
  !> @param[in] precision Precision of array that is expected.
  !> @param[out] data Pointer to pointer that should be reallocated to store
  !>   the data.
  !> @returns Number of elements in the data.
  function generic_map_get_1darray(x, key, subtype, precision, data) &
       result(out)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    character(len=*) :: subtype
    integer, intent(in) :: precision
    type(c_ptr) :: data
    integer(kind=c_size_t) :: out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    out = generic_map_get_1darray_c(x, c_key, c_subtype, &
         int(precision, c_size_t), data)
  end function generic_map_get_1darray
  !> @brief Get a nd array value from a map.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[in] key Key string for value that should be returned.
  !> @param[in] subtype Subtype of array expected.
  !> @param[in] precision Precision of array that is expected.
  !> @param[out] data Pointer to array that should be reallocated to store
  !>   the data.
  !> @returns Shape of the array (size in each dimension).
  function generic_map_get_ndarray(x, key, subtype, precision, data) &
       result(shape)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    character(len=*) :: subtype
    integer, intent(in) :: precision
    type(c_ptr) :: data
    integer(kind=c_size_t), dimension(:), pointer :: shape
    integer(kind=c_size_t) :: ndim
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    type(c_ptr), target :: c_shape
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    ndim = generic_map_get_ndarray_c(x, c_key, c_subtype, &
         int(precision, c_size_t), data, c_loc(c_shape))
    call c_f_pointer(c_shape, shape, [ndim])
  end function generic_map_get_ndarray
  ! Set
  !> @brief Set an item from a map for types that don't require additional
  !>   parameters.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[in] key Key string for value that should be set.
  !> @param[in] typename Type of value being set.
  !> @param[in] val Pointer to data that item should be set to.
  subroutine generic_map_set_item(x, key, typename, val)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    character(len=*) :: typename
    type(c_ptr) :: val
    integer(kind=c_int) :: c_out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(typename)+1) :: c_typename
    c_key = trim(key)//c_null_char
    c_typename = trim(typename)//c_null_char
    c_out = generic_map_set_item_c(x, c_key, c_typename, val)
    if (c_out.lt.0) then
       stop "Error setting element in map."
    end if
  end subroutine generic_map_set_item
  !> @brief Set a scalar value in a map.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[in] key Key string for value that should be set.
  !> @param[in] val Pointer to scalar data.
  !> @param[in] subtype Subtype of scalar in value.
  !> @param[in] precision Precision of scalar in value.
  !> @param[in] units_in Units of value.
  subroutine generic_map_set_scalar(x, key, val, subtype, precision, &
       units_in)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    type(c_ptr) :: val
    character(len=*) :: subtype
    integer, intent(in) :: precision
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       allocate(character(len=0) :: units)
       units = ""
    end if
    allocate(character(len=len_trim(units)+1) :: c_units)
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_map_set_scalar_c(x, c_key, val, c_subtype, &
         int(precision, c_size_t), c_units)
    if (c_out.lt.0) then
       stop "Error setting scalar element in map."
    end if
    deallocate(c_units)
  end subroutine generic_map_set_scalar
  !> @brief Set a 1d array value in a map.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[in] key Key string for value that should be set.
  !> @param[in] val Pointer to array data.
  !> @param[in] subtype Subtype of array expected.
  !> @param[in] precision Precision of array that is expected.
  !> @param[in] length Number of elements in value.
  !> @param[in] units_in Units of value.
  subroutine generic_map_set_1darray(x, key, val, subtype, &
       precision, length, units_in)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    type(c_ptr) :: val
    character(len=*) :: subtype
    integer, intent(in) :: precision
    integer, intent(in) :: length
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       units = ""
    end if
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_map_set_1darray_c(x, c_key, val, c_subtype, &
         int(precision, c_size_t), int(length, c_size_t), c_units)
    if (c_out.lt.0) then
       stop "Error setting 1darray element in map."
    end if
  end subroutine generic_map_set_1darray
  !> @brief Set a nd array value in a map.
  !> @param[in] x Generic object that is presumed to contain a map.
  !> @param[in] key Key string for value that should be set.
  !> @param[in] data Pointer to array data.
  !> @param[in] subtype Subtype of array in value.
  !> @param[in] precision Precision of array that is in value.
  !> @param[in] shape Pointer to array containing the size of
  !>   the array in each dimension.
  !> @param[in] units_in Units that should be added to the array.
  subroutine generic_map_set_ndarray(x, key, data, subtype, &
       precision, shape, units_in)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    type(c_ptr) :: data
    character(len=*) :: subtype
    integer, intent(in) :: precision
    integer(kind=c_size_t), dimension(:), intent(in), target :: shape
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       units = ""
    end if
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_map_set_ndarray_c(x, c_key, data, c_subtype, &
         int(precision, c_size_t), int(size(shape), c_size_t), &
         c_loc(shape), c_units)
    if (c_out.lt.0) then
       stop "Error setting ndarray element in map."
    end if
  end subroutine generic_map_set_ndarray
  
end module fygg

library(yggdrasil)


get_fibonacci <- function(n) {
  pprev = 0
  prev = 1
  result = 1
  fib_no = 1
  while (fib_no < n) {
    result = prev + pprev
    pprev = prev
    prev = result
    fib_no = fib_no + 1
  }
  return(as.integer(result))
}


main <- function() {

  fprintf('Hello from R server!')

  # Create server-side rpc conneciton using model name
  rpc <- YggInterface('YggRpcServer', "server", "%d", "%d")

  # Continue receiving requests until the connection is closed when all
  # clients have disconnected.
  while (1) {
    fprintf('server(R): receiving...')
    c(retval, rpc_in) %<-% rpc$recv()
    if (!retval) {
      fprintf('server(R): end of input')
      break
    }

    # Compute fibonacci number
    n = rpc_in[[1]]
    fprintf('server(R): Received request for Fibonacci number %d', n)
    result = get_fibonacci(n)
    fprintf('server(R): Sending response for Fibonacci number %d: %d', n, result)

    # Send response back
    flag <- rpc$send(result)
    if (!flag) {
      stop('server(R): ERROR sending')
    }
    
  }

  print('Goodbye from R server')
}

main()

library(yggdrasil)


# Get input and output channels matching yaml
in1 <- YggInterface('YggInput', 'input1_R')
in2 <- YggInterface('YggInput', 'static_R')
out1 <- YggInterface('YggOutput', 'output_R')
print('SaM(R): Set up I/O channels')

# Get input from input1 channel
c(ret, adata) %<-% in1$recv()
if (!ret) {
  stop('SaM(R): ERROR RECV from input1')
}
a <- strtoi(adata)
fprintf('SaM(R): Received %d from input1', a)

# Get input from static channel
c(ret, bdata) %<-% in2$recv()
if (!ret) {
  stop('SaM(R): ERROR RECV from static')
}
b <- strtoi(bdata)
fprintf('SaM(R): Received %d from static', b)

# Compute sum and send message to output channel
sum <- a + b
outdata = sprintf('%d', sum)
ret <- out1$send(outdata)
if (!ret) {
  stop('SaM(R): ERROR SEND to output')
}
print('SaM(R): Sent to output')

function model_function(inputB, outputB) result(out)
  character(len=*), intent(in) :: inputB
  character(len=:), pointer :: outputB
  logical :: out
  out = .true.
  allocate(character(len=len(inputB)) :: outputB)
  outputB = inputB
  write(*, '("Model B: ",A," (length = ",I3,")")') outputB, len(outputB)
end function model_function

library(yggdrasil)


fibClientPar <- function(args) {
    
  iterations <- strtoi(args[[1]])
  fprintf('Hello from R rpcFibCliPar: iterations = %d ', iterations)
  
  # Create RPC connection with server
  # RPC client-side connection will be $(server_name)_$(client_name)
  rpc <- YggInterface('YggRpcClient', "rpcFibSrv_rpcFibCliPar", "%d", "%d %d")

  # Send all of the requests to the server
  for (i in 1:iterations) {
    fprintf('rpcFibCliPar(R): fib(->%-2d) ::: ', i)
    ret <- rpc$send(as.integer(i))
    if (!ret) {
      stop('rpcFibCliPar(R): SEND FAILED')
    }
  }
  
  # Receive responses for all requests that were sent
  for (i in 1:iterations) {
    c(ret, fib) %<-% rpc$recv()
    if (!ret) {
      stop('rpcFibCliPar(R): RECV FAILED')
    }
    fprintf('rpcFibCliPar(R): fib(%2d<-) = %-2d<-', fib[[1]], fib[[2]])
  }

  print('Goodbye from R rpcFibCliPar')
}


args <- commandArgs(trailingOnly=TRUE)
fibClientPar(args)

# Import library for input/output
library(yggdrasil)

# Initialize input/output channels
in_channel <- YggInterface('YggPandasInput', 'inputA')
out_channel <- YggInterface('YggPandasOutput', 'outputA')

# Loop until there is no longer input or the queues are closed
while(TRUE) {

  # Receive input from input channel
  # If there is an error, the flag will be False
  c(flag, frame) %<-% in_channel$recv()
  if (!flag) {
    print('Model A: No more input.')
    break
  }

  # Print received message
  fprintf('Model A: (%d rows)', nrow(frame))
  print(frame)

  # Send output to output channel
  # If there is an error, the flag will be False
  flag = out_channel$send(frame)
  if (!flag) {
    stop('Model A: Error sending output.')
  }

}

function model_function(inputA, outputA) result(out)
  character(len=*), intent(in) :: inputA
  character(len=:), pointer :: outputA
  logical :: out
  out = .true.
  allocate(character(len=len(inputA)) :: outputA)
  outputA = inputA
  write(*, '("Model A: ",A," (length = ",I3,")")') outputA, len(outputA)
end function model_function

program main
  ! Include interface methods
  use fygg

  integer, parameter :: BSIZE = 8192
  logical :: ret
  integer :: error_code = 0
  type(yggcomm) :: file_input, file_output, &
       table_input, table_output, array_input, array_output
  integer(kind=c_size_t), target :: line_size = LINE_SIZE_MAX
  type(yggchar_r) :: line  ! Wrapped to be reallocatable
  character(len=BSIZE), target :: name
  integer(kind=c_size_t), target :: name_siz = BSIZE
  integer(kind=8) :: number
  real(kind=8) :: value
  complex(kind=8) :: comp
  integer(kind=c_size_t), target :: nrows
  type(character_1d), target :: name_arr
  type(integer8_1d), target :: number_arr
  type(real8_1d), target :: value_arr
  type(complex8_1d), target :: comp_arr
  integer(kind=c_size_t) :: i

  ! Input & output to an ASCII file line by line
  file_input = ygg_ascii_file_input("inputF_file")
  file_output = ygg_ascii_file_output("outputF_file")
  ! Input & output from a table row by row
  table_input = ygg_ascii_table_input("inputF_table")
  table_output = ygg_ascii_table_output("outputF_table", &
       "%5s\t%ld\t%3.1f\t%3.1lf%+3.1lfj\n")
  ! Input & output from a table as an array
  array_input = ygg_ascii_array_input("inputF_array")
  array_output = ygg_ascii_array_output("outputF_array", &
       "%5s\t%ld\t%3.1f\t%3.1lf%+3.1lfj\n")

  ! Read lines from ASCII text file until end of file is reached.
  ! As each line is received, it is then sent to the output ASCII file.
  write(*, '("ascii_io(F): Receiving/sending ASCII file.")')
  ret = .true.
  do while (ret)
     line_size = size(line%x)  ! Reset to size of buffer

     ! Receive a single line
     ret = ygg_recv_var_realloc(file_input, &
          [yggarg(line), yggarg(line_size)])
     if (ret) then
        ! If the receive was succesful, send the line to output
        write(*, '("File: ",80A)', advance="no") line%x
        ret = ygg_send_var(file_output, &
             [yggarg(line), yggarg(line_size)])
        if (.not.ret) then
           write(*, '("ascii_io(F): ERROR SENDING LINE")')
           error_code = -1
           exit
        end if
     else
        ! If the receive was not succesful, send the end-of-file message to
        ! close the output file.
        write(*, '("End of file input (F)")')
     end if
  end do

  ! Read rows from ASCII table until end of file is reached.
  ! As each row is received, it is then sent to the output ASCII table
  write(*, '("ascii_io(F): Receiving/sending ASCII table.")')
  ret = .true.
  do while (ret)
     name_siz = BSIZE  ! Reset to size of the buffer

     ! Receive a single row with values stored in scalars declared locally
     ret = ygg_recv_var(table_input, &
          [yggarg(name), yggarg(name_siz), yggarg(number), &
          yggarg(value), yggarg(comp)])

     if (ret) then
        ! If the receive was succesful, send the values to output. Formatting
        ! is taken care of on the output driver side.
        write (*, '("Table: ",A,", ",I7,", ",F10.5,", ",2F10.5)') &
             trim(name), number, value, comp
        ret = ygg_send_var(table_output, &
             [yggarg(name), yggarg(name_siz), yggarg(number), &
             yggarg(value), yggarg(comp)])
        if (.not.ret) then
           write(*, '("ascii_io(F): ERROR SENDING ROW")')
           error_code = -1
           exit
        end if
     else
        ! If the receive was not succesful, send the end-of-file message to
        ! close the output file.
        write(*, '("End of table input (F)")')
     end if
  end do

  ! Read entire array from ASCII table into columns that are dynamically
  ! allocated. The returned values tells us the number of elements in the
  ! columns.
  write(*, '("Receiving/sending ASCII table as array.")')
  ret = .true.
  do while (ret)
     ret = ygg_recv_var_realloc(array_input, [yggarg(nrows), &
          yggarg(name_arr), yggarg(number_arr), &
          yggarg(value_arr), yggarg(comp_arr)])
     if (ret) then
        write(*, '("Array: (",I7," rows)")') nrows
        ! Print each line in the array
        do i = 1, nrows
           write(*, '(5A)', advance="no") name_arr%x(i)%x
           write(*, '(", ",I7,", ",F10.5,", ",2F10.5)') &
                number_arr%x(i), value_arr%x(i), comp_arr%x(i)
        end do
        ! Send the columns in the array to output. Formatting is handled on the
        ! output driver side.
        ret = ygg_send_var(array_output, [yggarg(nrows), &
             yggarg(name_arr), yggarg(number_arr), &
             yggarg(value_arr), yggarg(comp_arr)])
        if (.not.ret) then
           write(*, '("ascii_io(F): ERROR SENDING ARRAY")')
           error_code = -1
           exit
        end if
     else
        write(*, '("End of array input (F)")')
     end if
  end do

  if (error_code.lt.0) then
     stop 1
  end if

end program main

function model_function(in_buf, out_buf) result(ret)
  character(len=*), intent(in) :: in_buf
  type(yggchar_r) :: out_buf
  logical :: ret
  type(yggcomm) :: rpc
  WITH_GLOBAL_SCOPE(rpc = ygg_rpc_client("server_client"))
  write(*, '("client(F): ",A," (length = ",I3,")")') in_buf, len(in_buf)
  ret = ygg_rpc_call_realloc(rpc, yggarg(in_buf), yggarg(out_buf))
  if (.not.ret) then
     write(*, '("client(F): RPC CALL ERROR")')
     stop 1
  end if
end function model_function

function model_function(in_buf, out_buf) result(out)
  character(len=*), intent(in) :: in_buf
  character(len=:), pointer :: out_buf
  logical :: out
  write(*, '("server(Fortran): ",A)') in_buf
  out = .true.
  allocate(character(len=len(in_buf)) :: out_buf)
  out_buf = in_buf
end function model_function

program main
  use fygg

  interface
     function get_fibonacci(n) result(out)
       integer, intent(in) :: n
       integer :: out
     end function get_fibonacci
  end interface

  type(yggcomm) :: rpc
  logical :: ret
  integer :: fib, n
  integer :: exit_code = 0

  write(*, '("Hello from Fortran server!")')

  ! Create server-side rpc conneciton using model name
  rpc = ygg_rpc_server("server", "%d", "%d")

  ! Initialize variables
  ret = .true.
  fib = -1

  ! Continue receiving requests until the connection is closed when all
  ! clients have disconnected.
  do while (.TRUE.)
     write(*, '("server(F): receiving...")')
     ret = ygg_recv_var(rpc, yggarg(n))
     if (.not.ret) then
        write(*, '("server(F): end of input")')
        exit
     end if

     ! Compute fibonacci number
     write(*, '("server(F): Received request for Fibonacci number ",i2)') n
     fib = get_fibonacci(n)
     write(*, '("server(F): Sending response for Fibonacci number ",i2,": ",i2)') n, fib

     ! Send response back
     ret = ygg_send_var(rpc, yggarg(fib))
     if (.not.ret) then
        write(*, '("server(F): ERROR sending")')
        exit_code = -1;
        exit;
     end if
  end do

  write(*, '("Goodbye from Fortran server")')
  if (exit_code.lt.0) then
     stop 1
  end if

end program main

function get_fibonacci(n) result(out)
  integer, intent(in) :: n
  integer :: out
  integer :: pprev, prev, fib_no
  pprev = 0
  prev = 1
  out = 1
  fib_no = 1
  do while (fib_no < n)
     out = prev + pprev
     pprev = prev
     prev = out
     fib_no = fib_no + 1
  end do
end function get_fibonacci

library(yggdrasil)


charset = strsplit("0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ", '')[[1]]

msg_size = YggInterface('YGG_MSG_BUF')
fprintf("maxMsgCli(R): Hello message size %d.", msg_size)

# Create a max message, send/recv and verify
rpc <- YggInterface('YggRpcClient', "maxMsgSrv_maxMsgCli", "%s", "%s")

# Create a max message
output <- paste(sample(charset, msg_size, replace=TRUE), collapse='')

# Call RPC server
c(ret, input) %<-% rpc$call(output)
if (!ret) {
  stop("maxMsgCli(R): RPC ERROR")
}

# Check to see if response matches
if (input[[1]] != output) {
  stop("maxMsgCli(R): ERROR: input/output do not match")
} else {
  print("maxMsgCli(R): CONFIRM")
}

# All done, say goodbye
print("maxMsgCli(R): Goodbye!")

function yggptr_c2f(x, realloc) result(flag)
  implicit none
  type(yggptr) :: x
  logical :: realloc
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: array_ndim
  integer(kind=c_size_t), dimension(:), pointer :: array_shape
  integer(kind=c_size_t), pointer :: precision
  integer(kind=8) :: i
  logical :: flag
  character(len=500) :: log_msg
  flag = .true.
  call ygglog_debug("yggptr_c2f: begin")
  allocate(array_len)
  allocate(array_ndim)
  allocate(array_shape(1))
  allocate(precision)
  array_len = 1
  array_ndim = 1
  array_shape(1) = 1
  precision = 1
  if (x%array) then
     if ((x%ndim.gt.1).or.x%ndarray) then
        deallocate(array_ndim)
        deallocate(array_shape)
        call c_f_pointer(x%ndim_ptr, array_ndim)
        call c_f_pointer(x%shape_ptr, array_shape, [array_ndim])
        do i = 1, array_ndim
           array_len = array_len * array_shape(i)
        end do
        write(log_msg, '("array_ndim = ",i7)') array_ndim
        call ygglog_debug(log_msg)
     else
        deallocate(array_len)
        call c_f_pointer(x%len_ptr, array_len)
        array_shape(1) = array_len
     end if
     write(log_msg, '("array_len = ",i7)') array_len
     call ygglog_debug(log_msg)
  end if
  if ((x%type.eq."character").or.(x%type.eq."unicode")) then
     deallocate(precision)
     call c_f_pointer(x%prec_ptr, precision)
     write(log_msg, '("precision = ",i7)') precision
     call ygglog_debug(log_msg)
  end if
  flag = yggptr_realloc(x, array_shape, precision, realloc)
  if (x%array) then
     if (x%alloc) then
        select type(item=>x%item)
        type is (unsigned1_1d)
           call yggptr_c2f_1darray_realloc_unsigned(x)
        type is (unsigned2_1d)
           call yggptr_c2f_1darray_realloc_unsigned(x)
        type is (unsigned4_1d)
           call yggptr_c2f_1darray_realloc_unsigned(x)
        type is (unsigned8_1d)
           call yggptr_c2f_1darray_realloc_unsigned(x)
        type is (c_long_1d)
           call yggptr_c2f_1darray_realloc_integer(x)
        type is (integer_1d)
           call yggptr_c2f_1darray_realloc_integer(x)
        type is (integer2_1d)
           call yggptr_c2f_1darray_realloc_integer(x)
        type is (integer4_1d)
           call yggptr_c2f_1darray_realloc_integer(x)
        type is (integer8_1d)
           call yggptr_c2f_1darray_realloc_integer(x)
        type is (real_1d)
           call yggptr_c2f_1darray_realloc_real(x)
        type is (real4_1d)
           call yggptr_c2f_1darray_realloc_real(x)
        type is (real8_1d)
           call yggptr_c2f_1darray_realloc_real(x)
        type is (real16_1d)
           call yggptr_c2f_1darray_realloc_real(x)
        type is (complex_1d)
           call yggptr_c2f_1darray_realloc_complex(x)
        type is (complex4_1d)
           call yggptr_c2f_1darray_realloc_complex(x)
        type is (complex8_1d)
           call yggptr_c2f_1darray_realloc_complex(x)
        type is (complex16_1d)
           call yggptr_c2f_1darray_realloc_complex(x)
        type is (logical_1d)
           call yggptr_c2f_1darray_realloc_logical(x)
        type is (logical1_1d)
           call yggptr_c2f_1darray_realloc_logical(x)
        type is (logical2_1d)
           call yggptr_c2f_1darray_realloc_logical(x)
        type is (logical4_1d)
           call yggptr_c2f_1darray_realloc_logical(x)
        type is (logical8_1d)
           call yggptr_c2f_1darray_realloc_logical(x)
        type is (character_1d)
           call yggptr_c2f_1darray_realloc_character(x)
        type is (unsigned1_nd)
           call yggptr_c2f_ndarray_realloc_unsigned(x)
        type is (unsigned2_nd)
           call yggptr_c2f_ndarray_realloc_unsigned(x)
        type is (unsigned4_nd)
           call yggptr_c2f_ndarray_realloc_unsigned(x)
        type is (unsigned8_nd)
           call yggptr_c2f_ndarray_realloc_unsigned(x)
        type is (c_long_nd)
           call yggptr_c2f_ndarray_realloc_integer(x)
        type is (integer_nd)
           call yggptr_c2f_ndarray_realloc_integer(x)
        type is (integer2_nd)
           call yggptr_c2f_ndarray_realloc_integer(x)
        type is (integer4_nd)
           call yggptr_c2f_ndarray_realloc_integer(x)
        type is (integer8_nd)
           call yggptr_c2f_ndarray_realloc_integer(x)
        type is (real_nd)
           call yggptr_c2f_ndarray_realloc_real(x)
        type is (real4_nd)
           call yggptr_c2f_ndarray_realloc_real(x)
        type is (real8_nd)
           call yggptr_c2f_ndarray_realloc_real(x)
        type is (real16_nd)
           call yggptr_c2f_ndarray_realloc_real(x)
        type is (complex_nd)
           call yggptr_c2f_ndarray_realloc_complex(x)
        type is (complex4_nd)
           call yggptr_c2f_ndarray_realloc_complex(x)
        type is (complex8_nd)
           call yggptr_c2f_ndarray_realloc_complex(x)
        type is (complex16_nd)
           call yggptr_c2f_ndarray_realloc_complex(x)
        type is (logical_nd)
           call yggptr_c2f_ndarray_realloc_logical(x)
        type is (logical1_nd)
           call yggptr_c2f_ndarray_realloc_logical(x)
        type is (logical2_nd)
           call yggptr_c2f_ndarray_realloc_logical(x)
        type is (logical4_nd)
           call yggptr_c2f_ndarray_realloc_logical(x)
        type is (logical8_nd)
           call yggptr_c2f_ndarray_realloc_logical(x)
        type is (character_nd)
           call yggptr_c2f_ndarray_realloc_character(x)
        class default
           write(log_msg, '("yggptr_c2f (realloc array transfer): Unexpected type: ",A)') x%type
           call ygglog_error(log_msg)
           stop "ERROR"
        end select
     else
        if (x%ndim.gt.1) then
           select type(item=>x%item_array)
           type is (ygguint1)
              call yggptr_c2f_ndarray_unsigned(x)
           type is (ygguint2)
              call yggptr_c2f_ndarray_unsigned(x)
           type is (ygguint4)
              call yggptr_c2f_ndarray_unsigned(x)
           type is (ygguint8)
              call yggptr_c2f_ndarray_unsigned(x)
           type is (integer(kind=2))
              call yggptr_c2f_ndarray_integer(x)
           type is (integer(kind=4))
              call yggptr_c2f_ndarray_integer(x)
           type is (integer(kind=8))
              call yggptr_c2f_ndarray_integer(x)
           type is (real(kind=4))
              call yggptr_c2f_ndarray_real(x)
           type is (real(kind=8))
              call yggptr_c2f_ndarray_real(x)
           ! type is (real(kind=16))
           !    call yggptr_c2f_ndarray_real(x)
           type is (complex(kind=4))
              call yggptr_c2f_ndarray_complex(x)
           type is (complex(kind=8))
              call yggptr_c2f_ndarray_complex(x)
           ! type is (complex(kind=16))
           !    call yggptr_c2f_ndarray_complex(x)
           type is (logical(kind=1))
              call yggptr_c2f_ndarray_logical(x)
           type is (logical(kind=2))
              call yggptr_c2f_ndarray_logical(x)
           type is (logical(kind=4))
              call yggptr_c2f_ndarray_logical(x)
           type is (logical(kind=8))
              call yggptr_c2f_ndarray_logical(x)
           type is (character(*))
              call yggptr_c2f_ndarray_character(x)
           class default
              write(log_msg, '("yggptr_c2f (",i2,"D array transfer): Unexpected type: ",A)') x%ndim, x%type
              call ygglog_error(log_msg)
              stop "ERROR"
           end select
        else
           select type(item=>x%item_array)
           type is (ygguint1)
           type is (ygguint2)
           type is (ygguint4)
           type is (ygguint8)
           type is (integer(kind=2))
           type is (integer(kind=4))
           type is (integer(kind=8))
           type is (real(kind=4))
           type is (real(kind=8))
           ! type is (real(kind=16))
           type is (complex(kind=4))
           type is (complex(kind=8))
           ! type is (complex(kind=16))
           type is (logical(kind=1))
           type is (logical(kind=2))
           type is (logical(kind=4))
           type is (logical(kind=8))
           type is (yggchar_r)
              call yggptr_c2f_array_character(x)
           type is (character(*))
              call yggptr_c2f_array_character(x)
           class default
              write(log_msg, '("yggptr_c2f (1d array transfer): Unexpected type: ",A)') x%type
              call ygglog_error(log_msg)
              stop "ERROR"
           end select
        end if
     end if
  else
     select type(item=>x%item)
     type is (ygguint1)
     type is (ygguint2)
     type is (ygguint4)
     type is (ygguint8)
     type is (integer(kind=2))
     type is (integer(kind=4))
     type is (integer(kind=8))
     type is (real(kind=4))
     type is (real(kind=8))
     ! type is (real(kind=16))
     type is (complex(kind=4))
     type is (complex(kind=8))
     ! type is (complex(kind=16))
     type is (logical(kind=1))
     type is (logical(kind=2))
     type is (logical(kind=4))
     type is (logical(kind=8))
     type is (yggnull)
     type is (yggchar_r)
        call yggptr_c2f_scalar_character(x)
     type is (character(*))
        call yggptr_c2f_scalar_character(x)
     class default
        if ((x%type.eq."ply").or.(x%type.eq."obj").or. &
             (x%type.eq."generic").or.(x%type.eq."object").or. &
             (x%type.eq."array").or.(x%type.eq."schema").or. &
             (x%type.eq."python").or.(x%type.eq."class").or. &
             (x%type.eq."instance").or.(x%type.eq."function")) then
           ! Use pointer        
        else
           select type(item=>x%item)
           type is (character(kind=ucs4, len=*))
              call yggptr_c2f_scalar_character(x)
           class default
              write(log_msg, '("yggptr_c2f (scalar transfer): Unexpected type: ",A)') x%type
              call ygglog_error(log_msg)
              stop "ERROR"
           end select
        end if
     end select
  end if
  if (.not.x%array) then
     deallocate(array_len)
     deallocate(array_ndim)
     deallocate(array_shape)
  else
     if (x%ndim.gt.1) then
        deallocate(array_len)
        nullify(array_ndim)
        nullify(array_shape)
     else
        nullify(array_len)
        deallocate(array_ndim)
        deallocate(array_shape)
     end if
  end if
  if (.not.((x%type.eq."character").or.(x%type.eq."unicode"))) then
     deallocate(precision)
  else
     nullify(precision)
  end if
  call ygglog_debug("yggptr_c2f: end")
end function yggptr_c2f


subroutine yggptr_c2f_scalar_character(x)
  implicit none
  type(yggptr) :: x
  character(kind=ucs4, len=:), &
       pointer :: x_unicode
  character(len=:), pointer :: x_character
  type(yggchar_r), pointer :: x_character_realloc
  integer(kind=8) :: i
  select type(item=>x%item)
  type is (yggchar_r)
     x_character_realloc => item
     if (.not.associated(x_character_realloc%x)) then
        call c_f_pointer(x%ptr, x_character_realloc%x, [x%prec])
     end if
     do i = (x%prec + 1), size(x_character_realloc%x)
        x_character_realloc%x(i) = ' '
     end do
  type is (character(*))
     x_character => item
     do i = 1, x%prec
        x_character(i:i) = x%data_character_unit(i)
     end do
     do i = (x%prec + 1), len(x_character)
        x_character(i:i) = ' '
     end do
     deallocate(x%data_character_unit)
  class default
     select type(item=>x%item)
     type is (character(kind=ucs4, len=*))
        x_unicode => item
        do i = 1, (x%prec / 4)
           x_unicode(i:i) = x%data_unicode_unit(i)
        end do
        do i = ((x%prec / 4) + 1), len(x_unicode)
           x_unicode(i:i) = ' '
        end do
        deallocate(x%data_unicode_unit)
     class default
        call ygglog_error("yggptr_c2f_scalar_character: Unexpected type.")
        stop "ERROR"
     end select
  end select
end subroutine yggptr_c2f_scalar_character


subroutine yggptr_c2f_array_character(x)
  implicit none
  type(yggptr) :: x
  character, dimension(:), pointer :: xarr_character
  integer(kind=8) :: i, j
  select type(item=>x%item_array)
  type is (character(*))
     xarr_character => item
     do i = 1, x%len
        do j = 1, x%prec
           xarr_character(i)(j:j) = x%data_character_unit(i)
        end do
        do j = (x%prec + 1), len(xarr_character(i))
           xarr_character(i)(j:j) = ' '
        end do
     end do
     deallocate(x%data_character_unit)
  class default
     call ygglog_error("yggptr_c2f_array_character: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_array_character


! ND not reallocatable
subroutine yggptr_c2f_ndarray_unsigned(x)
  implicit none
  type(yggptr) :: x
  type(ygguint1), dimension(:), pointer :: x1
  type(ygguint2), dimension(:), pointer :: x2
  type(ygguint4), dimension(:), pointer :: x4
  type(ygguint8), dimension(:), pointer :: x8
  type(ygguint1), dimension(:, :), pointer :: x1_2d
  type(ygguint2), dimension(:, :), pointer :: x2_2d
  type(ygguint4), dimension(:, :), pointer :: x4_2d
  type(ygguint8), dimension(:, :), pointer :: x8_2d
  select type(item_2d=>x%item_array_2d)
  type is (ygguint1)
     x1_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (ygguint1)
        x1 => item_1d
        x1_2d = reshape(x1, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x1)
     class default
        call ygglog_error("yggptr_c2f_ndarray_unsigned: types do not match")
        stop "ERROR"
     end select
  type is (ygguint2)
     x2_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (ygguint2)
        x2 => item_1d
        x2_2d = reshape(x2, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x2)
     class default
        call ygglog_error("yggptr_c2f_ndarray_unsigned: types do not match")
        stop "ERROR"
     end select
  type is (ygguint4)
     x4_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (ygguint4)
        x4 => item_1d
        x4_2d = reshape(x4, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x4)
     class default
        call ygglog_error("yggptr_c2f_ndarray_unsigned: types do not match")
        stop "ERROR"
     end select
  type is (ygguint8)
     x8_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (ygguint8)
        x8 => item_1d
        x8_2d = reshape(x8, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x8)
     class default
        call ygglog_error("yggptr_c2f_ndarray_unsigned: types do not match")
        stop "ERROR"
     end select
  class default
     call ygglog_error("yggptr_c2f_ndarray_unsigned: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_unsigned
subroutine yggptr_c2f_ndarray_integer(x)
  implicit none
  type(yggptr) :: x
  integer(kind=2), dimension(:), pointer :: x2
  integer(kind=4), dimension(:), pointer :: x4
  integer(kind=8), dimension(:), pointer :: x8
  integer(kind=2), dimension(:, :), pointer :: x2_2d
  integer(kind=4), dimension(:, :), pointer :: x4_2d
  integer(kind=8), dimension(:, :), pointer :: x8_2d
  select type(item_2d=>x%item_array_2d)
  type is (integer(kind=2))
     x2_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (integer(kind=2))
        x2 => item_1d
        x2_2d = reshape(x2, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x2)
     class default
        call ygglog_error("yggptr_c2f_ndarray_integer: types do not match")
        stop "ERROR"
     end select
  type is (integer(kind=4))
     x4_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (integer(kind=4))
        x4 => item_1d
        x4_2d = reshape(x4, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x4)
     class default
        call ygglog_error("yggptr_c2f_ndarray_integer: types do not match")
        stop "ERROR"
     end select
  type is (integer(kind=8))
     x8_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (integer(kind=8))
        x8 => item_1d
        x8_2d = reshape(x8, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x8)
     class default
        call ygglog_error("yggptr_c2f_ndarray_integer: types do not match")
        stop "ERROR"
     end select
  class default
     call ygglog_error("yggptr_c2f_ndarray_integer: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_integer
subroutine yggptr_c2f_ndarray_real(x)
  implicit none
  type(yggptr) :: x
  real(kind=4), dimension(:), pointer :: x4
  real(kind=8), dimension(:), pointer :: x8
  ! real(kind=16), dimension(:), pointer :: x16
  real(kind=4), dimension(:, :), pointer :: x4_2d
  real(kind=8), dimension(:, :), pointer :: x8_2d
  ! real(kind=16), dimension(:, :), pointer :: x16_2d
  select type(item_2d=>x%item_array_2d)
  type is (real(kind=4))
     x4_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (real(kind=4))
        x4 => item_1d
        x4_2d = reshape(x4, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x4)
     class default
        call ygglog_error("yggptr_c2f_ndarray_real: types do not match")
        stop "ERROR"
     end select
  type is (real(kind=8))
     x8_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (real(kind=8))
        x8 => item_1d
        x8_2d = reshape(x8, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x8)
     class default
        call ygglog_error("yggptr_c2f_ndarray_real: types do not match")
        stop "ERROR"
     end select
  ! type is (real(kind=16))
  !    x16_2d => item_2d
  !    select type(item_1d=>x%item_array)
  !    type is (real(kind=16))
  !       x16 => item_1d
  !       x16_2d = reshape(x16, [x%shape(1), x%shape(2)])
  !       nullify(x%item_array)
  !       deallocate(x16)
  !    class default
  !       call ygglog_error("yggptr_c2f_ndarray_real: types do not match")
  !       stop "ERROR"
  !    end select
  class default
     call ygglog_error("yggptr_c2f_ndarray_real: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_real
subroutine yggptr_c2f_ndarray_complex(x)
  implicit none
  type(yggptr) :: x
  complex(kind=4), dimension(:), pointer :: x4
  complex(kind=8), dimension(:), pointer :: x8
  ! complex(kind=16), dimension(:), pointer :: x16
  complex(kind=4), dimension(:, :), pointer :: x4_2d
  complex(kind=8), dimension(:, :), pointer :: x8_2d
  ! complex(kind=16), dimension(:, :), pointer :: x16_2d
  select type(item_2d=>x%item_array_2d)
  type is (complex(kind=4))
     x4_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (complex(kind=4))
        x4 => item_1d
        x4_2d = reshape(x4, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x4)
     class default
        call ygglog_error("yggptr_c2f_ndarray_complex: types do not match")
        stop "ERROR"
     end select
  type is (complex(kind=8))
     x8_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (complex(kind=8))
        x8 => item_1d
        x8_2d = reshape(x8, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x8)
     class default
        call ygglog_error("yggptr_c2f_ndarray_complex: types do not match")
        stop "ERROR"
     end select
  ! type is (complex(kind=16))
  !    x16_2d => item_2d
  !    select type(item_1d=>x%item_array)
  !    type is (complex(kind=16))
  !       x16 => item_1d
  !       x16_2d = reshape(x16, [x%shape(1), x%shape(2)])
  !       nullify(x%item_array)
  !       deallocate(x16)
  !    class default
  !       call ygglog_error("yggptr_c2f_ndarray_complex: types do not match")
  !       stop "ERROR"
  !    end select
  class default
     call ygglog_error("yggptr_c2f_ndarray_complex: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_complex
subroutine yggptr_c2f_ndarray_logical(x)
  implicit none
  type(yggptr) :: x
  logical(kind=1), dimension(:), pointer :: x1
  logical(kind=2), dimension(:), pointer :: x2
  logical(kind=4), dimension(:), pointer :: x4
  logical(kind=8), dimension(:), pointer :: x8
  logical(kind=1), dimension(:, :), pointer :: x1_2d
  logical(kind=2), dimension(:, :), pointer :: x2_2d
  logical(kind=4), dimension(:, :), pointer :: x4_2d
  logical(kind=8), dimension(:, :), pointer :: x8_2d
  select type(item_2d=>x%item_array_2d)
  type is (logical(kind=1))
     x1_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (logical(kind=1))
        x1 => item_1d
        x1_2d = reshape(x1, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x1)
     class default
        call ygglog_error("yggptr_c2f_ndarray_logical: types do not match")
        stop "ERROR"
     end select
  type is (logical(kind=2))
     x2_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (logical(kind=2))
        x2 => item_1d
        x2_2d = reshape(x2, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x2)
     class default
        call ygglog_error("yggptr_c2f_ndarray_logical: types do not match")
        stop "ERROR"
     end select
  type is (logical(kind=4))
     x4_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (logical(kind=4))
        x4 => item_1d
        x4_2d = reshape(x4, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x4)
     class default
        call ygglog_error("yggptr_c2f_ndarray_logical: types do not match")
        stop "ERROR"
     end select
  type is (logical(kind=8))
     x8_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (logical(kind=8))
        x8 => item_1d
        x8_2d = reshape(x8, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(x8)
     class default
        call ygglog_error("yggptr_c2f_ndarray_logical: types do not match")
        stop "ERROR"
     end select
  class default
     call ygglog_error("yggptr_c2f_ndarray_logical: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_logical
subroutine yggptr_c2f_ndarray_character(x)
  implicit none
  type(yggptr) :: x
  character(len=:), dimension(:), pointer :: xc
  character(len=:), dimension(:, :), pointer :: xc_2d
  integer(kind=c_size_t) :: i, j
  select type(item_2d=>x%item_array_2d)
  type is (character(*))
     xc_2d => item_2d
     select type(item_1d=>x%item_array)
     type is (character(*))
        xc => item_1d
        allocate(character(len=x%prec) :: xc_2d(x%shape(1), x%shape(2)))
        do i = 1, x%shape(1)
           do j = 1, x%shape(2)
              xc_2d(i, j) = xc(i + (j-1)*(x%shape(1)))
           enddo
        enddo
        ! xc_2d = reshape(xc, [x%shape(1), x%shape(2)])
        nullify(x%item_array)
        deallocate(xc)
     class default
        call ygglog_error("yggptr_c2f_ndarray_logical: types do not match")
        stop "ERROR"
     end select
  class default
     call ygglog_error("yggptr_c2f_ndarray_character: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_character


! 1D reallocatable
subroutine yggptr_c2f_1darray_realloc_unsigned(x)
  implicit none
  type(yggptr) :: x
  type(unsigned1_1d), pointer :: x_unsigned1_1d
  type(unsigned2_1d), pointer :: x_unsigned2_1d
  type(unsigned4_1d), pointer :: x_unsigned4_1d
  type(unsigned8_1d), pointer :: x_unsigned8_1d
  select type(item=>x%item)
  type is (unsigned1_1d)
     x_unsigned1_1d => item
     if (.not.associated(x_unsigned1_1d%x)) then
        call c_f_pointer(x%ptr, x_unsigned1_1d%x, [x%len])
     end if
  type is (unsigned2_1d)
     x_unsigned2_1d => item
     if (.not.associated(x_unsigned2_1d%x)) then
        call c_f_pointer(x%ptr, x_unsigned2_1d%x, [x%len])
     end if
  type is (unsigned4_1d)
     x_unsigned4_1d => item
     if (.not.associated(x_unsigned4_1d%x)) then
        call c_f_pointer(x%ptr, x_unsigned4_1d%x, [x%len])
     end if
  type is (unsigned8_1d)
     x_unsigned8_1d => item
     if (.not.associated(x_unsigned8_1d%x)) then
        call c_f_pointer(x%ptr, x_unsigned8_1d%x, [x%len])
     end if
  class default
     call ygglog_error("yggptr_c2f_1darray_realloc_unsigned: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_1darray_realloc_unsigned
subroutine yggptr_c2f_1darray_realloc_integer(x)
  implicit none
  type(yggptr) :: x
  type(c_long_1d), pointer :: x_c_long_1d
  type(integer_1d), pointer :: x_integer_1d
  type(integer2_1d), pointer :: x_integer2_1d
  type(integer4_1d), pointer :: x_integer4_1d
  type(integer8_1d), pointer :: x_integer8_1d
  select type(item=>x%item)
  type is (c_long_1d)
     x_c_long_1d => item
     if (.not.associated(x_c_long_1d%x)) then
        call c_f_pointer(x%ptr, x_c_long_1d%x, [x%len])
     end if
  type is (integer_1d)
     x_integer_1d => item
     if (.not.associated(x_integer_1d%x)) then
        call c_f_pointer(x%ptr, x_integer_1d%x, [x%len])
     end if
  type is (integer2_1d)
     x_integer2_1d => item
     if (.not.associated(x_integer2_1d%x)) then
        call c_f_pointer(x%ptr, x_integer2_1d%x, [x%len])
     end if
  type is (integer4_1d)
     x_integer4_1d => item
     if (.not.associated(x_integer4_1d%x)) then
        call c_f_pointer(x%ptr, x_integer4_1d%x, [x%len])
     end if
  type is (integer8_1d)
     x_integer8_1d => item
     if (.not.associated(x_integer8_1d%x)) then
        call c_f_pointer(x%ptr, x_integer8_1d%x, [x%len])
     end if
  class default
     call ygglog_error("yggptr_c2f_1darray_realloc_integer: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_1darray_realloc_integer
subroutine yggptr_c2f_1darray_realloc_real(x)
  implicit none
  type(yggptr) :: x
  type(real_1d), pointer :: x_real_1d
  type(real4_1d), pointer :: x_real4_1d
  type(real8_1d), pointer :: x_real8_1d
  type(real16_1d), pointer :: x_real16_1d
  select type(item=>x%item)
  type is (real_1d)
     x_real_1d => item
     if (.not.associated(x_real_1d%x)) then
        call c_f_pointer(x%ptr, x_real_1d%x, [x%len])
     end if
  type is (real4_1d)
     x_real4_1d => item
     if (.not.associated(x_real4_1d%x)) then
        call c_f_pointer(x%ptr, x_real4_1d%x, [x%len])
     end if
  type is (real8_1d)
     x_real8_1d => item
     if (.not.associated(x_real8_1d%x)) then
        call c_f_pointer(x%ptr, x_real8_1d%x, [x%len])
     end if
  type is (real16_1d)
     x_real16_1d => item
     if (.not.associated(x_real16_1d%x)) then
        call c_f_pointer(x%ptr, x_real16_1d%x, [x%len])
     end if
  class default
     call ygglog_error("yggptr_c2f_1darray_realloc_real: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_1darray_realloc_real
subroutine yggptr_c2f_1darray_realloc_complex(x)
  implicit none
  type(yggptr) :: x
  type(complex_1d), pointer :: x_complex_1d
  type(complex4_1d), pointer :: x_complex4_1d
  type(complex8_1d), pointer :: x_complex8_1d
  type(complex16_1d), pointer :: x_complex16_1d
  select type(item=>x%item)
  type is (complex_1d)
     x_complex_1d => item
     if (.not.associated(x_complex_1d%x)) then
        call c_f_pointer(x%ptr, x_complex_1d%x, [x%len])
     end if
  type is (complex4_1d)
     x_complex4_1d => item
     if (.not.associated(x_complex4_1d%x)) then
        call c_f_pointer(x%ptr, x_complex4_1d%x, [x%len])
     end if
  type is (complex8_1d)
     x_complex8_1d => item
     if (.not.associated(x_complex8_1d%x)) then
        call c_f_pointer(x%ptr, x_complex8_1d%x, [x%len])
     end if
  type is (complex16_1d)
     x_complex16_1d => item
     if (.not.associated(x_complex16_1d%x)) then
        call c_f_pointer(x%ptr, x_complex16_1d%x, [x%len])
     end if
  class default
     call ygglog_error("yggptr_c2f_1darray_realloc_complex: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_1darray_realloc_complex
subroutine yggptr_c2f_1darray_realloc_logical(x)
  implicit none
  type(yggptr) :: x
  type(logical_1d), pointer :: x_logical_1d
  type(logical1_1d), pointer :: x_logical1_1d
  type(logical2_1d), pointer :: x_logical2_1d
  type(logical4_1d), pointer :: x_logical4_1d
  type(logical8_1d), pointer :: x_logical8_1d
  select type(item=>x%item)
  type is (logical_1d)
     x_logical_1d => item
     if (.not.associated(x_logical_1d%x)) then
        call c_f_pointer(x%ptr, x_logical_1d%x, [x%len])
     end if
  type is (logical1_1d)
     x_logical1_1d => item
     if (.not.associated(x_logical1_1d%x)) then
        call c_f_pointer(x%ptr, x_logical1_1d%x, [x%len])
     end if
  type is (logical2_1d)
     x_logical2_1d => item
     if (.not.associated(x_logical2_1d%x)) then
        call c_f_pointer(x%ptr, x_logical2_1d%x, [x%len])
     end if
  type is (logical4_1d)
     x_logical4_1d => item
     if (.not.associated(x_logical4_1d%x)) then
        call c_f_pointer(x%ptr, x_logical4_1d%x, [x%len])
     end if
  type is (logical8_1d)
     x_logical8_1d => item
     if (.not.associated(x_logical8_1d%x)) then
        call c_f_pointer(x%ptr, x_logical8_1d%x, [x%len])
     end if
  class default
     call ygglog_error("yggptr_c2f_1darray_realloc_logical: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_1darray_realloc_logical
subroutine yggptr_c2f_1darray_realloc_character(x)
  implicit none
  type(yggptr) :: x
  integer(kind=8) :: i
  type(character_1d), pointer :: x_character_1d
  select type(item=>x%item)
  type is (character_1d)
     x_character_1d => item
     if (.not.associated(x%data_character_unit)) then
        call c_f_pointer(x%ptr, x%data_character_unit, [x%prec*x%len])
     end if
     do i = 1, x%len
        x_character_1d%x(i)%x = x%data_character_unit( &
             (1+(i-1)*x%prec):(i*x%prec))
     end do
     deallocate(x%data_character_unit)
  class default
     call ygglog_error("yggptr_c2f_1darray_realloc_character: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_1darray_realloc_character


! ND reallocatable
subroutine yggptr_c2f_ndarray_realloc_unsigned(x)
  implicit none
  type(yggptr) :: x
  type(unsigned1_nd), pointer :: x_unsigned1_nd
  type(unsigned2_nd), pointer :: x_unsigned2_nd
  type(unsigned4_nd), pointer :: x_unsigned4_nd
  type(unsigned8_nd), pointer :: x_unsigned8_nd
  select type(item=>x%item)
  type is (unsigned1_nd)
     x_unsigned1_nd => item
     if (.not.associated(x_unsigned1_nd%x)) then
        call c_f_pointer(x%ptr, x_unsigned1_nd%x, [x%len])
     end if
     if (.not.associated(x_unsigned1_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_unsigned1_nd%shape, [x%ndim])
     end if
  type is (unsigned2_nd)
     x_unsigned2_nd => item
     if (.not.associated(x_unsigned2_nd%x)) then
        call c_f_pointer(x%ptr, x_unsigned2_nd%x, [x%len])
     end if
     if (.not.associated(x_unsigned2_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_unsigned2_nd%shape, [x%ndim])
     end if
  type is (unsigned4_nd)
     x_unsigned4_nd => item
     if (.not.associated(x_unsigned4_nd%x)) then
        call c_f_pointer(x%ptr, x_unsigned4_nd%x, [x%len])
     end if
     if (.not.associated(x_unsigned4_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_unsigned4_nd%shape, [x%ndim])
     end if
  type is (unsigned8_nd)
     x_unsigned8_nd => item
     if (.not.associated(x_unsigned8_nd%x)) then
        call c_f_pointer(x%ptr, x_unsigned8_nd%x, [x%len])
     end if
     if (.not.associated(x_unsigned8_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_unsigned8_nd%shape, [x%ndim])
     end if
  class default
     call ygglog_error("yggptr_c2f_ndarray_realloc_unsigned: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_realloc_unsigned
subroutine yggptr_c2f_ndarray_realloc_integer(x)
  implicit none
  type(yggptr) :: x
  type(c_long_nd), pointer :: x_c_long_nd
  type(integer_nd), pointer :: x_integer_nd
  type(integer2_nd), pointer :: x_integer2_nd
  type(integer4_nd), pointer :: x_integer4_nd
  type(integer8_nd), pointer :: x_integer8_nd
  select type(item=>x%item)
  type is (c_long_nd)
     x_c_long_nd => item
     if (.not.associated(x_c_long_nd%x)) then
        call c_f_pointer(x%ptr, x_c_long_nd%x, [x%len])
     end if
     if (.not.associated(x_c_long_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_c_long_nd%shape, [x%ndim])
     end if
  type is (integer_nd)
     x_integer_nd => item
     if (.not.associated(x_integer_nd%x)) then
        call c_f_pointer(x%ptr, x_integer_nd%x, [x%len])
     end if
     if (.not.associated(x_integer_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_integer_nd%shape, [x%ndim])
     end if
  type is (integer2_nd)
     x_integer2_nd => item
     if (.not.associated(x_integer2_nd%x)) then
        call c_f_pointer(x%ptr, x_integer2_nd%x, [x%len])
     end if
     if (.not.associated(x_integer2_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_integer2_nd%shape, [x%ndim])
     end if
  type is (integer4_nd)
     x_integer4_nd => item
     if (.not.associated(x_integer4_nd%x)) then
        call c_f_pointer(x%ptr, x_integer4_nd%x, [x%len])
     end if
     if (.not.associated(x_integer4_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_integer4_nd%shape, [x%ndim])
     end if
  type is (integer8_nd)
     x_integer8_nd => item
     if (.not.associated(x_integer8_nd%x)) then
        call c_f_pointer(x%ptr, x_integer8_nd%x, [x%len])
     end if
     if (.not.associated(x_integer8_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_integer8_nd%shape, [x%ndim])
     end if
  class default
     call ygglog_error("yggptr_c2f_ndarray_realloc_integer: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_realloc_integer
subroutine yggptr_c2f_ndarray_realloc_real(x)
  implicit none
  type(yggptr) :: x
  type(real_nd), pointer :: x_real_nd
  type(real4_nd), pointer :: x_real4_nd
  type(real8_nd), pointer :: x_real8_nd
  type(real16_nd), pointer :: x_real16_nd
  select type(item=>x%item)
  type is (real_nd)
     x_real_nd => item
     if (.not.associated(x_real_nd%x)) then
        call c_f_pointer(x%ptr, x_real_nd%x, [x%len])
     end if
     if (.not.associated(x_real_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_real_nd%shape, [x%ndim])
     end if
  type is (real4_nd)
     x_real4_nd => item
     if (.not.associated(x_real4_nd%x)) then
        call c_f_pointer(x%ptr, x_real4_nd%x, [x%len])
     end if
     if (.not.associated(x_real4_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_real4_nd%shape, [x%ndim])
     end if
  type is (real8_nd)
     x_real8_nd => item
     if (.not.associated(x_real8_nd%x)) then
        call c_f_pointer(x%ptr, x_real8_nd%x, [x%len])
     end if
     if (.not.associated(x_real8_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_real8_nd%shape, [x%ndim])
     end if
  type is (real16_nd)
     x_real16_nd => item
     if (.not.associated(x_real16_nd%x)) then
        call c_f_pointer(x%ptr, x_real16_nd%x, [x%len])
     end if
     if (.not.associated(x_real16_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_real16_nd%shape, [x%ndim])
     end if
  class default
     call ygglog_error("yggptr_c2f_ndarray_realloc_real: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_realloc_real
subroutine yggptr_c2f_ndarray_realloc_complex(x)
  implicit none
  type(yggptr) :: x
  type(complex_nd), pointer :: x_complex_nd
  type(complex4_nd), pointer :: x_complex4_nd
  type(complex8_nd), pointer :: x_complex8_nd
  type(complex16_nd), pointer :: x_complex16_nd
  select type(item=>x%item)
  type is (complex_nd)
     x_complex_nd => item
     if (.not.associated(x_complex_nd%x)) then
        call c_f_pointer(x%ptr, x_complex_nd%x, [x%len])
     end if
     if (.not.associated(x_complex_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_complex_nd%shape, [x%ndim])
     end if
  type is (complex4_nd)
     x_complex4_nd => item
     if (.not.associated(x_complex4_nd%x)) then
        call c_f_pointer(x%ptr, x_complex4_nd%x, [x%len])
     end if
     if (.not.associated(x_complex4_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_complex4_nd%shape, [x%ndim])
     end if
  type is (complex8_nd)
     x_complex8_nd => item
     if (.not.associated(x_complex8_nd%x)) then
        call c_f_pointer(x%ptr, x_complex8_nd%x, [x%len])
     end if
     if (.not.associated(x_complex8_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_complex8_nd%shape, [x%ndim])
     end if
  type is (complex16_nd)
     x_complex16_nd => item
     if (.not.associated(x_complex16_nd%x)) then
        call c_f_pointer(x%ptr, x_complex16_nd%x, [x%len])
     end if
     if (.not.associated(x_complex16_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_complex16_nd%shape, [x%ndim])
     end if
  class default
     call ygglog_error("yggptr_c2f_ndarray_realloc_complex: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_realloc_complex
subroutine yggptr_c2f_ndarray_realloc_logical(x)
  implicit none
  type(yggptr) :: x
  type(logical_nd), pointer :: x_logical_nd
  type(logical1_nd), pointer :: x_logical1_nd
  type(logical2_nd), pointer :: x_logical2_nd
  type(logical4_nd), pointer :: x_logical4_nd
  type(logical8_nd), pointer :: x_logical8_nd
  select type(item=>x%item)
  type is (logical_nd)
     x_logical_nd => item
     if (.not.associated(x_logical_nd%x)) then
        call c_f_pointer(x%ptr, x_logical_nd%x, [x%len])
     end if
     if (.not.associated(x_logical_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_logical_nd%shape, [x%ndim])
     end if
  type is (logical1_nd)
     x_logical1_nd => item
     if (.not.associated(x_logical1_nd%x)) then
        call c_f_pointer(x%ptr, x_logical1_nd%x, [x%len])
     end if
     if (.not.associated(x_logical1_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_logical1_nd%shape, [x%ndim])
     end if
  type is (logical2_nd)
     x_logical2_nd => item
     if (.not.associated(x_logical2_nd%x)) then
        call c_f_pointer(x%ptr, x_logical2_nd%x, [x%len])
     end if
     if (.not.associated(x_logical2_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_logical2_nd%shape, [x%ndim])
     end if
  type is (logical4_nd)
     x_logical4_nd => item
     if (.not.associated(x_logical4_nd%x)) then
        call c_f_pointer(x%ptr, x_logical4_nd%x, [x%len])
     end if
     if (.not.associated(x_logical4_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_logical4_nd%shape, [x%ndim])
     end if
  type is (logical8_nd)
     x_logical8_nd => item
     if (.not.associated(x_logical8_nd%x)) then
        call c_f_pointer(x%ptr, x_logical8_nd%x, [x%len])
     end if
     if (.not.associated(x_logical8_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_logical8_nd%shape, [x%ndim])
     end if
  class default
     call ygglog_error("yggptr_c2f_ndarray_realloc_logical: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_realloc_logical
subroutine yggptr_c2f_ndarray_realloc_character(x)
  implicit none
  type(yggptr) :: x
  integer(kind=8) :: i
  type(character_nd), pointer :: x_character_nd
  select type(item=>x%item)
  type is (character_nd)
     x_character_nd => item
     if (.not.associated(x%data_character_unit)) then
        call c_f_pointer(x%ptr, x%data_character_unit, [x%prec*x%len])
     end if
     do i = 1, x%len
        x_character_nd%x(i)%x = x%data_character_unit( &
             (1+(i-1)*x%prec):(i*x%prec))
     end do
     deallocate(x%data_character_unit)
     if (.not.associated(x_character_nd%shape)) then
        call c_f_pointer(x%shape_ptr, x_character_nd%shape, [x%ndim])
     end if
  class default
     call ygglog_error("yggptr_c2f_ndarray_realloc_character: Unexpected type.")
     stop "ERROR"
  end select
end subroutine yggptr_c2f_ndarray_realloc_character

PROGRAM hello
  USE fygg

  logical :: ret = .true.
  integer :: bufsiz
  character(len = 512) :: buf = ""
  TYPE(yggcomm) :: inf, outf, inq, outq

  PRINT *, "Hello from Fortran"

  ! Ins/outs matching with the the model yaml
  inf = ygg_input("inFile")
  outf = ygg_output("outFile")
  inq = ygg_input("helloQueueIn")
  outq = ygg_output("helloQueueOut")
  PRINT *, "hello(Fortran): Created I/O channels"

  ! Receive input from a local file
  bufsiz = len(buf)
  ret = ygg_recv(inf, buf, bufsiz)
  IF (.not.ret) THEN
     PRINT *, "hello(Fortran): ERROR FILE RECV"
     STOP 1
  END IF
  PRINT *, "hello(Fortran): Received ", bufsiz, &
       "bytes from file: ", buf

  ! Send output to the output queue
  ret = ygg_send(outq, buf, bufsiz)
  IF (.not.ret) THEN
     PRINT *, "hello(Fortran): ERROR QUEUE SEND"
     STOP 1
  END IF
  PRINT *, "hello(Fortran): Sent to outq"
  
  ! Receive input form the input queue
  bufsiz = len(buf)
  ret = ygg_recv(inq, buf, bufsiz)
  IF (.not.ret) THEN
     PRINT *, "hello(Fortran): ERROR QUEUE RECV"
     STOP 1
  END IF
  PRINT *, "hello(Fortran): Received ", bufsiz, &
       "bytes from queue: ", buf

  ! Send output to a local file
  ret = ygg_send(outf, buf, bufsiz)
  IF (.not.ret) THEN
     PRINT *, "hello(Fortran): ERROR FILE SEND"
     STOP 1
  END IF
  PRINT *, "hello(Fortran): Sent to outf"

  PRINT *, "Goodbye from Fortran"
  
END PROGRAM hello

program main
  use fygg

  character(len=32) :: arg
  integer :: iterations
  type(yggcomm) :: ymlfile
  type(yggcomm) :: rpc
  type(yggcomm) :: log
  logical :: ret
  integer, parameter :: msg_len = 2048  ! YGG_MSG_MAX
  character(len=msg_len) :: ycontent
  integer :: fib, fibNo, i, nlines, count_lines
  character(len=msg_len) :: logmsg
  integer :: ycontent_siz, logmsg_siz
  character(len=2) :: fibStr

  call get_command_argument(1, arg)
  read(arg, *) iterations
  write(*, '("Hello from Fortran rpcFibCli: iterations ",i2)') iterations

  ! Set up connections matching yaml
  ! RPC client-side connection will be $(server_name)_$(client_name)
  ymlfile = ygg_input("yaml_in")
  rpc = ygg_rpc_client("rpcFibSrv_rpcFibCli", "%d", "%d %d")
  log = ygg_output("output_log")

  ! Read entire contents of yaml
  ycontent_siz = len(ycontent)
  ret = ygg_recv(ymlfile, ycontent, ycontent_siz)
  if (.not.ret) then
     write(*, '("rpcFibCli(F): RECV ERROR")')
     stop 1
  end if
  nlines = count_lines(ycontent, new_line('A'))
  write(*, '("rpcFibCli: yaml has ",i4," lines")') nlines + 1
  ret = ygg_recv(ymlfile, ycontent, ycontent_siz)

  fib = -1
  fibNo = -1
  do i = 1, iterations

     ! Call the server and receive response
     write(*, '("rpcFibCli(F): fib(->",i2,") ::: ")') i
     ret = ygg_rpc_call(rpc, yggarg(i), [yggarg(fibNo), yggarg(fib)])
     if (.not.ret) then
        write(*, '("rpcFibCli(F): RPC CALL ERROR")')
        stop 1
     end if

     ! Log result by sending it to the log connection
     write(fibStr, '(i2)') fib
     write(logmsg, '("fib(",i2,"<-) = ",A,"<-",A)') fibNo, &
          adjustl(fibStr), new_line('A')
     write(*, '(A)', advance="no") trim(logmsg)
     logmsg_siz = len_trim(logmsg)
     ret = ygg_send(log, logmsg, logmsg_siz)
     if (.not.ret) then
        write(*, '("rpcFibCli(F): SEND ERROR")')
        stop 1
     end if

  end do

  write(*, '("Goodbye from Fortran rpcFibCli")')

end program main

function count_lines(str, substr) result(c)
  implicit none
  character(len=*) :: str
  character(len=*) :: substr
  integer :: c
  integer :: k, inc, idx
  c = 0
  k = 1
  inc = len_trim(substr)
  idx = index(str(k:), substr)
  do while (idx.ne.0)
     c = c + 1
     k = k + inc
     idx = index(str(k:), substr)
  end do
end function count_lines

! use omp_lib
function model_function(in_buf, out_buf) result(ret)
  character(len=*), intent(in) :: in_buf
  type(yggchar_r) :: out_buf
  logical :: ret
  type(yggcomm) :: rpc
  character(len=255) :: nthreads_str
  integer :: nthreads, i, j, error_code, flag
  type(yggchar_r) :: out_temp
  error_code = 0
  flag = 0

  ! Initialize yggdrasil outside the threaded section
  ret = ygg_init()
  if (.not.ret) then
     write(*, '("client(F): ERROR initializing yggdrasil")')
  end if

  ! Get the number of threads from an environment variable set in the yaml
  call get_environment_variable("NTHREAD", nthreads_str)
  read(nthreads_str,*) nthreads
  call omp_set_num_threads(nthreads)
  
  !$OMP PARALLEL DO PRIVATE(ret,flag,out_temp,i,j,rpc) SHARED(error_code,out_buf,in_buf,nthreads)
  do i=1,nthreads
     !$OMP CRITICAL
     flag = error_code
     !$OMP END CRITICAL

     if (flag.eq.0) then
        ! The WITH_GLOBAL_SCOPE macro is required to ensure that the
        ! comm persists between function calls
        !$OMP CRITICAL
        WITH_GLOBAL_SCOPE(rpc = ygg_rpc_client("server_client"))
        write(*, '("client(F:",i2,"): ",A," (length = ",I3,")")') i, in_buf, len(in_buf)
        out_temp%x => null()
        ret = ygg_rpc_call_realloc(rpc, yggarg(in_buf), yggarg(out_temp))
        !$OMP END CRITICAL
        if (.not.ret) then
           write(*, '("client(F:",i2,"): RPC CALL ERROR")') i
           !$OMP CRITICAL
           error_code = -1
           !$OMP END CRITICAL
        end if

        if (i.eq.1) then
           !$OMP CRITICAL
           allocate(out_buf%x(size(out_temp%x)))
           out_buf%x = out_temp%x;
           !$OMP END CRITICAL
        end if
     end if
  end do
  !$OMP END PARALLEL DO
  if (error_code.ne.0) stop 1
end function model_function

#' Compute the intensity of light.
#'
#' @param doy Day of year.
#' @param height Distance from ground in cm.
#'
#' @return Intensity of light in ergs cm^-2 s^-1.
light <- function(doy, height) {
  # Define parameters that are static across a run
  amplitude <- units::set_units(80.0, 'ergs cm-3 s-1')
  doy_offset <- units::set_units(0.0, 'days')

  # Calculate intensity
  intensity <- amplitude * height * (1.0 + sin(2.0 * pi *
    units::drop_units((doy - doy_offset) / units::set_units(365, 'days'))))
  return(intensity)
}

program main
  use fygg

  character(len=32) :: arg
  integer :: msg_count, msg_size
  type(yggcomm) :: inq, outf
  logical :: ret
  integer :: i, count
  integer :: exit_code = 0
  integer :: bufsiz = 0, old_bufsiz = 0
  type(yggchar_r) :: buf

  write(*, '("Hello from Fortran pipe_dst")')

  ! Ins/outs matching with the the model yaml
  inq = ygg_input("input_pipe")
  outf = ygg_output("output_file")
  write(*, '("pipe_dst(F): Created I/O channels")')

  ! Continue receiving input from the queue
  count = 0
  do while(.true.)
     bufsiz = size(buf%x)
     old_bufsiz = bufsiz
     ret = ygg_recv_nolimit(inq, buf, bufsiz)
     if (.not.ret) then
        write(*, '("pipe_dst(F): Input channel closed")')
        exit
     end if
     if (bufsiz.gt.old_bufsiz) then
        write(*, '("pipe_dst(F): Buffer increased from ",&
             &i5.1," to ",i5.1," bytes")') old_bufsiz, bufsiz
     end if
     ret = ygg_send_nolimit(outf, buf, bufsiz)
     if (.not.ret) then
        write(*, '("pipe_dst(F): SEND ERROR ON MSG ",i5.1)') count
        exit_code = -1
        exit
     end if
     count = count + 1
  end do

  write(*, '("Goodbye from Fortran destination. Received ",&
       &i5.1," messages.")') count
  if (exit_code.lt.0) then
     stop 1
  end if

end program main

function yggarr2ygggeneric(input) result(out)
  type(yggarr) :: input
  type(ygggeneric) :: out
  out%prefix = input%prefix
  out%obj = input%obj
end function yggarr2ygggeneric
  
function yggmap2ygggeneric(input) result(out)
  type(yggmap) :: input
  type(ygggeneric) :: out
  out%prefix = input%prefix
  out%obj = input%obj
end function yggmap2ygggeneric
  
function yggschema2ygggeneric(input) result(out)
  type(yggschema) :: input
  type(ygggeneric) :: out
  out%prefix = input%prefix
  out%obj = input%obj
end function yggschema2ygggeneric
  
function yggpyinst2ygggeneric(input) result(out)
  type(yggpyinst) :: input
  type(ygggeneric) :: out
  out%prefix = input%prefix
  out%obj = input%obj
end function yggpyinst2ygggeneric

function ygggeneric2yggarr(input) result(out)
  type(ygggeneric) :: input
  type(yggarr) :: out
  out%prefix = input%prefix
  out%obj = input%obj
end function ygggeneric2yggarr

function ygggeneric2yggmap(input) result(out)
  type(ygggeneric) :: input
  type(yggmap) :: out
  out%prefix = input%prefix
  out%obj = input%obj
end function ygggeneric2yggmap

function ygggeneric2yggschema(input) result(out)
  type(ygggeneric) :: input
  type(yggschema) :: out
  out%prefix = input%prefix
  out%obj = input%obj
end function ygggeneric2yggschema

function ygggeneric2yggpyinst(input) result(out)
  type(ygggeneric) :: input
  type(yggpyinst) :: out
  out%prefix = input%prefix
  out%obj = input%obj
end function ygggeneric2yggpyinst

function yggpython2yggpython(input) result(out)
  type(yggpython) :: input
  type(yggpython) :: out
  out%name = input%name
  out%args = input%args
  out%kwargs = input%kwargs
  out%obj = input%obj
end function yggpython2yggpython

function yggpyfunc2yggpython(input) result(out)
  type(yggpyfunc) :: input
  type(yggpython) :: out
  out%name = input%name
  out%args = input%args
  out%kwargs = input%kwargs
  out%obj = input%obj
end function yggpyfunc2yggpython

function yggpython2yggpyfunc(input) result(out)
  type(yggpython) :: input
  type(yggpyfunc) :: out
  out%name = input%name
  out%args = input%args
  out%kwargs = input%kwargs
  out%obj = input%obj
end function yggpython2yggpyfunc

program main
  use fygg

  type(yggcomm) :: rpc
  integer(kind=c_size_t) :: input_size
  type(yggchar_r) :: input
  logical :: ret

  print *, "maxMsgSrv(F): Hello!"
  rpc = ygg_rpc_server("maxMsgSrv", "%s", "%s")

  do while (.true.)
     ! Reset to size of buffer if not all utilized
     input_size = size(input%x)

     ret = ygg_recv_var_realloc(rpc, [yggarg(input), yggarg(input_size)])
     if (.not.ret) exit
     print *, "maxMsgSrv(F): rpcRecv returned ", ret, ", input (size=", &
          input_size, ") ", input%x(1:10)
     ret = ygg_send_var(rpc, [yggarg(input), yggarg(input_size)])
     if (.not.ret) then
        print *, "maxMsgSrv(F): SEND ERROR"
        exit
     end if

  end do

  print *, "maxMsgSrv(F): Goodbye!"

end program main

! Scalar versions
function yggarg_scalar_init(x) result (y)
  class(*), target :: x
  type(yggptr) :: y
  y%item => x
  y%array = .false.
  y%alloc = .false.
  y%len = 1
  y%prec = 1
  y%ndim = 1
  allocate(y%shape(1))
  y%shape(1) = 1
end function yggarg_scalar_init
function yggarg_scalar_unsigned1(x) result (y)
  type(yggptr) :: y
  type(ygguint1), target :: x
  type(ygguint1), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "unsigned"
  y%ptr = c_loc(xp%x)
  y%nbytes = 1
end function yggarg_scalar_unsigned1
function yggarg_scalar_unsigned2(x) result (y)
  type(yggptr) :: y
  type(ygguint2), target :: x
  type(ygguint2), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "unsigned"
  y%ptr = c_loc(xp%x)
  y%nbytes = 2
end function yggarg_scalar_unsigned2
function yggarg_scalar_unsigned4(x) result (y)
  type(yggptr) :: y
  type(ygguint4), target :: x
  type(ygguint4), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "unsigned"
  y%ptr = c_loc(xp%x)
  y%nbytes = 4
end function yggarg_scalar_unsigned4
function yggarg_scalar_unsigned8(x) result (y)
  type(yggptr) :: y
  type(ygguint8), target :: x
  type(ygguint8), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "unsigned"
  y%ptr = c_loc(xp%x)
  y%nbytes = 8
end function yggarg_scalar_unsigned8
function yggarg_scalar_integer2(x) result (y)
  type(yggptr) :: y
  integer(kind=2), target :: x
  integer(kind=2), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "integer"
  y%ptr = c_loc(xp)
  y%nbytes = 2
end function yggarg_scalar_integer2
function yggarg_scalar_integer4(x) result (y)
  type(yggptr) :: y
  integer(kind=4), target :: x
  integer(kind=4), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "integer"
  y%ptr = c_loc(xp)
  y%nbytes = 4
end function yggarg_scalar_integer4
function yggarg_scalar_integer8(x) result (y)
  type(yggptr) :: y
  integer(kind=8), target :: x
  integer(kind=8), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "integer"
  y%ptr = c_loc(xp)
  y%nbytes = 8
end function yggarg_scalar_integer8
function yggarg_scalar_real4(x) result (y)
  type(yggptr) :: y
  real(kind=4), target :: x
  real(kind=4), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "real"
  y%ptr = c_loc(xp)
  y%nbytes = 4
end function yggarg_scalar_real4
function yggarg_scalar_real8(x) result (y)
  type(yggptr) :: y
  real(kind=8), target :: x
  real(kind=8), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "real"
  y%ptr = c_loc(xp)
  y%nbytes = 8
end function yggarg_scalar_real8
function yggarg_scalar_complex4(x) result (y)
  type(yggptr) :: y
  complex(kind=4), target :: x
  complex(kind=4), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "complex"
  y%ptr = c_loc(xp)
  y%nbytes = 4 * 2
end function yggarg_scalar_complex4
function yggarg_scalar_complex8(x) result (y)
  type(yggptr) :: y
  complex(kind=8), target :: x
  complex(kind=8), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "complex"
  y%ptr = c_loc(xp)
  y%nbytes = 8 * 2
end function yggarg_scalar_complex8
function yggarg_scalar_logical1(x) result (y)
  type(yggptr) :: y
  logical(kind=1), target :: x
  logical(kind=1), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "logical"
  y%ptr = c_loc(xp)
  y%nbytes = 1
end function yggarg_scalar_logical1
function yggarg_scalar_logical2(x) result (y)
  type(yggptr) :: y
  logical(kind=2), target :: x
  logical(kind=2), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "logical"
  y%ptr = c_loc(xp)
  y%nbytes = 2
end function yggarg_scalar_logical2
function yggarg_scalar_logical4(x) result (y)
  type(yggptr) :: y
  logical(kind=4), target :: x
  logical(kind=4), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "logical"
  y%ptr = c_loc(xp)
  y%nbytes = 4
end function yggarg_scalar_logical4
function yggarg_scalar_logical8(x) result (y)
  type(yggptr) :: y
  logical(kind=8), target :: x
  logical(kind=8), pointer :: xp
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "logical"
  y%ptr = c_loc(xp)
  y%nbytes = 8
end function yggarg_scalar_logical8
function yggarg_scalar_character(x) result (y)
  type(yggptr) :: y
  character(len=*), target :: x
  character(len=len(x)), pointer :: xp
  integer :: i
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "character"
  y%prec = len(x)
  allocate(y%data_character_unit(len(x)))
  do i = 1, len(x)
     y%data_character_unit(i) = x(i:i)
  end do
  if (len_trim(x).lt.len(x)) then
     y%data_character_unit(len_trim(x) + 1) = c_null_char
  end if
  y%ptr = c_loc(y%data_character_unit(1))
  y%nbytes = len(x)
end function yggarg_scalar_character
function yggarg_scalar_unicode(x) result (y)
  type(yggptr) :: y
  character(kind=ucs4, len=*), target :: x
  character(kind=ucs4, len=len(x)), pointer :: xp
  integer :: i
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "unicode"
  y%prec = len(x) * 4  ! sizeof(ucs4)
  allocate(y%data_unicode_unit(len(x)))
  do i = 1, len(x)
     y%data_unicode_unit(i) = x(i:i)
  end do
  if (len_trim(x).lt.len(x)) then
     y%data_unicode_unit(len_trim(x) + 1) = c_null_char
  end if
  y%ptr = c_loc(y%data_unicode_unit(1))
  y%nbytes = len(x) * 4
end function yggarg_scalar_unicode
function yggarg_scalar_yggchar_r(x) result (y)
  type(yggchar_r), target :: x
  type(yggchar_r), pointer :: xp
  type(yggptr) :: y
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "character"
  y%alloc = .true.
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%prec = size(xp%x)
     y%nbytes = y%prec
  else
     y%ptr = c_null_ptr
     y%nbytes = 0
  end if
end function yggarg_scalar_yggchar_r
function yggarg_scalar_ply(x) result(y)
  type(yggply), target :: x
  type(yggply), pointer :: xp
  type(yggptr) :: y
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "ply"
  y%ptr = c_loc(xp%material(1))
  y%nbytes = -1  ! sizeof(x)
end function yggarg_scalar_ply
function yggarg_scalar_obj(x) result(y)
  type(yggobj), target :: x
  type(yggobj), pointer :: xp
  type(yggptr) :: y
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "obj"
  y%ptr = c_loc(xp%material(1))
  y%nbytes = -1  ! sizeof(x)
end function yggarg_scalar_obj
function yggarg_scalar_null(x) result(y)
  type(yggnull), target :: x
  type(yggnull), pointer :: xp
  type(yggptr) :: y
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "null"
  y%ptr = c_loc(xp%ptr)
  y%nbytes = 8  ! sizeof(x)
end function yggarg_scalar_null
function yggarg_scalar_generic(x) result(y)
  type(ygggeneric), target :: x
  type(ygggeneric), pointer :: xp
  type(yggptr) :: y
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "generic"
  y%ptr = c_loc(xp%prefix)
  y%nbytes = -1  ! sizeof(x)
end function yggarg_scalar_generic
function yggarg_scalar_yggarr(x) result(y)
  type(yggarr), target :: x
  type(yggarr), pointer :: xp
  type(yggptr) :: y
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "array"
  y%ptr = c_loc(xp%prefix)
  y%nbytes = -1  ! sizeof(x)
end function yggarg_scalar_yggarr
function yggarg_scalar_yggmap(x) result(y)
  type(yggmap), target :: x
  type(yggmap), pointer :: xp
  type(yggptr) :: y
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "object"
  y%ptr = c_loc(xp%prefix)
  y%nbytes = -1  ! sizeof(x)
end function yggarg_scalar_yggmap
function yggarg_scalar_yggschema(x) result(y)
  type(yggschema), target :: x
  type(yggschema), pointer :: xp
  type(yggptr) :: y
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "schema"
  y%ptr = c_loc(xp%prefix)
  y%nbytes = -1  ! sizeof(x)
end function yggarg_scalar_yggschema
function yggarg_scalar_yggpyinst(x) result(y)
  type(yggpyinst), target :: x
  type(yggpyinst), pointer :: xp
  type(yggptr) :: y
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "instance"
  y%ptr = c_loc(xp%prefix)
  y%nbytes = -1  ! sizeof(x)
end function yggarg_scalar_yggpyinst
function yggarg_scalar_yggpython(x) result(y)
  type(yggpython), target :: x
  type(yggpython), pointer :: xp
  type(yggptr) :: y
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "python"
  y%ptr = c_loc(xp%name)
  y%nbytes = -1  ! sizeof(x)
end function yggarg_scalar_yggpython
function yggarg_scalar_yggpyfunc(x) result(y)
  type(yggpyfunc), target :: x
  type(yggpyfunc), pointer :: xp
  type(yggptr) :: y
  y = yggarg_scalar_init(x)
  xp => x
  y%type = "class"
  y%ptr = c_loc(xp%name)
  y%nbytes = -1  ! sizeof(x)
end function yggarg_scalar_yggpyfunc
function yggarg_scalar_yggptr(x) result(y)
  type(yggptr), target :: x
  type(yggptr) :: y
  y = x
end function yggarg_scalar_yggptr

  
! 1D Reallocatable array versions
function yggarg_realloc_1darray_init(x) &
     result (y)
  class(*), target :: x
  type(yggptr) :: y
  y%item => x
  y%array = .true.
  y%alloc = .true.
  y%len = 1
  y%prec = 1
  y%ndim = 1
  allocate(y%shape(1))
  y%shape(1) = 1
  y%ptr = c_null_ptr
end function yggarg_realloc_1darray_init
function yggarg_realloc_1darray_unsigned1(x) result (y)
  type(unsigned1_1d), target :: x
  type(unsigned1_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "unsigned"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_unsigned1
function yggarg_realloc_1darray_unsigned2(x) result (y)
  type(unsigned2_1d), target :: x
  type(unsigned2_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "unsigned"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_unsigned2
function yggarg_realloc_1darray_unsigned4(x) result (y)
  type(unsigned4_1d), target :: x
  type(unsigned4_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "unsigned"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_unsigned4
function yggarg_realloc_1darray_unsigned8(x) result (y)
  type(unsigned8_1d), target :: x
  type(unsigned8_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "unsigned"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_unsigned8
function yggarg_realloc_1darray_c_long(x) result (y)
  type(c_long_1d), target :: x
  type(c_long_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "c_long"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_c_long
function yggarg_realloc_1darray_integer(x) result (y)
  type(integer_1d), target :: x
  type(integer_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "integer"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_integer
function yggarg_realloc_1darray_integer2(x) result (y)
  type(integer2_1d), target :: x
  type(integer2_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "integer"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_integer2
function yggarg_realloc_1darray_integer4(x) result (y)
  type(integer4_1d), target :: x
  type(integer4_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "integer"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_integer4
function yggarg_realloc_1darray_integer8(x) result (y)
  type(integer8_1d), target :: x
  type(integer8_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "integer"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_integer8
function yggarg_realloc_1darray_real(x) result (y)
  type(real_1d), target :: x
  type(real_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "real"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_real
function yggarg_realloc_1darray_real4(x) result (y)
  type(real4_1d), target :: x
  type(real4_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "real"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_real4
function yggarg_realloc_1darray_real8(x) result (y)
  type(real8_1d), target :: x
  type(real8_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "real"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_real8
function yggarg_realloc_1darray_real16(x) result (y)
  type(real16_1d), target :: x
  type(real16_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "real"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_real16
function yggarg_realloc_1darray_complex(x) result (y)
  type(complex_1d), target :: x
  type(complex_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "complex"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_complex
function yggarg_realloc_1darray_complex4(x) result (y)
  type(complex4_1d), target :: x
  type(complex4_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "complex"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_complex4
function yggarg_realloc_1darray_complex8(x) result (y)
  type(complex8_1d), target :: x
  type(complex8_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "complex"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_complex8
function yggarg_realloc_1darray_complex16(x) result (y)
  type(complex16_1d), target :: x
  type(complex16_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "complex"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_complex16
function yggarg_realloc_1darray_logical(x) result (y)
  type(logical_1d), target :: x
  type(logical_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "logical"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_logical
function yggarg_realloc_1darray_logical1(x) result (y)
  type(logical1_1d), target :: x
  type(logical1_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "logical"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_logical1
function yggarg_realloc_1darray_logical2(x) result (y)
  type(logical2_1d), target :: x
  type(logical2_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "logical"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_logical2
function yggarg_realloc_1darray_logical4(x) result (y)
  type(logical4_1d), target :: x
  type(logical4_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "logical"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_logical4
function yggarg_realloc_1darray_logical8(x) result (y)
  type(logical8_1d), target :: x
  type(logical8_1d), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "logical"
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
  end if
end function yggarg_realloc_1darray_logical8
function yggarg_realloc_1darray_character(x) result (y)
  type(character_1d), target :: x
  type(character_1d), pointer :: xp
  type(yggptr) :: y
  integer :: i
  integer(kind=c_size_t) :: j, ilength
  y = yggarg_realloc_1darray_init(x)
  xp => x
  y%type = "character"
  if (associated(xp%x)) then
     y%len = size(xp%x)
     y%shape(1) = size(xp%x)
     if (associated(xp%x(1)%x)) then
        y%prec = size(xp%x(1)%x)
        allocate(y%data_character_unit(y%len * y%prec))
        do i = 1, size(xp%x)
           ilength = 0
           do j = 1, y%prec
              if (len_trim(xp%x(i)%x(j)) > 0) ilength = j
           end do
           do j = 1, ilength
              y%data_character_unit(((i-1)*y%prec) + j) = xp%x(i)%x(j)
           end do
           if (ilength.lt.y%prec) then
              y%data_character_unit(((i-1)*y%prec) + ilength + 1) = c_null_char
           end if
           do j = (ilength + 2), y%prec
              y%data_character_unit(((i-1)*y%prec) + j) = ' '
           end do
        end do
        y%ptr = c_loc(y%data_character_unit(1))
     end if
  end if
end function yggarg_realloc_1darray_character

! 1D array versions
function yggarg_ndarray_init(x, x_shape) result (y)
  class(*), dimension(:), target :: x
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  y%item => x(1)
  y%item_array => x
  y%array = .true.
  y%alloc = .false.
  y%prec = 1
  y%len = size(x)
  if (present(x_shape)) then
     y%ndim = size(x_shape)
     allocate(y%shape(y%ndim))
     y%shape = x_shape
  else
     y%ndim = 1
     allocate(y%shape(1))
     y%shape(1) = y%len
  end if
  y%ptr = c_null_ptr
end function yggarg_ndarray_init
function yggarg_1darray_unsigned1(x, x_shape) result (y)
  type(ygguint1), dimension(:), target :: x
  type(ygguint1), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "unsigned"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_unsigned1
function yggarg_1darray_unsigned2(x, x_shape) result (y)
  type(ygguint2), dimension(:), target :: x
  type(ygguint2), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "unsigned"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_unsigned2
function yggarg_1darray_unsigned4(x, x_shape) result (y)
  type(ygguint4), dimension(:), target :: x
  type(ygguint4), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "unsigned"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_unsigned4
function yggarg_1darray_unsigned8(x, x_shape) result (y)
  type(ygguint8), dimension(:), target :: x
  type(ygguint8), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "unsigned"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_unsigned8
function yggarg_1darray_integer2(x, x_shape) result (y)
  integer(kind=2), dimension(:), target :: x
  integer(kind=2), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "integer"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_integer2
function yggarg_1darray_integer4(x, x_shape) result (y)
  integer(kind=4), dimension(:), target :: x
  integer(kind=4), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "integer"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_integer4
function yggarg_1darray_integer8(x, x_shape) result (y)
  integer(kind=8), dimension(:), target :: x
  integer(kind=8), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "integer"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_integer8
function yggarg_1darray_real4(x, x_shape) result (y)
  real(kind=4), dimension(:), target :: x
  real(kind=4), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "real"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_real4
function yggarg_1darray_real8(x, x_shape) result (y)
  real(kind=8), dimension(:), target :: x
  real(kind=8), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "real"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_real8
function yggarg_1darray_complex4(x, x_shape) result (y)
  complex(kind=4), dimension(:), target :: x
  complex(kind=4), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "complex"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_complex4
function yggarg_1darray_complex8(x, x_shape) result (y)
  complex(kind=8), dimension(:), target :: x
  complex(kind=8), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "complex"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_complex8
function yggarg_1darray_logical1(x, x_shape) result (y)
  logical(kind=1), dimension(:), target :: x
  logical(kind=1), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "logical"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_logical1
function yggarg_1darray_logical2(x, x_shape) result (y)
  logical(kind=2), dimension(:), target :: x
  logical(kind=2), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "logical"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_logical2
function yggarg_1darray_logical4(x, x_shape) result (y)
  logical(kind=4), dimension(:), target :: x
  logical(kind=4), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "logical"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_logical4
function yggarg_1darray_logical8(x, x_shape) result (y)
  logical(kind=8), dimension(:), target :: x
  logical(kind=8), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "logical"
  y%ptr = c_loc(xp(1))
end function yggarg_1darray_logical8
function yggarg_1darray_character(x, x_shape) result (y)
  character(len=*), dimension(:), target :: x
  character(len=len(x(1))), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  integer :: i, ilength
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "character"
  y%prec = len(xp(1))
  do i = 1, size(xp)
     ilength = len_trim(xp(i))
     if (ilength.lt.y%prec) then
        xp(i)((ilength+1):(ilength+1)) = c_null_char
     end if
  end do
  allocate(y%data_character_unit(y%len * y%prec))
  y%data_character_unit = transfer(x, y%data_character_unit)
  y%ptr = c_loc(y%data_character_unit(1))
end function yggarg_1darray_character
function yggarg_1darray_unicode(x, x_shape) result (y)
  character(kind=ucs4, len=*), &
       dimension(:), target :: x
  character(kind=ucs4, len=len(x(1))), &
       dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  integer :: i, ilength
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "unicode"
  y%prec = len(xp(1)) * 4  ! sizeof(ucs4)
  do i = 1, size(xp)
     ilength = len_trim(xp(i))
     if (ilength.lt.len(xp(1))) then
        xp(i)((ilength+1):(ilength+1)) = c_null_char
     end if
  end do
  allocate(y%data_unicode_unit(y%len * len(xp(1))))
  y%data_unicode_unit = transfer(x, y%data_unicode_unit)
  y%ptr = c_loc(y%data_unicode_unit(1))
end function yggarg_1darray_unicode
function yggarg_1darray_yggchar_r(x, x_shape) result (y)
  type(yggchar_r), dimension(:), target :: x
  type(yggchar_r), dimension(:), pointer :: xp
  integer, dimension(:), optional :: x_shape
  type(yggptr) :: y
  integer :: i, j, ilength
  xp => x
  if (present(x_shape)) then
     y = yggarg_ndarray_init(x, x_shape)
  else
     y = yggarg_ndarray_init(x)
  end if
  y%type = "character"
  if ((associated(xp(1)%x)).and.(size(xp(1)%x).ge.1)) then
     y%prec = size(xp(1)%x)
     allocate(y%data_character_unit(y%len * y%prec))
     do i = 1, size(xp)
        ilength = 0
        do j = 1, ilength
           if (len_trim(xp(i)%x(j)) > 0) ilength = j
        end do
        do j = 1, ilength
           y%data_character_unit(((i-1)*y%prec) + j) = xp(i)%x(j)
        end do
        if (ilength.lt.size(xp(i)%x)) then
           y%data_character_unit(((i-1)*y%prec) + ilength + 1) = c_null_char
        end if
        do j = (ilength + 2), size(xp(i)%x)
           y%data_character_unit(((i-1)*y%prec) + j) = ' '
        end do
     end do
     y%ptr = c_loc(y%data_character_unit(1))
  end if
end function yggarg_1darray_yggchar_r

! ND array versions
subroutine yggarg_2darray_init(y, x)
  type(yggptr) :: y
  class(*), dimension(:, :), intent(in), target :: x
  y%item_array_2d => x
end subroutine yggarg_2darray_init
function yggarg_2darray_unsigned1(x) result (y)
  type(ygguint1), dimension(:, :), target :: x
  type(ygguint1), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_unsigned1
function yggarg_2darray_unsigned2(x) result (y)
  type(ygguint2), dimension(:, :), target :: x
  type(ygguint2), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_unsigned2
function yggarg_2darray_unsigned4(x) result (y)
  type(ygguint4), dimension(:, :), target :: x
  type(ygguint4), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_unsigned4
function yggarg_2darray_unsigned8(x) result (y)
  type(ygguint8), dimension(:, :), target :: x
  type(ygguint8), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_unsigned8
function yggarg_2darray_integer2(x) result (y)
  integer(kind=2), dimension(:, :), target :: x
  integer(kind=2), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_integer2
function yggarg_2darray_integer4(x) result (y)
  integer(kind=4), dimension(:, :), target :: x
  integer(kind=4), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_integer4
function yggarg_2darray_integer8(x) result (y)
  integer(kind=8), dimension(:, :), target :: x
  integer(kind=8), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_integer8
function yggarg_2darray_real4(x) result (y)
  real(kind=4), dimension(:, :), target :: x
  real(kind=4), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_real4
function yggarg_2darray_real8(x) result (y)
  real(kind=8), dimension(:, :), target :: x
  real(kind=8), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_real8
function yggarg_2darray_complex4(x) result (y)
  complex(kind=4), dimension(:, :), target :: x
  complex(kind=4), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_complex4
function yggarg_2darray_complex8(x) result (y)
  complex(kind=8), dimension(:, :), target :: x
  complex(kind=8), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_complex8
function yggarg_2darray_logical1(x) result (y)
  logical(kind=1), dimension(:, :), target :: x
  logical(kind=1), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_logical1
function yggarg_2darray_logical2(x) result (y)
  logical(kind=2), dimension(:, :), target :: x
  logical(kind=2), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_logical2
function yggarg_2darray_logical4(x) result (y)
  logical(kind=4), dimension(:, :), target :: x
  logical(kind=4), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_logical4
function yggarg_2darray_logical8(x) result (y)
  logical(kind=8), dimension(:, :), target :: x
  logical(kind=8), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_logical8
function yggarg_2darray_character(x) result (y)
  character(len=*), dimension(:, :), target :: x
  character(len=:), dimension(:), pointer :: xp
  integer(kind=8) :: i, j
  type(yggptr) :: y
  allocate(character(len=len(x(1,1))) :: xp(size(x)))
  do i = 1, size(x, 1)
     do j = 1, size(x, 2)
        xp(i + (j-1)*size(x, 1)) = x(i, j)
     enddo
  enddo
  ! xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_character
function yggarg_2darray_yggchar_r(x) result (y)
  type(yggchar_r), dimension(:, :), target :: x
  type(yggchar_r), dimension(:), pointer :: xp
  type(yggptr) :: y
  allocate(xp(size(x)))
  xp = reshape(x, [size(x)])
  y = yggarg(xp, shape(x))
  call yggarg_2darray_init(y, x)
end function yggarg_2darray_yggchar_r

! ND Reallocatable array versions
function yggarg_realloc_ndarray_init(x) &
     result (y)
  class(*), target :: x
  type(yggptr) :: y
  y%item => x
  y%ndarray = .true.
  y%array = .true.
  y%alloc = .true.
  y%len = 1
  y%prec = 1
  y%ndim = 1
  y%shape => null()
  y%ptr = c_null_ptr
end function yggarg_realloc_ndarray_init
function yggarg_realloc_ndarray_unsigned1(x) result (y)
  type(unsigned1_nd), target :: x
  type(unsigned1_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "unsigned"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_unsigned1
function yggarg_realloc_ndarray_unsigned2(x) result (y)
  type(unsigned2_nd), target :: x
  type(unsigned2_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "unsigned"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_unsigned2
function yggarg_realloc_ndarray_unsigned4(x) result (y)
  type(unsigned4_nd), target :: x
  type(unsigned4_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "unsigned"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_unsigned4
function yggarg_realloc_ndarray_unsigned8(x) result (y)
  type(unsigned8_nd), target :: x
  type(unsigned8_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "unsigned"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_unsigned8
function yggarg_realloc_ndarray_c_long(x) result (y)
  type(c_long_nd), target :: x
  type(c_long_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "c_long"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_c_long
function yggarg_realloc_ndarray_integer(x) result (y)
  type(integer_nd), target :: x
  type(integer_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "integer"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_integer
function yggarg_realloc_ndarray_integer2(x) result (y)
  type(integer2_nd), target :: x
  type(integer2_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "integer"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_integer2
function yggarg_realloc_ndarray_integer4(x) result (y)
  type(integer4_nd), target :: x
  type(integer4_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "integer"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_integer4
function yggarg_realloc_ndarray_integer8(x) result (y)
  type(integer8_nd), target :: x
  type(integer8_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "integer"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_integer8
function yggarg_realloc_ndarray_real(x) result (y)
  type(real_nd), target :: x
  type(real_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "real"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_real
function yggarg_realloc_ndarray_real4(x) result (y)
  type(real4_nd), target :: x
  type(real4_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "real"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_real4
function yggarg_realloc_ndarray_real8(x) result (y)
  type(real8_nd), target :: x
  type(real8_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "real"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_real8
function yggarg_realloc_ndarray_real16(x) result (y)
  type(real16_nd), target :: x
  type(real16_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "real"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_real16
function yggarg_realloc_ndarray_complex(x) result (y)
  type(complex_nd), target :: x
  type(complex_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "complex"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_complex
function yggarg_realloc_ndarray_complex4(x) result (y)
  type(complex4_nd), target :: x
  type(complex4_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "complex"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_complex4
function yggarg_realloc_ndarray_complex8(x) result (y)
  type(complex8_nd), target :: x
  type(complex8_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "complex"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_complex8
function yggarg_realloc_ndarray_complex16(x) result (y)
  type(complex16_nd), target :: x
  type(complex16_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "complex"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_complex16
function yggarg_realloc_ndarray_logical(x) result (y)
  type(logical_nd), target :: x
  type(logical_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "logical"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_logical
function yggarg_realloc_ndarray_logical1(x) result (y)
  type(logical1_nd), target :: x
  type(logical1_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "logical"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_logical1
function yggarg_realloc_ndarray_logical2(x) result (y)
  type(logical2_nd), target :: x
  type(logical2_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "logical"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_logical2
function yggarg_realloc_ndarray_logical4(x) result (y)
  type(logical4_nd), target :: x
  type(logical4_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "logical"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_logical4
function yggarg_realloc_ndarray_logical8(x) result (y)
  type(logical8_nd), target :: x
  type(logical8_nd), pointer :: xp
  type(yggptr) :: y
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "logical"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%ptr = c_loc(xp%x(1))
     y%len = size(xp%x)
     y%shape => x%shape
  end if
end function yggarg_realloc_ndarray_logical8
function yggarg_realloc_ndarray_character(x) result (y)
  type(character_nd), target :: x
  type(character_nd), pointer :: xp
  type(yggptr) :: y
  integer :: i
  integer(kind=c_size_t) :: j, ilength
  y = yggarg_realloc_ndarray_init(x)
  xp => x
  y%type = "character"
  y%ndim = size(x%shape)
  if (associated(xp%x)) then
     y%len = size(xp%x)
     if (associated(xp%x(1)%x)) then
        y%prec = size(xp%x(1)%x)
        allocate(y%data_character_unit(y%len * y%prec))
        do i = 1, size(xp%x)
           ilength = 0
           do j = 1, y%prec
              if (len_trim(xp%x(i)%x(j)) > 0) ilength = j
           end do
           do j = 1, ilength
              y%data_character_unit(((i-1)*y%prec) + j) = xp%x(i)%x(j)
           end do
           if (ilength.lt.y%prec) then
              y%data_character_unit(((i-1)*y%prec) + ilength + 1) = c_null_char
           end if
           do j = (ilength + 2), y%prec
              y%data_character_unit(((i-1)*y%prec) + j) = ' '
           end do
        end do
        y%ptr = c_loc(y%data_character_unit(1))
     end if
  end if
end function yggarg_realloc_ndarray_character

subroutine copy_real4_nd(x_out, x_in)
  type(real4_nd), intent(in) :: x_in
  class(real4_nd), intent(inout) :: x_out
  if (associated(x_out%x)) deallocate(x_out%x)
  if (associated(x_out%shape)) deallocate(x_out%shape)
  print *, "copy", associated(x_in%x), associated(x_in%shape)
  allocate(x_out%x, source = x_in%x)
  allocate(x_out%shape, source = x_in%shape)
end subroutine copy_real4_nd

modelA_function <- function(in_val) {
  out_val1 <- 2 * in_val
  out_val2 <- 3 * in_val
  print(sprintf("modelA_function(%f) = (%f, %f)", in_val, out_val1, out_val2))
  return(list(out_val1,out_val2))
}

#!/bin/sh

# Check if xar and mkbom are available
command -v xar >/dev/null 2>&1 || (
  echo "Building xar"
  sudo apt-get install libxml2-dev libssl1.0-dev zlib1g-dev -y
  mkdir -p /tmp/xar && cd /tmp/xar
  git clone https://github.com/mackyle/xar && cd xar/xar
  (sh autogen.sh && make && sudo make install) || (echo "Failed to build xar"; exit 1)
)
command -v mkbom >/dev/null 2>&1 || (
  echo "Building mkbom"
  mkdir -p /tmp/mkbom && cd /tmp/mkbom
  git clone https://github.com/hogliux/bomutils && cd bomutils
  sudo make install || (echo "Failed to build mkbom"; exit 1)
)

# Build Yggdrasil
echo "running GO111MODULE=on GOOS=darwin GOARCH=${PKGARCH-amd64} ./build"
GO111MODULE=on GOOS=darwin GOARCH=${PKGARCH-amd64} ./build

# Check if we can find the files we need - they should
# exist if you are running this script from the root of
# the yggdrasil-go repo and you have ran ./build
test -f yggdrasil || (echo "yggdrasil binary not found"; exit 1)
test -f yggdrasilctl || (echo "yggdrasilctl binary not found"; exit 1)
test -f contrib/macos/yggdrasil.plist || (echo "contrib/macos/yggdrasil.plist not found"; exit 1)
test -f contrib/semver/version.sh || (echo "contrib/semver/version.sh not found"; exit 1)

# Delete the pkgbuild folder if it already exists
test -d pkgbuild && rm -rf pkgbuild

# Create our folder structure
mkdir -p pkgbuild/scripts
mkdir -p pkgbuild/flat/base.pkg
mkdir -p pkgbuild/flat/Resources/en.lproj
mkdir -p pkgbuild/root/usr/local/bin
mkdir -p pkgbuild/root/Library/LaunchDaemons

# Copy package contents into the pkgbuild root
cp yggdrasil pkgbuild/root/usr/local/bin
cp yggdrasilctl pkgbuild/root/usr/local/bin
cp contrib/macos/yggdrasil.plist pkgbuild/root/Library/LaunchDaemons

# Create the postinstall script
cat > pkgbuild/scripts/postinstall << EOF
#!/bin/sh

# Normalise the config if it exists, generate it if it doesn't
if [ -f /etc/yggdrasil.conf ];
then
  mkdir -p /Library/Preferences/Yggdrasil
  echo "Backing up configuration file to /Library/Preferences/Yggdrasil/yggdrasil.conf.`date +%Y%m%d`"
  cp /etc/yggdrasil.conf /Library/Preferences/Yggdrasil/yggdrasil.conf.`date +%Y%m%d`
  echo "Normalising /etc/yggdrasil.conf"
  /usr/local/bin/yggdrasil -useconffile /Library/Preferences/Yggdrasil/yggdrasil.conf.`date +%Y%m%d` -normaliseconf > /etc/yggdrasil.conf
else
  (umask 037 && /usr/local/bin/yggdrasil -genconf > /etc/yggdrasil.conf)
fi

# Unload existing Yggdrasil launchd service, if possible
test -f /Library/LaunchDaemons/yggdrasil.plist && (launchctl unload /Library/LaunchDaemons/yggdrasil.plist || true)

# Load Yggdrasil launchd service and start Yggdrasil
launchctl load /Library/LaunchDaemons/yggdrasil.plist
EOF

# Set execution permissions
chmod +x pkgbuild/scripts/postinstall
chmod +x pkgbuild/root/usr/local/bin/yggdrasil
chmod +x pkgbuild/root/usr/local/bin/yggdrasilctl

# Pack payload and scripts
( cd pkgbuild/scripts && find . | cpio -o --format odc --owner 0:80 | gzip -c ) > pkgbuild/flat/base.pkg/Scripts
( cd pkgbuild/root && find . | cpio -o --format odc --owner 0:80 | gzip -c ) > pkgbuild/flat/base.pkg/Payload

# Work out metadata for the package info
PKGNAME=$(sh contrib/semver/name.sh)
PKGVERSION=$(sh contrib/semver/version.sh --bare)
PKGARCH=${PKGARCH-amd64}
PAYLOADSIZE=$(( $(wc -c pkgbuild/flat/base.pkg/Payload | awk '{ print $1 }') / 1024 ))
[ "$PKGARCH" = "amd64" ] && PKGHOSTARCH="x86_64" || PKGHOSTARCH=${PKGARCH}

# Create the PackageInfo file
cat > pkgbuild/flat/base.pkg/PackageInfo << EOF
<pkg-info format-version="2" identifier="io.github.yggdrasil-network.pkg" version="${PKGVERSION}" install-location="/" auth="root">
  <payload installKBytes="${PAYLOADSIZE}" numberOfFiles="3"/>
  <scripts>
    <postinstall file="./postinstall"/>
  </scripts>
</pkg-info>
EOF

# Create the BOM
( cd pkgbuild && mkbom root flat/base.pkg/Bom )

# Create the Distribution file
cat > pkgbuild/flat/Distribution << EOF
<?xml version="1.0" encoding="utf-8"?>
<installer-script minSpecVersion="1.000000" authoringTool="com.apple.PackageMaker" authoringToolVersion="3.0.3" authoringToolBuild="174">
    <title>Yggdrasil (${PKGNAME}-${PKGVERSION})</title>
    <options customize="never" allow-external-scripts="no" hostArchitectures="${PKGHOSTARCH}" />
    <domains enable_anywhere="true"/>
    <installation-check script="pm_install_check();"/>
    <script>
    function pm_install_check() {
      if(!(system.compareVersions(system.version.ProductVersion,'10.10') >= 0)) {
        my.result.title = 'Failure';
        my.result.message = 'You need at least Mac OS X 10.10 to install Yggdrasil.';
        my.result.type = 'Fatal';
        return false;
      }
      return true;
    }
    </script>
    <choices-outline>
        <line choice="choice1"/>
    </choices-outline>
    <choice id="choice1" title="base">
        <pkg-ref id="io.github.yggdrasil-network.pkg"/>
    </choice>
    <pkg-ref id="io.github.yggdrasil-network.pkg" installKBytes="${PAYLOADSIZE}" version="${VERSION}" auth="Root">#base.pkg</pkg-ref>
</installer-script>
EOF

# Finally pack the .pkg
( cd pkgbuild/flat && xar --compression none -cf "../../${PKGNAME}-${PKGVERSION}-macos-${PKGARCH}.pkg" * )

#!/usr/bin/env sh

set -e

CONF_DIR="/etc/yggdrasil-network"

if [ ! -f "$CONF_DIR/config.conf" ]; then
  echo "generate $CONF_DIR/config.conf"
  (umask 037 && yggdrasil --genconf > "$CONF_DIR/config.conf")
fi

if [ -n "$ALLOW_IPV6_FORWARDING" ]; then
  echo "set sysctl -w net.ipv6.conf.all.forwarding=1"
  sysctl -w net.ipv6.conf.all.forwarding=1
fi

yggdrasil --useconf < "$CONF_DIR/config.conf"
exit $?

#!/bin/sh

# Get the current branch name
BRANCH="$GITHUB_REF_NAME"
if [ -z "$BRANCH" ]; then
  BRANCH=$(git symbolic-ref --short HEAD 2>/dev/null)
fi

if [ $? != 0 ] || [ -z "$BRANCH" ]; then
  printf "yggdrasil"
  exit 0
fi

# Remove "/" characters from the branch name if present
BRANCH=$(echo $BRANCH | tr -d "/")

# Check if the branch name is not master
if [ "$BRANCH" = "master" ]; then
  printf "yggdrasil"
  exit 0
fi

# If it is something other than master, append it
printf "yggdrasil-%s" "$BRANCH"

@echo off
setlocal enabledelayedexpansion

set PKGSRC=github.com/yggdrasil-network/yggdrasil-go/src/version

set LDFLAGS=-X %PKGSRC%.buildName=%PKGNAME% -X %PKGSRC%.buildVersion=%PKGVER%
set ARGS=-v

:parse_args
if "%1"=="" goto end_args
if "%1"=="-u" set UPX=true
if "%1"=="-t" set TABLES=true
if "%1"=="-d" set ARGS=%ARGS% -tags debug & set DEBUG=true
if "%1"=="-r" set ARGS=%ARGS% -race
if "%1"=="-p" set ARGS=%ARGS% -buildmode=pie
if "%1"=="-c" (
  shift
  set GCFLAGS=%GCFLAGS% %1
)
if "%1"=="-l" (
  shift
  set LDFLAGS=%LDFLAGS% %1
)
if "%1"=="-o" (
  shift
  set ARGS=%ARGS% -o %1
)
shift
goto parse_args

:end_args
if "%TABLES%"=="" if "%DEBUG%"=="" (
  set LDFLAGS=%LDFLAGS% -s -w
)

for %%C in (yggdrasil yggdrasilctl) do (
  echo Building: %%C.exe
  go build %ARGS% -ldflags="%LDFLAGS%" -gcflags="%GCFLAGS%" ./cmd/%%C

  if "%UPX%"=="true" (
    upx --brute %%C.exe
  )
)

#!/bin/sh

# Get the last tag
TAG=$(git describe --abbrev=0 --tags --match="v[0-9]*\.[0-9]*\.[0-9]*" 2>/dev/null)

# Did getting the tag succeed?
if [ $? != 0 ] || [ -z "$TAG" ]; then
  printf -- "unknown"
  exit 0
fi

# Get the current branch
BRANCH=$(git symbolic-ref -q HEAD --short 2>/dev/null)

# Did getting the branch succeed?
if [ $? != 0 ] || [ -z "$BRANCH" ]; then
  BRANCH="master"
fi

# Split out into major, minor and patch numbers
MAJOR=$(echo $TAG | cut -c 2- | cut -d "." -f 1)
MINOR=$(echo $TAG | cut -c 2- | cut -d "." -f 2)
PATCH=$(echo $TAG | cut -c 2- | cut -d "." -f 3 | awk -F"rc" '{print $1}')

# Output in the desired format
if [ $((PATCH)) -eq 0 ]; then
  printf '%s%d.%d' "$PREPEND" "$((MAJOR))" "$((MINOR))"
else
  printf '%s%d.%d.%d' "$PREPEND" "$((MAJOR))" "$((MINOR))" "$((PATCH))"
fi

# Add the build tag on non-master branches
if [ "$BRANCH" != "master" ]; then
  BUILD=$(git rev-list --count $TAG..HEAD 2>/dev/null)

  # Did getting the count of commits since the tag succeed?
  if [ $? != 0 ] || [ -z "$BUILD" ]; then
    printf -- "-unknown"
    exit 0
  fi

  # Is the build greater than zero?
  if [ $((BUILD)) -gt 0 ]; then
      printf -- "-%04d" "$((BUILD))"
  fi
fi

#!/bin/sh

# This script generates an MSI file for Yggdrasil for a given architecture. It
# needs to run on Windows within MSYS2 and Go 1.21 or later must be installed on
# the system and within the PATH. This is ran currently by GitHub Actions (see
# the workflows in the repository).
#
# Author: Neil Alexander <neilalexander@users.noreply.github.com>

# Get arch from command line if given
PKGARCH=$1
if [ "${PKGARCH}" == "" ];
then
  echo "tell me the architecture: x86, x64 or arm64"
  exit 1
fi

# Download the wix tools!
dotnet tool install --global wix --version 5.0.0

# Build Yggdrasil!
[ "${PKGARCH}" == "x64" ] && GOOS=windows GOARCH=amd64 CGO_ENABLED=0 ./build
[ "${PKGARCH}" == "x86" ] && GOOS=windows GOARCH=386 CGO_ENABLED=0 ./build
[ "${PKGARCH}" == "arm64" ] && GOOS=windows GOARCH=arm64 CGO_ENABLED=0 ./build

# Create the postinstall script
cat > updateconfig.bat << EOF
if not exist %ALLUSERSPROFILE%\\Yggdrasil (
  mkdir %ALLUSERSPROFILE%\\Yggdrasil
)
if not exist %ALLUSERSPROFILE%\\Yggdrasil\\yggdrasil.conf (
  if exist yggdrasil.exe (
    yggdrasil.exe -genconf > %ALLUSERSPROFILE%\\Yggdrasil\\yggdrasil.conf
  )
)
EOF

# Work out metadata for the package info
PKGNAME=$(sh contrib/semver/name.sh)
PKGVERSION=$(sh contrib/msi/msversion.sh --bare)
PKGVERSIONMS=$(echo $PKGVERSION | tr - .)
([ "${PKGARCH}" == "x64" ] || [ "${PKGARCH}" == "arm64" ]) && \
  PKGGUID="77757838-1a23-40a5-a720-c3b43e0260cc" PKGINSTFOLDER="ProgramFiles64Folder" || \
  PKGGUID="54a3294e-a441-4322-aefb-3bb40dd022bb" PKGINSTFOLDER="ProgramFilesFolder"

# Download the Wintun driver
if [ ! -d wintun ];
then
  curl -o wintun.zip https://www.wintun.net/builds/wintun-0.14.1.zip
  if [ `sha256sum wintun.zip | cut -f 1 -d " "` != "07c256185d6ee3652e09fa55c0b673e2624b565e02c4b9091c79ca7d2f24ef51" ];
  then
    echo "wintun package didn't match expected checksum"
    exit 1
  fi
  unzip wintun.zip
fi
if [ $PKGARCH = "x64" ]; then
  PKGWINTUNDLL=wintun/bin/amd64/wintun.dll
elif [ $PKGARCH = "x86" ]; then
  PKGWINTUNDLL=wintun/bin/x86/wintun.dll
elif [ $PKGARCH = "arm64" ]; then
  PKGWINTUNDLL=wintun/bin/arm64/wintun.dll
else
  echo "wasn't sure which architecture to get wintun for"
  exit 1
fi

if [ $PKGNAME != "master" ]; then
  PKGDISPLAYNAME="Yggdrasil Network (${PKGNAME} branch)"
else
  PKGDISPLAYNAME="Yggdrasil Network"
fi

# Generate the wix.xml file
cat > wix.xml << EOF
<?xml version="1.0" encoding="windows-1252"?>
<Wix xmlns="http://schemas.microsoft.com/wix/2006/wi">
  <Product
    Name="${PKGDISPLAYNAME}"
    Id="*"
    UpgradeCode="${PKGGUID}"
    Language="1033"
    Codepage="1252"
    Version="${PKGVERSIONMS}"
    Manufacturer="github.com/yggdrasil-network">

    <Package
      Id="*"
      Keywords="Installer"
      Description="Yggdrasil Network Installer"
      Comments="Yggdrasil Network standalone router for Windows."
      Manufacturer="github.com/yggdrasil-network"
      InstallerVersion="500"
      InstallScope="perMachine"
      Languages="1033"
      Compressed="yes"
      SummaryCodepage="1252" />

    <MajorUpgrade
      AllowDowngrades="yes" />

    <Media
      Id="1"
      Cabinet="Media.cab"
      EmbedCab="yes"
      CompressionLevel="high" />

    <Directory Id="TARGETDIR" Name="SourceDir">
      <Directory Id="${PKGINSTFOLDER}" Name="PFiles">
        <Directory Id="YggdrasilInstallFolder" Name="Yggdrasil">

          <Component Id="MainExecutable" Guid="c2119231-2aa3-4962-867a-9759c87beb24">
            <File
              Id="Yggdrasil"
              Name="yggdrasil.exe"
              DiskId="1"
              Source="yggdrasil.exe"
              KeyPath="yes" />

            <File
              Id="Wintun"
              Name="wintun.dll"
              DiskId="1"
              Source="${PKGWINTUNDLL}" />

            <ServiceInstall
              Id="ServiceInstaller"
              Account="LocalSystem"
              Description="Yggdrasil Network router process"
              DisplayName="Yggdrasil Service"
              ErrorControl="normal"
              LoadOrderGroup="NetworkProvider"
              Name="Yggdrasil"
              Start="auto"
              Type="ownProcess"
              Arguments='-useconffile "%ALLUSERSPROFILE%\\Yggdrasil\\yggdrasil.conf" -logto "%ALLUSERSPROFILE%\\Yggdrasil\\yggdrasil.log"'
              Vital="yes" />

            <ServiceControl
              Id="ServiceControl"
              Name="yggdrasil"
              Start="install"
              Stop="both"
              Remove="uninstall" />
          </Component>

          <Component Id="CtrlExecutable" Guid="a916b730-974d-42a1-b687-d9d504cbb86a">
            <File
              Id="Yggdrasilctl"
              Name="yggdrasilctl.exe"
              DiskId="1"
              Source="yggdrasilctl.exe"
              KeyPath="yes"/>
          </Component>

          <Component Id="ConfigScript" Guid="64a3733b-c98a-4732-85f3-20cd7da1a785">
            <File
              Id="Configbat"
              Name="updateconfig.bat"
              DiskId="1"
              Source="updateconfig.bat"
              KeyPath="yes"/>
          </Component>
        </Directory>
      </Directory>
    </Directory>

    <Feature Id="YggdrasilFeature" Title="Yggdrasil" Level="1">
      <ComponentRef Id="MainExecutable" />
      <ComponentRef Id="CtrlExecutable" />
      <ComponentRef Id="ConfigScript" />
    </Feature>

    <CustomAction
      Id="UpdateGenerateConfig"
      Directory="YggdrasilInstallFolder"
      ExeCommand="cmd.exe /c updateconfig.bat"
      Execute="deferred"
      Return="check"
      Impersonate="yes" />

    <InstallExecuteSequence>
      <Custom
        Action="UpdateGenerateConfig"
        Before="StartServices">
          NOT Installed AND NOT REMOVE
      </Custom>
    </InstallExecuteSequence>

  </Product>
</Wix>
EOF

# Generate the MSI
CANDLEFLAGS="-nologo"
LIGHTFLAGS="-nologo -spdb -sice:ICE71 -sice:ICE61"
candle $CANDLEFLAGS -out ${PKGNAME}-${PKGVERSION}-${PKGARCH}.wixobj -arch ${PKGARCH} wix.xml && \
light $LIGHTFLAGS -ext WixUtilExtension.dll -out ${PKGNAME}-${PKGVERSION}-${PKGARCH}.msi ${PKGNAME}-${PKGVERSION}-${PKGARCH}.wixobj

#!/bin/sh

# This is a lazy script to create a .deb for Debian/Ubuntu. It installs
# yggdrasil and enables it in systemd. You can give it the PKGARCH= argument
# i.e. PKGARCH=i386 sh contrib/deb/generate.sh

if [ `pwd` != `git rev-parse --show-toplevel` ]
then
  echo "You should run this script from the top-level directory of the git repo"
  exit 1
fi

PKGBRANCH=$(basename `git name-rev --name-only HEAD`)
PKGNAME=$(sh contrib/semver/name.sh)
PKGVERSION=$(sh contrib/semver/version.sh --bare)
PKGARCH=${PKGARCH-amd64}
PKGFILE=$PKGNAME-$PKGVERSION-$PKGARCH.deb
PKGREPLACES=yggdrasil

if [ $PKGBRANCH = "master" ]; then
  PKGREPLACES=yggdrasil-develop
fi

GOLDFLAGS="-X github.com/yggdrasil-network/yggdrasil-go/src/config.defaultConfig=/etc/yggdrasil/yggdrasil.conf"
GOLDFLAGS="${GOLDFLAGS} -X github.com/yggdrasil-network/yggdrasil-go/src/config.defaultAdminListen=unix:///var/run/yggdrasil/yggdrasil.sock"

if [ $PKGARCH = "amd64" ]; then GOARCH=amd64 GOOS=linux ./build -l "${GOLDFLAGS}"
elif [ $PKGARCH = "i386" ]; then GOARCH=386 GOOS=linux ./build -l "${GOLDFLAGS}"
elif [ $PKGARCH = "mipsel" ]; then GOARCH=mipsle GOOS=linux ./build -l "${GOLDFLAGS}"
elif [ $PKGARCH = "mips" ]; then GOARCH=mips64 GOOS=linux ./build -l "${GOLDFLAGS}"
elif [ $PKGARCH = "armhf" ]; then GOARCH=arm GOOS=linux GOARM=6 ./build -l "${GOLDFLAGS}"
elif [ $PKGARCH = "arm64" ]; then GOARCH=arm64 GOOS=linux ./build -l "${GOLDFLAGS}"
elif [ $PKGARCH = "armel" ]; then GOARCH=arm GOOS=linux GOARM=5 ./build -l "${GOLDFLAGS}"
else
  echo "Specify PKGARCH=amd64,i386,mips,mipsel,armhf,arm64,armel"
  exit 1
fi

echo "Building $PKGFILE"

mkdir -p /tmp/$PKGNAME/
mkdir -p /tmp/$PKGNAME/debian/
mkdir -p /tmp/$PKGNAME/usr/bin/
mkdir -p /tmp/$PKGNAME/lib/systemd/system/

cat > /tmp/$PKGNAME/debian/changelog << EOF
Please see https://github.com/yggdrasil-network/yggdrasil-go/
EOF
echo 9 > /tmp/$PKGNAME/debian/compat
cat > /tmp/$PKGNAME/debian/control << EOF
Package: $PKGNAME
Version: $PKGVERSION
Section: golang
Priority: optional
Architecture: $PKGARCH
Replaces: $PKGREPLACES
Conflicts: $PKGREPLACES
Depends: systemd
Maintainer: Neil Alexander <neilalexander@users.noreply.github.com>
Description: Yggdrasil Network
 Yggdrasil is an early-stage implementation of a fully end-to-end encrypted IPv6
 network. It is lightweight, self-arranging, supported on multiple platforms and
 allows pretty much any IPv6-capable application to communicate securely with
 other Yggdrasil nodes.
EOF
cat > /tmp/$PKGNAME/debian/copyright << EOF
Please see https://github.com/yggdrasil-network/yggdrasil-go/
EOF
cat > /tmp/$PKGNAME/debian/docs << EOF
Please see https://github.com/yggdrasil-network/yggdrasil-go/
EOF
cat > /tmp/$PKGNAME/debian/install << EOF
usr/bin/yggdrasil usr/bin
usr/bin/yggdrasilctl usr/bin
lib/systemd/system/*.service lib/systemd/system
EOF
cat > /tmp/$PKGNAME/debian/postinst << EOF
#!/bin/sh

systemctl daemon-reload

if ! getent group yggdrasil 2>&1 > /dev/null; then
  groupadd --system --force yggdrasil
fi

if [ ! -d /etc/yggdrasil ];
then
    mkdir -p /etc/yggdrasil
    chown root:yggdrasil /etc/yggdrasil
    chmod 750 /etc/yggdrasil
fi

if [ ! -f /etc/yggdrasil/yggdrasil.conf ];
then
    test -f /etc/yggdrasil.conf && mv /etc/yggdrasil.conf /etc/yggdrasil/yggdrasil.conf
fi

if [ -f /etc/yggdrasil/yggdrasil.conf ];
then
  mkdir -p /var/backups
  echo "Backing up configuration file to /var/backups/yggdrasil.conf.`date +%Y%m%d`"
  cp /etc/yggdrasil/yggdrasil.conf /var/backups/yggdrasil.conf.`date +%Y%m%d`

  echo "Normalising and updating /etc/yggdrasil/yggdrasil.conf"
  /usr/bin/yggdrasil -useconf -normaliseconf < /var/backups/yggdrasil.conf.`date +%Y%m%d` > /etc/yggdrasil/yggdrasil.conf

  chown root:yggdrasil /etc/yggdrasil/yggdrasil.conf
  chmod 640 /etc/yggdrasil/yggdrasil.conf
else
  echo "Generating initial configuration file /etc/yggdrasil/yggdrasil.conf"
  (umask 037 && /usr/bin/yggdrasil -genconf > /etc/yggdrasil/yggdrasil.conf)

  chown root:yggdrasil /etc/yggdrasil/yggdrasil.conf
  chmod 640 /etc/yggdrasil/yggdrasil.conf
fi

systemctl enable yggdrasil
systemctl restart yggdrasil

exit 0
EOF
cat > /tmp/$PKGNAME/debian/prerm << EOF
#!/bin/sh
if command -v systemctl >/dev/null; then
  if systemctl is-active --quiet yggdrasil; then
    systemctl stop yggdrasil || true
  fi
  systemctl disable yggdrasil || true
fi
EOF

cp yggdrasil /tmp/$PKGNAME/usr/bin/
cp yggdrasilctl /tmp/$PKGNAME/usr/bin/
cp contrib/systemd/yggdrasil-default-config.service.debian /tmp/$PKGNAME/lib/systemd/system/yggdrasil-default-config.service
cp contrib/systemd/yggdrasil.service.debian /tmp/$PKGNAME/lib/systemd/system/yggdrasil.service

tar --no-xattrs -czvf /tmp/$PKGNAME/data.tar.gz -C /tmp/$PKGNAME/ \
  usr/bin/yggdrasil usr/bin/yggdrasilctl \
  lib/systemd/system/yggdrasil.service \
  lib/systemd/system/yggdrasil-default-config.service
tar --no-xattrs -czvf /tmp/$PKGNAME/control.tar.gz -C /tmp/$PKGNAME/debian .
echo 2.0 > /tmp/$PKGNAME/debian-binary

ar -r $PKGFILE \
  /tmp/$PKGNAME/debian-binary \
  /tmp/$PKGNAME/control.tar.gz \
  /tmp/$PKGNAME/data.tar.gz

rm -rf /tmp/$PKGNAME

#!/bin/bash

_old_default=$CIS_DEFAULT_COMM
export YGG_DEBUG="INFO"
export YGG_NAMESPACE="timed_pipe"
export PIPE_MSG_COUNT=50
export PIPE_MSG_SIZE=10
export YGG_DEFAULT_COMM="IPCComm"
# export YGG_DEFAULT_COMM="ZMQComm"

yaml= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -a | --all )
	echo "Running Python and C integration"
	yaml='timed_pipe_all.yml'
	;;
    -p | --python )
	echo "Running Python"
	yaml='timed_pipe_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml='timed_pipe_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml='timed_pipe_c.yml'
	;;
    --cpp | --g++)
	echo "Running C++"
	yaml='timed_pipe_cpp.yml'
	;;
    -r | -R )
	echo "Running R"
	yaml='timed_pipe_r.yml'
	;;
    * )
	echo "Running ", $1
	yaml=$1
	;;
esac

time yggrun $yaml

# outfile="${TMPDIR}output_timed_pipe.txt"
# cat $outfile
export YGG_DEFAULT_COMM=$_old_default

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="timesync2"
export TIMESYNC_TSTEP_A=7  # hr (20 for short run)
export TIMESYNC_TSTEP_B=1  # days (3 for short run)

yaml= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -p | --python )
	echo "Running Python"
	yaml='timesync2_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml='timesync2_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml='timesync2_c.yml'
	;;
    --cpp | --g++ )
	echo "Running C++"
	yaml='timesync2_cpp.yml'
	;;
    -r | -R )
	echo "Running R"
	yaml='timesync2_r.yml'
	;;
esac

yggrun $yaml

outfileA="${TMPDIR}modelA_output.txt"
outfileB="${TMPDIR}modelB_output.txt"
echo $outfileA
cat $outfileA
echo $outfileB
cat $outfileB
python ../timesync1/plot_timesync.py $outfileA $outfileB $YGG_NAMESPACE

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="gs_lesson4"

yaml= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -p | --python )
	echo "Running Python"
	yaml='gs_lesson4_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml='gs_lesson4_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml='gs_lesson4_c.yml'
	;;
    --cpp | --g++)
	echo "Running C++"
	yaml='gs_lesson4_cpp.yml'
	;;
    -r | -R)
	echo "Running R"
	yaml='gs_lesson4_r.yml'
	;;
    --make )
	echo "Running Make"
	cp ./src/Makefile_linux ./src/Makefile
	yaml='gs_lesson4_make.yml'
	;;
    --cmake )
	echo "Running CMake"
	yaml='gs_lesson4_cmake.yml'
	;;
esac

yggrun $yaml

#!/bin/bash
set -e
source /opt/conda/etc/profile.d/conda.sh
conda activate CiS2021-hackathon-environment
jupyter notebook --no-browser --ip=0.0.0.0 --NotebookApp.token='' --NotebookApp.password='' --allow-root

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="gs_lesson3"

yaml= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -p | --python )
	echo "Running Python"
	yaml='gs_lesson3_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml='gs_lesson3_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml='gs_lesson3_c.yml'
	;;
    --cpp | --g++)
	echo "Running C++"
	yaml='gs_lesson3_cpp.yml'
	;;
    -r | -R)
	echo "Running R"
	yaml='gs_lesson3_r.yml'
	;;
esac

yggrun $yaml

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="osr"

yaml= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -p | --python )
	echo "Running Python"
	yaml='osr_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml='osr_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml='osr_c.yml'
	;;
    --cpp | --g++ )
	echo "Running C++"
	yaml='osr_cpp.yml'
	;;
    -r | -R )
	echo "Running R"
	yaml='osr_r.yml'
	;;
    -f | --fortran )
	echo "Running Fortran"
	yaml='osr_fortran.yml'
	;;
esac

yggrun $yaml

outfile="${TMPDIR}other_model_output.txt"
echo $outfile
cat $outfile

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="formatted_io7"

yaml= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -p | --python )
	echo "Running Python"
	yaml='formatted_io7_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml='formatted_io7_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml='formatted_io7_c.yml'
	;;
    --cpp | --g++)
	echo "Running C++"
	yaml='formatted_io7_cpp.yml'
	;;
    -r | -R)
	echo "Running R"
	yaml='formatted_io7_r.yml'
	;;
    -f | --fortran )
	echo "Running Fortran"
	yaml='formatted_io7_fortran.yml'
	;;
esac

yggrun $yaml

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="rpc_lesson2"
export FIB_ITERATIONS="3"

yaml1= 
yaml2= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -p | --python )
	echo "Running Python"
	yaml1='server_python.yml'
	yaml2='client_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml1='server_python.yml'
	yaml2='client_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml1='server_python.yml'
	yaml2='client_c.yml'
	;;
    --cpp | --g++ )
	echo "Running C++"
	yaml1='server_python.yml'
	yaml2='client_cpp.yml'
	;;
    -r | -R )
	echo "Running R"
	yaml1='server_python.yml'
	yaml2='client_r.yml'
	;;
esac

yggrun $yaml1 $yaml2

outfile1="${TMPDIR}client_output1.txt"
outfile2="${TMPDIR}client_output2.txt"
cat $outfile1
cat $outfile2

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="model_function2"

yaml= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -p | --python )
	echo "Running Python"
	yaml='model_function2_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml='model_function2_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml='model_function2_c.yml'
	;;
    --cpp | --g++)
	echo "Running C++"
	yaml='model_function2_cpp.yml'
	;;
    --make )
	echo "Running Make"
	cp ./src/Makefile_linux ./src/Makefile
	yaml='model_function2_make.yml'
	;;
    --cmake )
	echo "Running CMake"
	yaml='model_function2_cmake.yml'
	;;
    -R | -r | --R | --r )
	echo "Running R"
	yaml='model_function2_r.yml'
	;;
    -f | --fortran )
	echo "Running Fortran"
	yaml='model_function2_fortran.yml'
	;;
esac

yggrun $yaml $2

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="rpc_lesson3b"

yaml1= 
yaml2= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -p | --python )
	echo "Running Python"
	yaml1='server_python.yml'
	yaml2='client_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml1='server_python.yml'
	yaml2='client_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml1='server_python.yml'
	yaml2='client_c.yml'
	;;
    --cpp | --g++)
	echo "Running C++"
	yaml1='server_python.yml'
	yaml2='client_cpp.yml'
	;;
    -R | -r | --R | --r )
	echo "Running R"
	yaml1='server_python.yml'
	yaml2='client_r.yml'
	;;
    -f | --fortran )
	echo "Running Fortran"
	yaml1='server_python.yml'
	yaml2='client_fortran.yml'
	;;
esac

yggrun $yaml1 $yaml2

outfile="${TMPDIR}client_output.txt"
cat $outfile
